package net.zfsy.logic.base.helper;

package ..deTemp.1741362825106;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.lang.Assert;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.text.CharSequenceUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSONArray;
import com.google.common.base.Joiner;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.google.common.collect.Sets;
import com.jfinal.aop.Before;
import com.jfinal.kit.JsonKit;
import com.jfinal.kit.PathKit;
import com.jfinal.kit.StringKit;
import com.jfinal.plugin.activerecord.ActiveRecordException;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.DbUtil;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.plugin.activerecord.Record;
import com.jfinal.plugin.activerecord.tx.Tx;
import com.jfinal.plugin.ehcache.CacheKit;
import com.jfinal.plugin.sql.SqlSplitUtils;
import com.jfinal.plugin.sql.enums.MachineCategoriesEnum;
import com.jfinal.plugin.sql.enums.SqlLike;
import java.io.File;
import java.nio.charset.StandardCharsets;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.Random;
import java.util.Set;
import java.util.stream.Collectors;
import net.sf.json.JSONObject;
import net.zfsy.core.rpc.RepRpcStart;
import net.zfsy.custom.exception.CustomException;
import net.zfsy.logic.base.helper.AppHelp;
import net.zfsy.logic.base.helper.AuthoriseCompute;
import net.zfsy.logic.base.helper.AuthoriseHelp;
import net.zfsy.logic.base.helper.AutoUpgradeHelp;
import net.zfsy.logic.base.helper.ClearCacheMap;
import net.zfsy.logic.base.helper.HealthStateHelp;
import net.zfsy.logic.base.helper.HostAsyncHandleHelp;
import net.zfsy.logic.base.helper.HostCacheHelp;
import net.zfsy.logic.base.helper.HostOnlineHelp;
import net.zfsy.logic.base.helper.LogHelp;
import net.zfsy.logic.base.helper.ManIfestHelp;
import net.zfsy.logic.base.helper.OrgAuthHelp;
import net.zfsy.logic.base.helper.OrgCfgHelp;
import net.zfsy.logic.base.helper.OrgaHelp;
import net.zfsy.logic.base.helper.PermissionHelp;
import net.zfsy.logic.base.helper.PolicyHelp;
import net.zfsy.logic.base.helper.SqlCascadSiteHelp;
import net.zfsy.logic.base.helper.SysParamHelp;
import net.zfsy.logic.base.helper.UserHelp;
import net.zfsy.logic.base.interceptor.NotifyInterceptor;
import net.zfsy.logic.base.model.host.HostAuthDetailVo;
import net.zfsy.logic.base.model.host.HostAuthVo;
import net.zfsy.logic.base.model.host.HostDetailVo;
import net.zfsy.logic.base.rpc.Notify;
import net.zfsy.logic.base.rpc.cache.RpcCacheHelp;
import net.zfsy.logic.base.start.BaseGlobal;
import net.zfsy.logic.base.util.LogicUtil;
import net.zfsy.logic.base.util.SMS4Util;
import net.zfsy.logic.base.util.SysdataTool;
import net.zfsy.logic.base.util.ZipUtil;
import net.zfsy.logic.db.adapter.DbDialectUtil;
import net.zfsy.logic.thread.OtherSysHostMachtThread;
import net.zfsy.logic.util.AES;
import net.zfsy.logic.util.FileUtil;
import net.zfsy.logic.util.JsonUtils;
import net.zfsy.logic.util.SysLogicUtil;
import net.zfsy.logic.util.SysParamUtil;
import net.zfsy.logic.util.ThreadLocalMap;
import net.zfsy.logic.util.YqPropertiesUtil;
import net.zfsy.logic.util.ZFHttpClient;
import net.zfsy.redis.RedisClient;
import net.zfsy.redis.lock.RedisLockFactory;
import net.zfsy.thread.BusinessThreadPoolFactory;
import org.apache.commons.lang3.StringUtils;
import org.apache.log4j.Logger;
import org.redisson.api.RLock;

public class HostHelp {
  private static final Logger logger = Logger.getLogger(net.zfsy.logic.base.helper.HostHelp.class);
  
  static Map<String, String> getUserByHostLevel = new HashMap<>();
  
  public static final String HOST_CACHE_NAME = "tb_base_host";
  
  public static final String HOST_CACHE_THREAD_POOL_NAME = "host.hostIdCatch";
  
  static {
    getUserByHostLevel.put("5", "1");
    getUserByHostLevel.put("0", "5");
    getUserByHostLevel.put("4", "2");
    getUserByHostLevel.put("3", "2");
    getUserByHostLevel.put("2", "3");
    getUserByHostLevel.put("1", "4");
  }
  
  public static Page<Record> sysHostPage(Map paramMap) {
    SysParamUtil sysParamUtil = new SysParamUtil(paramMap);
    List<Object> param = new ArrayList();
    StringBuilder where = new StringBuilder(" where ( 1=1 ");
    StringBuilder sortBuffer = new StringBuilder(" order by ");
    String id = sysParamUtil.getPara("id");
    if (StringKit.notBlank(id)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`id`=? "));
      param.add(id);
    } 
    String ids = sysParamUtil.getPara("ids");
    if (StringKit.notBlank(ids) && !ids.contains("'")) {
      ids = SysLogicUtil.filterParam(ids);
      String[] idArr = ids.split(",");
      StringBuilder idBuff = new StringBuilder();
      for (String hostId : idArr) {
        idBuff.append("'");
        idBuff.append(hostId);
        idBuff.append("'");
        idBuff.append(",");
      } 
      if (idBuff.length() > 0) {
        ids = idBuff.toString();
        ids = ids.substring(0, ids.length() - 1);
        where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`id` in (")).append(ids).append(")");
      } 
    } 
    String code = sysParamUtil.getPara("code");
    if (StringKit.notBlank(code)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`code`=? "));
      param.add(code);
    } 
    String feature = sysParamUtil.getPara("feature");
    if (StringKit.notBlank(feature)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`feature` like ? "));
      param.add("%" + feature + "%");
    } 
    String lastDate = sysParamUtil.getPara("last_online_time", "");
    if (StringKit.notBlank(lastDate)) {
      int addtime = 0 - LogicUtil.parseIntSafe(lastDate) + 1;
      Calendar calendar = Calendar.getInstance();
      calendar.setTime(new Date());
      calendar.add(5, addtime);
      SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`last_online_date` <?"));
      param.add(Timestamp.valueOf(df.format(calendar.getTime())));
    } 
    String begDate = sysParamUtil.getPara("online_beg_date", "");
    String endDate = sysParamUtil.getPara("online_end_date", "");
    if (StringKit.notBlank(begDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`last_online_date` >=?"));
      param.add(Timestamp.valueOf(begDate));
    } 
    if (StringKit.notBlank(endDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`last_online_date` <?"));
      param.add(Timestamp.valueOf(endDate));
    } 
    String unbegDate = sysParamUtil.getPara("un_beg_date", "");
    String unendDate = sysParamUtil.getPara("un_end_date", "");
    if (StringKit.notBlank(unbegDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`unreg_date` >=?"));
      param.add(Timestamp.valueOf(unbegDate));
    } 
    if (StringKit.notBlank(unendDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`unreg_date` <?"));
      param.add(Timestamp.valueOf(unendDate));
    } 
    String regBegDate = sysParamUtil.getPara("active_beg_date", "");
    String regEndDate = sysParamUtil.getPara("active_end_date", "");
    if (StringKit.notBlank(regBegDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`active_date` >=?"));
      param.add(Timestamp.valueOf(regBegDate));
    } 
    if (StringKit.notBlank(regEndDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`active_date` <?"));
      param.add(Timestamp.valueOf(regEndDate));
    } 
    String ipRange = sysParamUtil.getPara("ip_range");
    boolean isIps = true;
    StringBuffer ipAdressRange = new StringBuffer();
    if (StringKit.notBlank(ipRange)) {
      String[] ipRanges = ipRange.split(";");
      for (String ipdress : ipRanges) {
        String[] ips = ipdress.split("-");
        if (ips.length > 1)
          if (isIps) {
            ipAdressRange.append(" and ( " + DbDialectUtil.getDbFunFactory().ipScope("host.`ip`", ips[0], ips[1], "host.`ipval`"));
            isIps = false;
          } else {
            ipAdressRange.append(" or " + DbDialectUtil.getDbFunFactory().ipScope("host.`ip`", ips[0], ips[1], "host.`ipval`"));
          }  
      } 
      if (ipAdressRange.toString().length() > 1)
        ipAdressRange.append(" ) "); 
      where.append(ipAdressRange.toString());
    } 
    String userId = sysParamUtil.getPara("user_id");
    if (StringKit.notBlank(userId)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`user_id`=? "));
      param.add(userId);
    } 
    String userName = sysParamUtil.getPara("user_name");
    if (StringKit.notBlank(userName)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and u.`name` like ? "));
      param.add("%" + userName + "%");
    } 
    String installCode = sysParamUtil.getPara("install_code");
    if (StringKit.notBlank(installCode)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`install_code` =?"));
      param.add(installCode);
    } 
    String name = sysParamUtil.getPara("name");
    if (StringKit.notBlank(name)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`name` like ? "));
      param.add("%" + name + "%");
    } 
    String mac = sysParamUtil.getPara("mac");
    if (StringKit.notBlank(mac)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`mac` like ? "));
      param.add("%" + mac + "%");
    } 
    String ip = sysParamUtil.getPara("ip");
    if (StringKit.notBlank(ip)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`ip` like ? "));
      param.add("%" + ip + "%");
    } 
    String host_group_id = sysParamUtil.getPara("host_ip_group");
    if (StringKit.notBlank(host_group_id)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`ip` like ? "));
      param.add("%" + host_group_id + "%");
    } 
    String pSyncState = sysParamUtil.getPara("p_sync_state");
    if (StringKit.notBlank(pSyncState)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`p_sync_state`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(pSyncState)));
    } 
    String installSeclevel = sysParamUtil.getPara("install_seclevel");
    if (StringKit.notBlank(installSeclevel)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`sec_level`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(installSeclevel)));
    } 
    String syncState = sysParamUtil.getPara("sync_state");
    if (StringKit.notBlank(syncState)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`sync_state`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(syncState)));
    } 
    String onlineState = sysParamUtil.getPara("online_state");
    if (StringKit.notBlank(onlineState))
      if ("1".equals(onlineState)) {
        where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`online_state` =1"));
      } else {
        where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`online_state` is null "));
      }  
    String installState = sysParamUtil.getPara("install_state");
    if (StringKit.notBlank(installState)) {
      installState = SysLogicUtil.filterParam(installState);
      String[] installStates = installState.split(",");
      where.append("and ");
      int i = 0;
      for (String string : installStates) {
        String state = "6".equals(string) ? "5" : string;
        if (i == 0) {
          where.append(DbDialectUtil.getDbRuleFactory().dbField("( host.`install_state`=?  "));
        } else {
          where.append(DbDialectUtil.getDbRuleFactory().dbField(" or host.`install_state`=?  "));
        } 
        i++;
        param.add(Integer.valueOf(LogicUtil.parseIntSafe(state)));
      } 
      where.append(")");
      String uninstallState = sysParamUtil.getPara("unInstall", "0");
      if ("5".equals(installState) && "1".equals(uninstallState))
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`remark` !='已卸载' ")); 
      if ("6".equals(installState))
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`remark` ='已卸载' ")); 
    } 
    String forbidInstallState = sysParamUtil.getPara("forbid_install_state");
    if (StringKit.notBlank(forbidInstallState)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`install_state`<? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(forbidInstallState)));
    } 
    String type = sysParamUtil.getPara("type");
    if (StringKit.notBlank(type)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`type`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(type)));
    } 
    String orgId = sysParamUtil.getPara("org_id");
    if (StringKit.notBlank(orgId)) {
      orgId = SysLogicUtil.filterParam(orgId);
      String orgs = LogicUtil.getOrgChilds(orgId);
      orgs = orgs.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id` in (") + orgs + ") ");
    } 
    String orgsId = sysParamUtil.getPara("orgs_id");
    if (StringKit.notBlank(orgsId)) {
      orgsId = SysLogicUtil.filterParam(orgsId);
      orgsId = orgsId.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id` in ('") + orgsId + "')");
    } 
    String accNameRange = ThreadLocalMap.getOrgpermiss();
    if (StringKit.notBlank(accNameRange)) {
      accNameRange = SysLogicUtil.filterParam(accNameRange);
      accNameRange = LogicUtil.getAccRange(accNameRange);
      accNameRange = accNameRange.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and  org.`id`  in ('") + accNameRange + "')");
    } 
    String gid = sysParamUtil.getPara("group_id");
    if (StringKit.notBlank(gid)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (select `obj_id` from tb_base_group_bind where `group_id`=?) "));
      param.add(gid);
    } 
    String groupIds = sysParamUtil.getPara("groups_id");
    if (StringKit.notBlank(groupIds)) {
      groupIds = SysLogicUtil.filterParam(groupIds);
      groupIds = groupIds.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (select `obj_id` from tb_base_group_bind where `group_id` in(") + "'" + groupIds + "'))  ");
    } 
    String removeHost = sysParamUtil.getPara("remove_host");
    if (StringKit.notBlank(removeHost)) {
      removeHost = SysLogicUtil.filterParam(removeHost);
      removeHost = removeHost.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` NOT IN (SELECT `id` FROM tb_base_host WHERE `id` in(") + "'" + removeHost + "')) ");
    } 
    String sort = sysParamUtil.getPara("sort");
    String order = sysParamUtil.getPara("order", " desc ");
    String unreg_page = sysParamUtil.getPara("unreg_page");
    if (StringKit.notBlank(sort)) {
      sortBuffer.append(sort).append(" ").append(order).append(DbDialectUtil.getDbRuleFactory().dbField(" ,`feature` desc "));
    } else {
      if (unreg_page != null) {
        if ("1".equals(unreg_page))
          sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" `unreg_date` ")); 
      } else {
        sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" `reg_date` "));
      } 
      sortBuffer.append(order);
      sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" ,`feature` desc "));
    } 
    where.append(" )");
    String additHost = sysParamUtil.getPara("addit_host");
    if (StringKit.notBlank(additHost)) {
      additHost = additHost.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" OR host.`id`  IN (SELECT `id` FROM tb_base_host WHERE `id` in(") + "'" + additHost + "')) ");
    } 
    String sql = DbDialectUtil.getDbRuleFactory().dbField("select host.`source`, host.`feature`,host.`node_id`,host.`install_code`,host.`id`,host.`code`,host.`room_num`,host.`name`,host.`type`,host.`install_state`,case when host.`online_state` is null then 0 else host.`online_state` end as `online_state`,host.`sync_date`,host.`sync_state`,host.`p_sync_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`unreg_date`,host.`sync_date`,host.`last_modify_date`,host.`host_version`,host.`ext`,host.`user_id`,host.`create_date`,u.`name` AS `user_name`,org.`id` AS `org_id`,org.`region` AS `region` ,org.`name` AS `orga_name`, dict_install.`dict_name` AS `install_state_name`,dict_sec_level.`dict_name` AS `dict_sec_level_name`,host.`remark` , dict_sys.`dict_name` AS `oper_name` ,u.`work_num` ");
    String sqlExceptSelect = DbDialectUtil.getDbRuleFactory().dbField(" FROM tb_base_source_host host    LEFT JOIN tb_base_user  u ON host.`user_id`=u.`id` LEFT JOIN tb_base_org  org ON org.`id`=u.`org_id` LEFT JOIN (SELECT `dict_id`,`dict_name` FROM  tb_base_dict WHERE  `dict_type`='3') dict_install ON host.`install_state`=dict_install.`dict_id`  LEFT JOIN (SELECT `dict_id`,`dict_name` FROM  tb_base_dict WHERE  `dict_type`='1') dict_sec_level ON host.`sec_level`=dict_sec_level.`dict_id` LEFT JOIN (SELECT `dict_id`,`dict_name` FROM  tb_base_dict WHERE  `dict_type`='7') dict_sys ON host.`oper_sys`=dict_sys.`dict_id` ") + where.toString() + sortBuffer.toString();
    int pagePosition = sysParamUtil.getParaToInt("page", Integer.valueOf(1)).intValue();
    int pageSize = sysParamUtil.getParaToInt("rows", Integer.valueOf(10)).intValue();
    if (pagePosition == 0 && pageSize == 0) {
      List<Record> recordList = DbUtil.find(sql + sqlExceptSelect, param.toArray());
      Page<Record> page1 = new Page(recordList, 0, 0, 0, 0);
      LogicUtil.getSysOtherInfo(page1.getList(), "org_id", "orga_name");
      return page1;
    } 
    Page<Record> page = DbUtil.paginate(pagePosition, pageSize, sql, sqlExceptSelect, param.toArray());
    LogicUtil.getSysOtherInfo(page.getList(), "org_id", "orga_name");
    return page;
  }
  
  private static List<Record> filterHostListRecordByParam(SysParamUtil sysParamUtil, List<Record> recordList) {
    if (recordList.size() < 1)
      return recordList; 
    String[] hostIdsParams = (String[])recordList.stream().map(r -> r.getStr("id")).toArray(x$0 -> new String[x$0]);
    List<Record> productListRecord = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField("select host_id , products from tb_base_host_extend where host_id in (" + (String)recordList.stream().map(record -> "?").collect(Collectors.joining(",")) + ")"), (Object[])hostIdsParams);
    HashMap<Object, Object> productListMap = new HashMap<>();
    productListRecord.forEach(p -> productListMap.putIfAbsent(p.getStr("host_id"), p.getStr("products")));
    String[] orgIdArr = (String[])recordList.stream().map(r -> r.getStr("org_id")).filter(CharSequenceUtil::isNotEmpty).toArray(x$0 -> new String[x$0]);
    HashMap<String, String> redisOrgNameMap = new HashMap<>();
    if (ObjectUtil.isNotNull(orgIdArr) && orgIdArr.length > 0) {
      List<String> redisOrgNameValus = RedisClient.getJedis().hmget("ITX:CACHE:ORG_NAME_MAP", orgIdArr);
      for (int i = 0; i < orgIdArr.length; i++)
        redisOrgNameMap.put(orgIdArr[i], Optional.<String>ofNullable(redisOrgNameValus.get(i)).orElse("")); 
    } 
    recordList.forEach(r -> {
          r.set("products", productListMap.get(r.get("id")));
          String orgId = r.getStr("org_id");
          if (StringKit.notBlank(orgId)) {
            r.set("org_id", orgId);
            String orgRedisData = (String)redisOrgNameMap.get(orgId);
            if (StringKit.notBlank(orgRedisData)) {
              JSONObject jsonObject = JSONObject.fromObject(orgRedisData);
              Object region = jsonObject.opt("region");
              r.set("region", (region instanceof net.sf.json.JSONNull) ? "" : region);
              Object orgaName = jsonObject.opt("name");
              r.set("orga_name", (orgaName instanceof net.sf.json.JSONNull) ? "" : orgaName);
            } 
          } 
          r.set("is_deb_name", MachineCategoriesEnum.getValueByKey(r.getInt("is_deb")));
          r.set("is_deb_soft", Objects.equals(r.getInt("is_deb"), MachineCategoriesEnum.DEB3.getKey()) ? "是" : "否");
          Integer hostOnlineState = (Integer)r.get("host_online_state");
          r.set("online_state", hostOnlineState);
        });
    return recordList;
  }
  
  public static Page<Record> showAllHostList(Map paramMap) {
    boolean isUpdateCache = false;
    SysParamUtil sysParamUtil = new SysParamUtil(paramMap);
    boolean cascadeDataFlag = sysParamUtil.getParaToBoolean("cascade_data", Boolean.valueOf(false)).booleanValue();
    if (isHideHost(cascadeDataFlag))
      return new Page(Collections.emptyList(), 0, 0, 0, 0); 
    String sql = DbDialectUtil.getDbRuleFactory().dbField("select  host_online.`host_online_state` , host.`feature`,host.`node_id`,host.`install_code`,host.`id`,host.`code`,host.`room_num`,host.`name`,host.`type`,host.`install_state`,host.`type_new`,host.`fixed_no`,host.`host_class`,host.`eq_use`,  host.`is_deb`, host.`sync_date`,host.`sync_state`,host.`p_sync_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`unreg_date`,host.`sync_date`,host.`last_modify_date`,host.`host_version`,host.`ext`,host.`user_id`,host.`create_date`,host.`remark` , host.`sec_level`, host.`oper_sys` ,u.`work_num`,u.`tel_num` AS `tel_num`,u.`name` AS `user_name`, u.`org_id` ");
    if (!cascadeDataFlag)
      sql = sql + DbDialectUtil.getDbRuleFactory().dbField(",host_online.`last_online_date`,host.`osversioninfo`"); 
    Map<String, Object> sqlMap = getHostListSqlByParam(sysParamUtil, isUpdateCache);
    String sqlExceptSelect = DbDialectUtil.getDbRuleFactory().dbField(" FROM tb_base_host host  LEFT JOIN tb_base_host_online host_online ON host.`id`=host_online.`host_id`LEFT JOIN tb_base_user u ON host.`user_id` = u.`id`LEFT JOIN tb_base_org  org ON org.`id`=u.`org_id` ") + MapUtil.getStr(sqlMap, "where") + MapUtil.getStr(sqlMap, "sort");
    int pagePosition = sysParamUtil.getParaToInt("page", Integer.valueOf(1)).intValue();
    int pageSize = sysParamUtil.getParaToInt("rows", Integer.valueOf(50000)).intValue();
    String isCheckFeature = sysParamUtil.getPara("is_check_feature", "0");
    String isCheckMacsn = sysParamUtil.getPara("is_check_macsn", "0");
    String checkUncheck = sysParamUtil.getPara("check_uncheck", "0");
    Page<Record> page = null;
    if ("1".equals(isCheckFeature) || "1".equals(isCheckMacsn)) {
      List<Record> recordList = DbUtil.findByCache(sql + sqlExceptSelect, isUpdateCache, "online_time_current", ((List)MapUtil.get(sqlMap, "param", List.class)).toArray());
      recordList = filterHostRecord(isCheckFeature, isCheckMacsn, recordList);
      filterHostListRecordByParam(sysParamUtil, recordList);
      int count = recordList.size();
      if (pagePosition == 0 && pageSize == 0) {
        page = new Page(recordList, 0, 0, 0, 0);
      } else if (count == 0) {
        page = new Page(recordList, pagePosition, pageSize, 0, 0);
      } else {
        int pageCount = count % pageSize;
        if (pageCount > 0)
          pageCount = count / pageSize + 1; 
        int begin = (pagePosition - 1) * pageSize;
        int end = begin + pageSize;
        if (recordList.size() < end)
          end = recordList.size(); 
        List<Record> newRecordList = new ArrayList<>();
        for (int i = begin; i < end; i++)
          newRecordList.add(recordList.get(i)); 
        page = new Page(newRecordList, pagePosition, pageSize, pageCount, count);
      } 
    } else {
      List<Record> recordList = null;
      if (pagePosition == 0 && pageSize == 0) {
        recordList = DbUtil.findByCache(sql + sqlExceptSelect, isUpdateCache, "online_time_current", ((List)MapUtil.get(sqlMap, "param", List.class)).toArray());
        filterHostListRecordByParam(sysParamUtil, recordList);
        page = new Page(recordList, 0, 0, 0, 0);
      } else {
        page = DbUtil.paginateByCache("tb_base_host", pagePosition, pageSize, sql, sqlExceptSelect, ((List)MapUtil.get(sqlMap, "param", List.class)).toArray());
        filterHostListRecordByParam(sysParamUtil, page.getList());
      } 
    } 
    loadDictInfo(page.getList());
    LogicUtil.getOtherInfo(page.getList(), "org_id", "orga_name", checkUncheck);
    page.getList().forEach(hostRecord -> {
          String nodeId = hostRecord.getStr("node_id");
          hostRecord.set("is_current_node_data", Integer.valueOf(checkIsCurrentNodeData(nodeId) ? 1 : 0));
        });
    return page;
  }
  
  public static Page<Record> showAll(Map paramMap) {
    boolean isUpdateCache = false;
    SysParamUtil sysParamUtil = new SysParamUtil(paramMap);
    boolean cascadeDataFlag = sysParamUtil.getParaToBoolean("cascade_data", Boolean.valueOf(false)).booleanValue();
    if (isHideHost(cascadeDataFlag))
      return new Page(Collections.emptyList(), 0, 0, 0, 0); 
    String sql = DbDialectUtil.getDbRuleFactory().dbField("select  products.`products` as `products`,host.`feature`,host.`node_id`,host.`install_code`,host.`id`,host.`code`,host.`room_num`,host.`name`,host.`type`,host.`install_state`,host.`type_new`,host.`fixed_no`,host.`host_class`,host.`eq_use`,case when host_online.`host_online_state` is null then 0 else host_online.`host_online_state` end as `online_state`,host_online.`host_online_state` as `host_online_state`,case when `is_deb`=0 then '普通机器' when `is_deb`=1 then '二期专用机' when `is_deb`=2 then '三期专用机' when `is_deb`=4 then '四期专用机' when `is_deb`=3 then '非安全类软件' else '普通机器' end as `is_deb_name`,case when `is_deb`=3 then '是'  else '否' end as `is_deb_soft`,  host.`sync_date`,host.`sync_state`,host.`p_sync_state`,host.`ip`, host.`sid`, host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`unreg_date`,host.`sync_date`,host.`last_modify_date`,host.`host_version`,host.`ext`,host.`user_id`,host.`create_date`,u.`name` AS `user_name`,org.`id` AS `org_id`,org.`region` AS `region` ,org.`name` AS `orga_name`,host.`remark`  ,u.`work_num` ,u.`tel_num`, host.`sec_level`, host.`oper_sys`, host.`mac` ");
    if (!cascadeDataFlag)
      sql = sql + DbDialectUtil.getDbRuleFactory().dbField(",host_online.`last_online_date`,host.`osversioninfo`"); 
    Map<String, Object> sqlMap = getHostSql(sysParamUtil, isUpdateCache);
    String sqlExceptSelect = DbDialectUtil.getDbRuleFactory().dbField(" FROM tb_base_host host  LEFT JOIN tb_base_host_online host_online ON host.`id`=host_online.`host_id`  LEFT JOIN tb_base_user  u ON host.`user_id`=u.`id` LEFT JOIN tb_base_org  org ON org.`id`=u.`org_id` LEFT JOIN tb_base_host_extend products on host.`id`=products.`host_id` ") + MapUtil.getStr(sqlMap, "where") + MapUtil.getStr(sqlMap, "sort");
    int pagePosition = sysParamUtil.getParaToInt("page", Integer.valueOf(1)).intValue();
    int pageSize = sysParamUtil.getParaToInt("rows", Integer.valueOf(50000)).intValue();
    String isCheckFeature = sysParamUtil.getPara("is_check_feature", "0");
    String is_check_macsn = sysParamUtil.getPara("is_check_macsn", "0");
    String checkUncheck = sysParamUtil.getPara("check_uncheck", "0");
    if (pagePosition == 0 && pageSize == 0) {
      List<Record> recordList = DbUtil.findByCache(sql + sqlExceptSelect, isUpdateCache, "online_time_current", ((List)MapUtil.get(sqlMap, "param", List.class)).toArray());
      if ("1".equals(isCheckFeature) || "1".equals(is_check_macsn))
        recordList = filterHostRecord(isCheckFeature, is_check_macsn, recordList); 
      Page<Record> page1 = new Page(recordList, 0, 0, 0, 0);
      loadDictInfo(page1.getList());
      LogicUtil.getOtherInfo(page1.getList(), "org_id", "orga_name", checkUncheck);
      SysLogicUtil.setIsCurrentNodeData(page1);
      return page1;
    } 
    Page<Record> page = null;
    if ("1".equals(isCheckFeature) || "1".equals(is_check_macsn)) {
      List<Record> recordList = DbUtil.findByCache(sql + sqlExceptSelect, isUpdateCache, "online_time_current", ((List)MapUtil.get(sqlMap, "param", List.class)).toArray());
      recordList = filterHostRecord(isCheckFeature, is_check_macsn, recordList);
      int count = recordList.size();
      if (count == 0) {
        page = new Page(recordList, pagePosition, pageSize, 0, 0);
      } else {
        int pageCount = count % pageSize;
        if (pageCount > 0)
          pageCount = count / pageSize + 1; 
        int begin = (pagePosition - 1) * pageSize;
        int end = begin + pageSize;
        if (recordList.size() < end)
          end = recordList.size(); 
        List<Record> newRecordList = new ArrayList<>();
        for (int i = begin; i < end; i++)
          newRecordList.add(recordList.get(i)); 
        page = new Page(newRecordList, pagePosition, pageSize, pageCount, count);
      } 
    } else {
      page = DbUtil.paginateByCache("tb_base_host", pagePosition, pageSize, sql, sqlExceptSelect, ((List)MapUtil.get(sqlMap, "param", List.class)).toArray());
    } 
    loadDictInfo(page.getList());
    LogicUtil.getOtherInfo(page.getList(), "org_id", "orga_name", checkUncheck);
    SysLogicUtil.setIsCurrentNodeData(page);
    return page;
  }
  
  private static void loadDictInfo(List<Record> list) {
    Map<String, String> map = BaseGlobal.getRedisorgcfgmap();
    Map<String, String> redistwoorgcfgmap = BaseGlobal.getRedistwoorgcfgmap();
    Map<String, Record> orgNameMap = BaseGlobal.getOrgNameMap();
    for (Record host : list) {
      host.set("install_state_name", BaseGlobal.dictInstallMap.get(host.get("install_state") + ""));
      host.set("dict_sec_level_name", BaseGlobal.dictSecLevelMap.get(host.get("sec_level") + ""));
      host.set("oper_name", BaseGlobal.dictOperMap.get(host.get("oper_sys") + ""));
      String orgstatus = OrgCfgHelp.getOrgCfgStatus(String.valueOf(host.getObject("org_id")), map, redistwoorgcfgmap);
      host.set("org_status", orgstatus);
      String path = "";
      try {
        Object orgId = host.get("org_id");
        if (orgId != null) {
          Object obj = orgNameMap.get(orgId);
          if (null != obj)
            path = (String)((Record)orgNameMap.get(orgId)).get("org_path"); 
        } 
      } catch (Exception e) {
        e.printStackTrace();
      } 
      if (StringKit.isBlank(path)) {
        Record nodeRecord = OrgaHelp.currentNode();
        path = nodeRecord.getStr("name");
      } 
      host.set("org_full_name", path);
    } 
  }
  
  public static Page<Record> showAllAuth(Map paramMap) {
    boolean isUpdateCache = false;
    SysParamUtil sysParamUtil = new SysParamUtil(paramMap);
    List<Object> param = new ArrayList();
    StringBuffer where = new StringBuffer(" where ( 1=1 ");
    StringBuffer sortBuffer = new StringBuffer(" order by ");
    boolean cascade_data = sysParamUtil.getParaToBoolean("cascade_data", Boolean.valueOf(false)).booleanValue();
    boolean isHide = false;
    try {
      Record record = SysParamHelp.show("F8E5DB84-DF81-429B-96DE-9954DC8A4000");
      if (record != null && "1".equals(record.getStr("param_value")))
        isHide = true; 
    } catch (Exception exception) {}
    if (cascade_data && isHide) {
      List<Record> recordList = new ArrayList<>();
      Page<Record> page1 = new Page(recordList, 0, 0, 0, 0);
      return page1;
    } 
    String id = sysParamUtil.getPara("id");
    if (StringKit.notBlank(id)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id`=? "));
      param.add(id);
    } 
    String ids = sysParamUtil.getPara("ids");
    if (StringKit.notBlank(ids) && ids.indexOf("'") < 0) {
      ids = SysLogicUtil.filterParam(ids);
      String[] idArr = ids.split(",");
      StringBuffer idBuff = new StringBuffer();
      for (String hostId : idArr) {
        idBuff.append("'");
        idBuff.append(hostId);
        idBuff.append("'");
        idBuff.append(",");
      } 
      if (idBuff.length() > 0) {
        ids = idBuff.toString();
        ids = ids.substring(0, ids.length() - 1);
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (") + ids + ")");
      } 
    } 
    String code = sysParamUtil.getPara("code");
    if (StringKit.notBlank(code)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`code`=? "));
      param.add(code);
    } 
    String roomNum = sysParamUtil.getPara("room_num");
    if (StringKit.notBlank(roomNum)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`room_num` like ? "));
      param.add("%" + roomNum + "%");
    } 
    String feature = sysParamUtil.getPara("feature");
    if (StringKit.notBlank(feature)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`feature` like ? "));
      param.add("%" + feature + "%");
    } 
    String sys_id = sysParamUtil.getPara("sys_id");
    if (StringKit.notBlank(sys_id)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`oper_sys` = ? "));
      param.add(sys_id);
    } 
    String lastDate = sysParamUtil.getPara("last_online_time", "");
    if (StringKit.notBlank(lastDate)) {
      int addtime = 0 - LogicUtil.parseIntSafe(lastDate) + 1;
      Calendar calendar = Calendar.getInstance();
      calendar.setTime(new Date());
      calendar.add(5, addtime);
      SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`last_online_date` <? "));
      param.add(Timestamp.valueOf(df.format(calendar.getTime())));
    } 
    String begDate = sysParamUtil.getPara("online_beg_date", "");
    String endDate = sysParamUtil.getPara("online_end_date", "");
    if (StringKit.notBlank(begDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`last_online_date` >=? "));
      param.add(Timestamp.valueOf(begDate));
    } 
    if (StringKit.notBlank(endDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`last_online_date` <? "));
      param.add(Timestamp.valueOf(endDate));
    } 
    String unbegDate = sysParamUtil.getPara("un_beg_date", "");
    String unendDate = sysParamUtil.getPara("un_end_date", "");
    if (StringKit.notBlank(unbegDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`unreg_date` >=? "));
      param.add(Timestamp.valueOf(unbegDate));
    } 
    if (StringKit.notBlank(unendDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`unreg_date` <? "));
      param.add(Timestamp.valueOf(unendDate));
    } 
    String regBegDate = sysParamUtil.getPara("active_beg_date", "");
    String regEndDate = sysParamUtil.getPara("active_end_date", "");
    if (StringKit.notBlank(regBegDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`active_date` >=? "));
      param.add(Timestamp.valueOf(regBegDate));
    } 
    if (StringKit.notBlank(regEndDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`active_date` <? "));
      param.add(Timestamp.valueOf(regEndDate));
    } 
    String ipRange = sysParamUtil.getPara("ip_range");
    boolean isIps = true;
    StringBuffer ipAdressRange = new StringBuffer();
    if (StringKit.notBlank(ipRange)) {
      ipRange = SysLogicUtil.filterParam(ipRange);
      String[] ipRanges = ipRange.split(";");
      for (String ipdress : ipRanges) {
        String[] ips = ipdress.split("-");
        if (ips.length > 1)
          if (isIps) {
            ipAdressRange.append(" and ( " + DbDialectUtil.getDbFunFactory().ipScope("host.`ip`", ips[0], ips[1], "host.`ipval`"));
            isIps = false;
          } else {
            ipAdressRange.append(" or " + DbDialectUtil.getDbFunFactory().ipScope("host.`ip`", ips[0], ips[1], "host.`ipval`"));
          }  
      } 
      if (ipAdressRange.toString().length() > 1)
        ipAdressRange.append(" ) "); 
      where.append(ipAdressRange.toString());
    } 
    String userId = sysParamUtil.getPara("user_id");
    if (StringKit.notBlank(userId)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`user_id`=? "));
      param.add(userId);
    } 
    String userName = sysParamUtil.getPara("user_name");
    if (StringKit.notBlank(userName)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and u.`name` like ? "));
      param.add("%" + userName + "%");
    } 
    String installCode = sysParamUtil.getPara("install_code");
    if (StringKit.notBlank(installCode)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`install_code` =? "));
      param.add(installCode);
    } 
    String name = sysParamUtil.getPara("name");
    if (StringKit.notBlank(name)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`name` like ? "));
      param.add("%" + name + "%");
    } 
    String mac = sysParamUtil.getPara("mac");
    if (StringKit.notBlank(mac)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`mac` like ? "));
      param.add("%" + mac + "%");
    } 
    String ip = sysParamUtil.getPara("ip");
    if (StringKit.notBlank(ip)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`ip` like ? "));
      param.add("%" + ip + "%");
    } 
    String host_group_id = sysParamUtil.getPara("host_ip_group");
    if (StringKit.notBlank(host_group_id)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`ip` like ? "));
      param.add("%" + host_group_id + "%");
    } 
    String pSyncState = sysParamUtil.getPara("p_sync_state");
    if (StringKit.notBlank(pSyncState)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`p_sync_state`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(pSyncState)));
    } 
    String installSeclevel = sysParamUtil.getPara("install_seclevel");
    if (StringKit.notBlank(installSeclevel)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`sec_level`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(installSeclevel)));
    } 
    String syncState = sysParamUtil.getPara("sync_state");
    if (StringKit.notBlank(syncState)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`sync_state`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(syncState)));
    } 
    String onlineState = sysParamUtil.getPara("online_state");
    if (StringKit.notBlank(onlineState)) {
      isUpdateCache = true;
      if ("1".equals(onlineState)) {
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`host_online_state` =1 "));
      } else {
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and (host_online.`host_online_state` =0 or host_online.`host_online_state` is null) "));
      } 
    } 
    String checkUncheck = sysParamUtil.getPara("check_uncheck", "0");
    String installState = sysParamUtil.getPara("install_state");
    if (StringKit.notBlank(installState)) {
      String[] installStates = installState.split(",");
      where.append("and ");
      int i = 0;
      for (String string : installStates) {
        String state = "6".equals(string) ? "5" : string;
        if (i == 0) {
          where.append(DbDialectUtil.getDbRuleFactory().dbField(" ( host.`install_state`=?  "));
        } else {
          where.append(DbDialectUtil.getDbRuleFactory().dbField(" or host.`install_state`=?  "));
        } 
        i++;
        param.add(Integer.valueOf(LogicUtil.parseIntSafe(state)));
      } 
      where.append(")");
      String uninstallState = sysParamUtil.getPara("unInstall", "0");
      if ("5".equals(installState) && "1".equals(uninstallState))
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`remark` !='已卸载' ")); 
      if ("6".equals(installState))
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`remark` ='已卸载' ")); 
    } 
    String forbidInstallState = sysParamUtil.getPara("forbid_install_state");
    if (StringKit.notBlank(forbidInstallState)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`install_state`<? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(forbidInstallState)));
    } 
    String isCheckFeature = sysParamUtil.getPara("is_check_feature", "0");
    if ("1".equals(isCheckFeature))
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in(select `id` from tb_base_host where `feature` in ( select `feature` from ( select count(`id`),`feature` from tb_base_host where `feature` is not null and (  `install_state`=1 or `install_state`=2 or `install_state`=3) group by  `feature`  having (count(`id`)>1)) as featuretmp) ) ")); 
    String isReloadHostInfo = sysParamUtil.getPara("is_reload_host_info", "0");
    if ("1".equals(isReloadHostInfo))
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in( select MAX(`id`) AS `id` from (select `id`,`feature`,`install_code`,`last_modify_date` from tb_base_host where `feature` in ( select `feature` from ( select count(`id`),`feature` from tb_base_host where `feature` is not null and (  `install_state`=1 or `install_state`=2 or `install_state`=3) group by  `feature`  having (count(`id`)>1)) as featuretmp) order by `last_online_date` desc ) tem_feature group by  feature)")); 
    String type = sysParamUtil.getPara("type");
    if (StringKit.notBlank(type)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`type`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(type)));
    } 
    String orgId = sysParamUtil.getPara("org_id");
    if (StringKit.notBlank(orgId)) {
      orgId = SysLogicUtil.filterParam(orgId);
      String orgs = LogicUtil.getOrgChilds(orgId);
      orgs = orgs.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id` in (") + orgs + ") ");
    } 
    String orgsId = sysParamUtil.getPara("orgs_id");
    orgsId = SysLogicUtil.filterParam(orgsId);
    if (StringKit.notBlank(orgsId)) {
      orgsId = orgsId.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id` in ('") + orgsId + "')");
    } 
    String accNameRange = ThreadLocalMap.getOrgpermiss();
    if (StringKit.notBlank(accNameRange)) {
      accNameRange = LogicUtil.getAccRange(accNameRange);
      accNameRange = accNameRange.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and  org.`id`  in ('") + accNameRange + "')");
    } 
    String gid = sysParamUtil.getPara("group_id");
    if (StringKit.notBlank(gid)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (select `obj_id` from tb_base_group_bind where `group_id`=?) "));
      param.add(gid);
    } 
    String groupIds = sysParamUtil.getPara("groups_id");
    if (StringKit.notBlank(groupIds)) {
      groupIds = SysLogicUtil.filterParam(groupIds);
      groupIds = groupIds.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (select `obj_id` from tb_base_group_bind where `group_id` in(") + "'" + groupIds + "'))  ");
    } 
    String removeHost = sysParamUtil.getPara("remove_host");
    if (StringKit.notBlank(removeHost)) {
      removeHost = SysLogicUtil.filterParam(removeHost);
      removeHost = removeHost.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` NOT IN (SELECT `id` FROM tb_base_host WHERE `id` in(") + "'" + removeHost + "')) ");
    } 
    String sort = sysParamUtil.getPara("sort");
    String order = sysParamUtil.getPara("order", " desc ");
    String unreg_page = sysParamUtil.getPara("unreg_page");
    if (StringKit.notBlank(sort)) {
      sortBuffer.append(sort).append(" ").append(order).append(DbDialectUtil.getDbRuleFactory().dbField(" ,`feature` desc "));
    } else if ("1".equals(isCheckFeature)) {
      sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" `feature` desc "));
    } else {
      if (unreg_page != null) {
        if ("1".equals(unreg_page))
          sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" `unreg_date` ")); 
      } else {
        sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" `reg_date` "));
      } 
      sortBuffer.append(order);
      sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" ,`feature` desc "));
    } 
    where.append(" )");
    String additHost = sysParamUtil.getPara("addit_host");
    if (StringKit.notBlank(additHost)) {
      additHost = additHost.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" OR host.`id`  IN (SELECT `id` FROM tb_base_host WHERE `id` in(") + "'" + additHost + "')) ");
    } 
    String sql = DbDialectUtil.getDbRuleFactory().dbField("select products.`products` as `products`,host.`feature`,host.`node_id`,host.`install_code`,host.`id`,host.`code`,host.`room_num`,host.`name`,host.`type`,host.`install_state`,case when host_online.`host_online_state` is null then 0 else host_online.`host_online_state` end as `online_state`,host_online.`host_online_state` as `host_online_state`,host.`sync_date`,host.`sync_state`,host.`p_sync_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`unreg_date`,host.`sync_date`,host.`last_modify_date`,host.`host_version`,host.`ext`,host.`user_id`,host.`create_date`,u.`name` AS `user_name`,org.`id` AS `org_id`,org.`region` AS `region` ,org.`name` AS `orga_name`, dict_install.`dict_name` AS `install_state_name`,dict_sec_level.`dict_name` AS `dict_sec_level_name`,host.`remark` , dict_sys.`dict_name` AS `oper_name` ,u.`work_num` ,u.`tel_num`  ");
    if (!cascade_data)
      sql = sql + DbDialectUtil.getDbRuleFactory().dbField(",host_online.`last_online_date`,host.`osversioninfo`"); 
    String sqlExceptSelect = DbDialectUtil.getDbRuleFactory().dbField(" FROM tb_base_host host  LEFT JOIN tb_base_host_online host_online ON host.`id`=host_online.`host_id`  LEFT JOIN tb_base_user  u ON host.`user_id`=u.`id` LEFT JOIN tb_base_org  org ON org.`id`=u.`org_id` LEFT JOIN (SELECT `dict_id`,`dict_name` FROM  tb_base_dict WHERE  `dict_type`='3') dict_install ON host.`install_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_install.`dict_id`", "int") + "  LEFT JOIN (SELECT `dict_id`,`dict_name` FROM  tb_base_dict WHERE  `dict_type`='1') dict_sec_level ON host.`sec_level`=" + DbDialectUtil.getDbFunFactory().cast("dict_sec_level.`dict_id`", "int") + " LEFT JOIN (SELECT `dict_id`,`dict_name` FROM  tb_base_dict WHERE  `dict_type`='7') dict_sys ON host.`oper_sys`=dict_sys.`dict_id` LEFT JOIN tb_base_host_extend products on host.`id`=products.`host_id`   JOIN (SELECT DISTINCT `host_id` FROM tb_base_client_health  WHERE `host_id` IN(SELECT `host_id` FROM tb_base_host_product_auth WHERE `product_id`='zfmg'))auth ON host.`id`=auth.`host_id` ") + where.toString() + sortBuffer.toString();
    int pagePosition = sysParamUtil.getParaToInt("page", Integer.valueOf(1)).intValue();
    int pageSize = sysParamUtil.getParaToInt("rows", Integer.valueOf(10)).intValue();
    if (pagePosition == 0 && pageSize == 0) {
      List<Record> recordList = DbUtil.findByCache(sql + sqlExceptSelect, isUpdateCache, "online_time_current", param.toArray());
      Page<Record> page1 = new Page(recordList, 0, 0, 0, 0);
      LogicUtil.getOtherInfo(page1.getList(), "org_id", "orga_name", checkUncheck);
      return page1;
    } 
    Page<Record> page = DbUtil.paginateByCache(pagePosition, pageSize, sql, sqlExceptSelect, isUpdateCache, "online_time_current", param.toArray());
    LogicUtil.getOtherInfo(page.getList(), "org_id", "orga_name", checkUncheck);
    return page;
  }
  
  public static Page<Record> showAllNormal(Map paramMap) {
    boolean isUpdateCache = false;
    SysParamUtil sysParamUtil = new SysParamUtil(paramMap);
    List<Object> param = new ArrayList();
    StringBuffer where = new StringBuffer(" where ( 1=1 ");
    StringBuffer sortBuffer = new StringBuffer(" order by ");
    boolean cascade_data = sysParamUtil.getParaToBoolean("cascade_data", Boolean.valueOf(false)).booleanValue();
    boolean isHide = false;
    try {
      Record record = SysParamHelp.show("F8E5DB84-DF81-429B-96DE-9954DC8A4000");
      if (record != null && "1".equals(record.getStr("param_value")))
        isHide = true; 
    } catch (Exception exception) {}
    if (cascade_data && isHide) {
      List<Record> recordList = new ArrayList<>();
      Page<Record> page1 = new Page(recordList, 0, 0, 0, 0);
      return page1;
    } 
    String id = sysParamUtil.getPara("id");
    if (StringKit.notBlank(id)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id`=? "));
      param.add(id);
    } 
    String ids = sysParamUtil.getPara("ids");
    if (StringKit.notBlank(ids) && ids.indexOf("'") < 0) {
      ids = SysLogicUtil.filterParam(ids);
      String[] idArr = ids.split(",");
      StringBuffer idBuff = new StringBuffer();
      for (String hostId : idArr) {
        idBuff.append("'");
        idBuff.append(hostId);
        idBuff.append("'");
        idBuff.append(",");
      } 
      if (idBuff.length() > 0) {
        ids = idBuff.toString();
        ids = ids.substring(0, ids.length() - 1);
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (") + ids + ")");
      } 
    } 
    String code = sysParamUtil.getPara("code");
    if (StringKit.notBlank(code)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`code`=? "));
      param.add(code);
    } 
    String roomNum = sysParamUtil.getPara("room_num");
    if (StringKit.notBlank(roomNum)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`room_num` like ? "));
      param.add("%" + roomNum + "%");
    } 
    String feature = sysParamUtil.getPara("feature");
    if (StringKit.notBlank(feature)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`feature` like ? "));
      param.add("%" + feature + "%");
    } 
    String sys_id = sysParamUtil.getPara("sys_id");
    if (StringKit.notBlank(sys_id)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`oper_sys` = ? "));
      param.add(sys_id);
    } 
    String lastDate = sysParamUtil.getPara("last_online_time", "");
    if (StringKit.notBlank(lastDate)) {
      int addtime = 0 - LogicUtil.parseIntSafe(lastDate) + 1;
      Calendar calendar = Calendar.getInstance();
      calendar.setTime(new Date());
      calendar.add(5, addtime);
      SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`last_online_date` <? "));
      param.add(Timestamp.valueOf(df.format(calendar.getTime())));
    } 
    String begDate = sysParamUtil.getPara("online_beg_date", "");
    String endDate = sysParamUtil.getPara("online_end_date", "");
    if (StringKit.notBlank(begDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`last_online_date` >=? "));
      param.add(Timestamp.valueOf(begDate));
    } 
    if (StringKit.notBlank(endDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`last_online_date` <? "));
      param.add(Timestamp.valueOf(endDate));
    } 
    String unbegDate = sysParamUtil.getPara("un_beg_date", "");
    String unendDate = sysParamUtil.getPara("un_end_date", "");
    if (StringKit.notBlank(unbegDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`unreg_date` >=? "));
      param.add(Timestamp.valueOf(unbegDate));
    } 
    if (StringKit.notBlank(unendDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`unreg_date` <? "));
      param.add(Timestamp.valueOf(unendDate));
    } 
    String regBegDate = sysParamUtil.getPara("active_beg_date", "");
    String regEndDate = sysParamUtil.getPara("active_end_date", "");
    if (StringKit.notBlank(regBegDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`active_date` >=? "));
      param.add(Timestamp.valueOf(regBegDate));
    } 
    if (StringKit.notBlank(regEndDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`active_date` <? "));
      param.add(Timestamp.valueOf(regEndDate));
    } 
    String ipRange = sysParamUtil.getPara("ip_range");
    boolean isIps = true;
    StringBuffer ipAdressRange = new StringBuffer();
    if (StringKit.notBlank(ipRange)) {
      ipRange = SysLogicUtil.filterParam(ipRange);
      String[] ipRanges = ipRange.split(";");
      for (String ipdress : ipRanges) {
        String[] ips = ipdress.split("-");
        if (ips.length > 1)
          if (isIps) {
            ipAdressRange.append(" and ( " + DbDialectUtil.getDbFunFactory().ipScope("host.`ip`", ips[0], ips[1], "host.`ipval`"));
            isIps = false;
          } else {
            ipAdressRange.append(" or " + DbDialectUtil.getDbFunFactory().ipScope("host.`ip`", ips[0], ips[1], "host.`ipval`"));
          }  
      } 
      if (ipAdressRange.toString().length() > 1)
        ipAdressRange.append(" ) "); 
      where.append(ipAdressRange.toString());
    } 
    String userId = sysParamUtil.getPara("user_id");
    if (StringKit.notBlank(userId)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`user_id`=? "));
      param.add(userId);
    } 
    String userName = sysParamUtil.getPara("user_name");
    if (StringKit.notBlank(userName)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and u.`name` like ? "));
      param.add("%" + userName + "%");
    } 
    String installCode = sysParamUtil.getPara("install_code");
    if (StringKit.notBlank(installCode)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`install_code` =? "));
      param.add(installCode);
    } 
    String name = sysParamUtil.getPara("name");
    if (StringKit.notBlank(name)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`name` like ? "));
      param.add("%" + name + "%");
    } 
    String mac = sysParamUtil.getPara("mac");
    if (StringKit.notBlank(mac)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`mac` like ? "));
      param.add("%" + mac + "%");
    } 
    String ip = sysParamUtil.getPara("ip");
    if (StringKit.notBlank(ip)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`ip` like ? "));
      param.add("%" + ip + "%");
    } 
    String hostIpGroup = sysParamUtil.getPara("host_ip_group");
    if (StringKit.notBlank(hostIpGroup)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`ip` like ? "));
      param.add("%" + hostIpGroup + "%");
    } 
    String pSyncState = sysParamUtil.getPara("p_sync_state");
    if (StringKit.notBlank(pSyncState)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`p_sync_state`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(pSyncState)));
    } 
    String installSeclevel = sysParamUtil.getPara("install_seclevel");
    if (StringKit.notBlank(installSeclevel)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`sec_level`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(installSeclevel)));
    } 
    String syncState = sysParamUtil.getPara("sync_state");
    if (StringKit.notBlank(syncState)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`sync_state`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(syncState)));
    } 
    String onlineState = sysParamUtil.getPara("online_state");
    if (StringKit.notBlank(onlineState)) {
      isUpdateCache = true;
      if ("1".equals(onlineState)) {
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`host_online_state` =1 "));
      } else {
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and (host_online.`host_online_state` =0 or host_online.`host_online_state` is null) "));
      } 
    } 
    String checkUncheck = sysParamUtil.getPara("check_uncheck", "0");
    String installState = sysParamUtil.getPara("install_state");
    if (StringKit.notBlank(installState)) {
      String[] installStates = installState.split(",");
      where.append("and ");
      int i = 0;
      for (String string : installStates) {
        String state = "6".equals(string) ? "5" : string;
        if (i == 0) {
          where.append(DbDialectUtil.getDbRuleFactory().dbField(" ( host.`install_state`=?  "));
        } else {
          where.append(DbDialectUtil.getDbRuleFactory().dbField(" or host.`install_state`=?  "));
        } 
        i++;
        param.add(Integer.valueOf(LogicUtil.parseIntSafe(state)));
      } 
      where.append(")");
      String uninstallState = sysParamUtil.getPara("unInstall", "0");
      if ("5".equals(installState) && "1".equals(uninstallState))
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`remark` !='已卸载' ")); 
      if ("6".equals(installState))
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`remark` ='已卸载' ")); 
    } 
    String forbidInstallState = sysParamUtil.getPara("forbid_install_state");
    if (StringKit.notBlank(forbidInstallState)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`install_state`<? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(forbidInstallState)));
    } 
    String isCheckFeature = sysParamUtil.getPara("is_check_feature", "0");
    where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in(select `id` from tb_base_host where `feature` in ( select `feature` from ( select count(`id`),`feature` from tb_base_host where `feature` is not null and (  `install_state`=1 or `install_state`=2 or `install_state`=3) group by  `feature`  having (count(`id`)>1)) as featuretmp) ) "));
    String isReloadHostInfo = sysParamUtil.getPara("is_reload_host_info", "0");
    String type = sysParamUtil.getPara("type");
    if (StringKit.notBlank(type)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`type`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(type)));
    } 
    String orgId = sysParamUtil.getPara("org_id");
    if (StringKit.notBlank(orgId)) {
      orgId = SysLogicUtil.filterParam(orgId);
      String orgs = LogicUtil.getOrgChilds(orgId);
      orgs = orgs.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id` in (") + orgs + ") ");
    } 
    String orgsId = sysParamUtil.getPara("orgs_id");
    orgsId = SysLogicUtil.filterParam(orgsId);
    if (StringKit.notBlank(orgsId)) {
      orgsId = orgsId.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id` in ('") + orgsId + "')");
    } 
    String accNameRange = ThreadLocalMap.getOrgpermiss();
    if (StringKit.notBlank(accNameRange)) {
      accNameRange = LogicUtil.getAccRange(accNameRange);
      accNameRange = accNameRange.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and  org.`id`  in ('") + accNameRange + "')");
    } 
    String gid = sysParamUtil.getPara("group_id");
    if (StringKit.notBlank(gid)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (select `obj_id` from tb_base_group_bind where `group_id`=?) "));
      param.add(gid);
    } 
    String groupIds = sysParamUtil.getPara("groups_id");
    if (StringKit.notBlank(groupIds)) {
      groupIds = SysLogicUtil.filterParam(groupIds);
      groupIds = groupIds.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (select `obj_id` from tb_base_group_bind where `group_id` in(") + "'" + groupIds + "'))  ");
    } 
    String removeHost = sysParamUtil.getPara("remove_host");
    if (StringKit.notBlank(removeHost)) {
      removeHost = SysLogicUtil.filterParam(removeHost);
      removeHost = removeHost.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` NOT IN (SELECT `id` FROM tb_base_host WHERE `id` in(") + "'" + removeHost + "')) ");
    } 
    String sort = sysParamUtil.getPara("sort");
    String order = sysParamUtil.getPara("order", " desc ");
    String unreg_page = sysParamUtil.getPara("unreg_page");
    if (StringKit.notBlank(sort)) {
      sortBuffer.append(sort).append(" ").append(order).append(DbDialectUtil.getDbRuleFactory().dbField(" ,`feature` desc "));
    } else if ("1".equals(isCheckFeature)) {
      sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" `feature` desc "));
    } else {
      if (unreg_page != null) {
        if ("1".equals(unreg_page))
          sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" `unreg_date` ")); 
      } else {
        sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" `reg_date` "));
      } 
      sortBuffer.append(order);
      sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" ,`feature` desc "));
    } 
    where.append(" )");
    String additHost = sysParamUtil.getPara("addit_host");
    if (StringKit.notBlank(additHost)) {
      additHost = additHost.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" OR host.`id`  IN (SELECT `id` FROM tb_base_host WHERE `id` in(") + "'" + additHost + "')) ");
    } 
    String sql = DbDialectUtil.getDbRuleFactory().dbField("select products.`products` as `products`,host.`feature`,host.`node_id`,host.`install_code`,host.`id`,host.`code`,host.`room_num`,host.`name`,host.`type`,host.`install_state`,case when host_online.`host_online_state` is null then 0 else host_online.`host_online_state` end as `online_state`,host_online.`host_online_state` as `host_online_state`,host.`sync_date`,host.`sync_state`,host.`p_sync_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`unreg_date`,host.`sync_date`,host.`last_modify_date`,host.`host_version`,host.`ext`,host.`user_id`,host.`create_date`,u.`name` AS `user_name`,org.`id` AS `org_id`,org.`region` AS `region` ,org.`name` AS `orga_name`, dict_install.`dict_name` AS `install_state_name`,dict_sec_level.`dict_name` AS `dict_sec_level_name`,host.`remark` , dict_sys.`dict_name` AS `oper_name` ,u.`work_num` ,u.`tel_num`  ");
    if (!cascade_data)
      sql = sql + DbDialectUtil.getDbRuleFactory().dbField(",host_online.`last_online_date`,host.`osversioninfo`"); 
    String sqlExceptSelect = DbDialectUtil.getDbRuleFactory().dbField(" FROM tb_base_host host  LEFT JOIN tb_base_host_online host_online ON host.`id`=host_online.`host_id`  LEFT JOIN tb_base_user  u ON host.`user_id`=u.`id` LEFT JOIN tb_base_org  org ON org.`id`=u.`org_id` LEFT JOIN (SELECT `dict_id`,`dict_name` FROM  tb_base_dict WHERE  `dict_type`='3') dict_install ON host.`install_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_install.`dict_id`", "int") + "  LEFT JOIN (SELECT `dict_id`,`dict_name` FROM  tb_base_dict WHERE  `dict_type`='1') dict_sec_level ON host.`sec_level`=" + DbDialectUtil.getDbFunFactory().cast("dict_sec_level.`dict_id`", "int") + " LEFT JOIN (SELECT `dict_id`,`dict_name` FROM  tb_base_dict WHERE  `dict_type`='7') dict_sys ON host.`oper_sys`=dict_sys.`dict_id` LEFT JOIN tb_base_host_extend products on host.`id`=products.`host_id` ") + where.toString() + sortBuffer.toString();
    int pagePosition = sysParamUtil.getParaToInt("page", Integer.valueOf(1)).intValue();
    int pageSize = sysParamUtil.getParaToInt("rows", Integer.valueOf(10)).intValue();
    if (pagePosition == 0 && pageSize == 0) {
      List<Record> recordList = DbUtil.findByCache(sql + sqlExceptSelect, isUpdateCache, "online_time_current", param.toArray());
      Page<Record> page1 = new Page(recordList, 0, 0, 0, 0);
      LogicUtil.getOtherInfo(page1.getList(), "org_id", "orga_name", checkUncheck);
      return page1;
    } 
    Page<Record> page = DbUtil.paginateByCache(pagePosition, pageSize, sql, sqlExceptSelect, isUpdateCache, "online_time_current", param.toArray());
    LogicUtil.getOtherInfo(page.getList(), "org_id", "orga_name", checkUncheck);
    return page;
  }
  
  public static Long containInfo(Map paramMap) {
    SysParamUtil sysParamUtil = new SysParamUtil(paramMap);
    String id = sysParamUtil.getPara("id");
    if (StringKit.notBlank(id)) {
      Record hostRecord = show(id);
      if (hostRecord.getInt("install_state").intValue() == 2 || hostRecord.getInt("install_state").intValue() == 3)
        return Long.valueOf(0L); 
    } 
    List<Object> param = new ArrayList();
    StringBuffer where = new StringBuffer(DbDialectUtil.getDbRuleFactory().dbField(" where   `install_state` <4  "));
    if (StringKit.notBlank(id))
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and `id` !='") + id + "'"); 
    String ip = sysParamUtil.getPara("ip");
    if (StringKit.notBlank(ip))
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and  `ip` ='") + ip + "'"); 
    String mac = sysParamUtil.getPara("mac");
    if (StringKit.notBlank(mac)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and `mac` ='") + mac + "'");
      param.add(mac);
    } 
    String sn = sysParamUtil.getPara("sn");
    if (StringKit.notBlank(sn)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and  `sn` ='") + sn + "'");
      param.add(sn);
    } 
    Long countLong = Db.queryLong(DbDialectUtil.getDbRuleFactory().dbField("select count(`id`) from tb_base_host ") + where.toString());
    return countLong;
  }
  
  public static ArrayList<String> showUserByHostIds(ArrayList<String> ids) {
    if (ObjectUtil.isNotNull(ids) && ids.size() > 0)
      return new ArrayList<>(); 
    return new ArrayList<>();
  }
  
  public static Record showUserByHostId(String hostId) {
    return DbUtil.findFirst("select user_id from tb_base_host where id = ?", new Object[] { hostId });
  }
  
  public static List<Record> showUserByHostId(List<String> hostIds) {
    if (hostIds.isEmpty())
      return Lists.newArrayList(); 
    String sql = DbDialectUtil.getDbRuleFactory().dbField(" select user_id from tb_base_host ");
    StringBuilder sqlBuilder = DbUtil.getSingleStatmentInSqlParam(hostIds, "`id`", new StringBuilder(sql));
    return Db.find(sqlBuilder.toString(), hostIds.toArray());
  }
  
  public static String showHostNames(String ids) {
    String[] idArr = ids.split(",");
    List<String> idLists = Arrays.asList(idArr);
    String sql = DbDialectUtil.getDbRuleFactory().dbField(" select distinct `name`  from tb_base_host ");
    StringBuilder sqlBuilder = DbUtil.getSingleStatmentInSqlParam(idLists, "`id`", new StringBuilder(sql));
    List<String> list = DbUtil.query(sqlBuilder.toString(), idLists.toArray());
    String hostNameString = "";
    for (String name : list)
      hostNameString = hostNameString + name + ","; 
    if (StringKit.notBlank(hostNameString) && hostNameString.length() > 0)
      hostNameString = hostNameString.substring(0, hostNameString.length() - 1); 
    return hostNameString;
  }
  
  public static Record showHostCount(String state) {
    Record countRecord = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select count(`id`) as `host_count` from tb_base_host where `install_state` <= ? limit 1"), new Object[] { state });
    return countRecord;
  }
  
  public static List<Record> ipGroup() {
    StringBuffer sqlBuffer = new StringBuffer();
    sqlBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" select distinct host.`ip` as `ips`  from "));
    sqlBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" tb_base_host host  LEFT JOIN tb_base_host_online host_online ON host.`id`=host_online.`host_id` "));
    sqlBuffer.append(DbDialectUtil.getDbRuleFactory().dbField("  LEFT JOIN tb_base_user  u ON host.`user_id`=u.`id`  "));
    sqlBuffer.append(DbDialectUtil.getDbRuleFactory().dbField("  LEFT JOIN tb_base_org  org ON org.`id`=u.`org_id`  "));
    StringBuffer where = new StringBuffer(DbDialectUtil.getDbRuleFactory().dbField(" where (host.`install_state`='0' or host.`install_state`='2' or host.`install_state`='3')  "));
    String accNameRange = ThreadLocalMap.getOrgpermiss();
    if (StringKit.notBlank(accNameRange)) {
      accNameRange = LogicUtil.getAccRange(accNameRange);
      accNameRange = accNameRange.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id`  in (select `id` from tb_base_org where `id` in(") + "'" + accNameRange + "')) ");
    } 
    sqlBuffer.append(where.toString());
    sqlBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" order by host.`ip` "));
    List<String> hostIps = Db.query(sqlBuffer.toString());
    List<String> newHostIpsList = new ArrayList<>();
    for (String hostIp : hostIps) {
      if (StringKit.notBlank(hostIp)) {
        String newIp = hostIp.substring(0, hostIp.lastIndexOf(".") + 1) + "0";
        newHostIpsList.add(newIp);
      } 
    } 
    HashSet<String> hSet = new HashSet<>(newHostIpsList);
    newHostIpsList.clear();
    newHostIpsList.addAll(hSet);
    return buildHostIPTree(newHostIpsList);
  }
  
  public static List<Record> sysOperGroup() {
    StringBuffer sqlBuffer = new StringBuffer();
    sqlBuffer.append(DbDialectUtil.getDbRuleFactory().dbField("select distinct(host.`oper_sys`), `dict_sys`.`dict_name` AS `oper_name` from tb_base_host host "));
    sqlBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" LEFT JOIN tb_base_user  u ON host.`user_id`=u.`id` "));
    sqlBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" LEFT JOIN tb_base_org  org ON org.`id`=u.`org_id` "));
    sqlBuffer.append(DbDialectUtil.getDbRuleFactory().dbField("  LEFT JOIN (SELECT `dict_id`,`dict_name` FROM  tb_base_dict WHERE  `dict_type`='7') dict_sys ON host.`oper_sys`=dict_sys.`dict_id` "));
    StringBuffer where = new StringBuffer(DbDialectUtil.getDbRuleFactory().dbField(" where (host.`install_state`>1) and host.`oper_sys` is not null AND host.`oper_sys` !='' "));
    String accNameRange = ThreadLocalMap.getOrgpermiss();
    if (StringKit.notBlank(accNameRange)) {
      accNameRange = LogicUtil.getAccRange(accNameRange);
      accNameRange = accNameRange.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id`  in (select id from tb_base_org where `id` in(") + "'" + accNameRange + "')) ");
    } 
    sqlBuffer.append(where.toString());
    List<Record> hostOperSys = Db.find(sqlBuffer.toString());
    return buildOperSysTree(hostOperSys);
  }
  
  private static List<Record> buildHostIPTree(List<String> hosts) {
    List<Record> nodes = Lists.newArrayList();
    Record node = new Record();
    node.set("id", "");
    node.set("text", "主机IP段");
    node.set("checked", Boolean.valueOf(false));
    node.set("iconCls", "icon-home");
    List<Record> childs = Lists.newArrayList();
    for (String ip : hosts) {
      if (StringKit.notBlank(ip)) {
        String[] ips = ip.split("\\.");
        if (ips.length == 4) {
          Record subNode = new Record();
          subNode.set("id", ips[0] + "." + ips[1] + "." + ips[2] + ".");
          subNode.set("text", "IP段(" + ips[0] + "." + ips[1] + "." + ips[2] + ".1-255)");
          subNode.set("iconCls", "");
          childs.add(subNode);
        } 
      } 
    } 
    node.set("children", childs);
    nodes.add(node);
    return nodes;
  }
  
  private static List<Record> buildOperSysTree(List<Record> hosts) {
    List<Record> nodes = Lists.newArrayList();
    Record node = new Record();
    node.set("id", "");
    node.set("text", "主机操作系统");
    node.set("checked", Boolean.valueOf(false));
    node.set("iconCls", "icon-home");
    List<Record> childs = Lists.newArrayList();
    for (Record host : hosts) {
      Record subNode = new Record();
      subNode.set("id", host.getStr("oper_sys"));
      subNode.set("text", host.getStr("oper_name"));
      subNode.set("iconCls", "");
      childs.add(subNode);
    } 
    node.set("children", childs);
    nodes.add(node);
    return nodes;
  }
  
  public static List<Record> listAll(Map paramMap) {
    SysParamUtil sysParamUtil = new SysParamUtil(paramMap);
    Map<String, String> param = sysParamUtil.getParam();
    param.put("page", "0");
    param.put("rows", "0");
    Page<Record> page = showAll(param);
    return page.getList();
  }
  
  public static Page<Record> listAllForPage(Map paramMap) {
    SysParamUtil sysParamUtil = new SysParamUtil(paramMap);
    Map param = sysParamUtil.getParam();
    return showAll(param);
  }
  
  public static Page<Record> hostProductPage(Map paramMap) {
    SysParamUtil sysParamUtil = new SysParamUtil(paramMap);
    List<Object> param = new ArrayList();
    StringBuffer where = new StringBuffer(DbDialectUtil.getDbRuleFactory().dbField(" where  (host.`install_state`=0 or host.`install_state`=1 or host.`install_state`=2 or  host.`install_state`=3) "));
    StringBuffer sortBuffer = new StringBuffer(" order by ");
    String findProduct = "";
    String product_id = sysParamUtil.getPara("product_id");
    if (StringKit.notBlank(product_id)) {
      findProduct = DbDialectUtil.getDbRuleFactory().dbField(" inner join (select * from tb_base_host_product_auth  where tb_base_host_product_auth.`product_id`=?)  productAuth on host.`id`=productAuth.`host_id` ");
      param.add(product_id);
    } 
    String id = sysParamUtil.getPara("id");
    if (StringKit.notBlank(id)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id`=? "));
      param.add(id);
    } 
    String installCode = sysParamUtil.getPara("install_code");
    if (StringKit.notBlank(installCode)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`install_code` =?"));
      param.add(installCode);
    } 
    Boolean showChildNodeData = sysParamUtil.getParaToBoolean("show_child_node_data", Boolean.valueOf(true));
    if (!showChildNodeData.booleanValue()) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`node_id` = ? "));
      param.add(BaseGlobal.getCurrentNodeId());
    } 
    String ids = sysParamUtil.getPara("ids");
    if (StringKit.notBlank(ids) && ids.indexOf("'") < 0) {
      ids = SysLogicUtil.filterParam(ids);
      String[] idArr = ids.split(",");
      StringBuffer idBuff = new StringBuffer();
      for (String hostId : idArr) {
        idBuff.append("'");
        idBuff.append(hostId);
        idBuff.append("'");
        idBuff.append(",");
      } 
      if (idBuff.length() > 0) {
        ids = idBuff.toString();
        ids = ids.substring(0, ids.length() - 1);
        where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`id` in (") + ids + ")");
      } 
    } 
    String code = sysParamUtil.getPara("code");
    if (StringKit.notBlank(code)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`code`=? "));
      param.add(code);
    } 
    String noauth_product_id = sysParamUtil.getPara("noauth_product_id");
    if (StringKit.notBlank(noauth_product_id)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`id` not in ( select  `host_id` from tb_base_host_product_auth where `product_id` =?) "));
      param.add(noauth_product_id);
    } 
    String onlineState = sysParamUtil.getPara("online_state");
    if (StringKit.notBlank(onlineState))
      if ("1".equals(onlineState)) {
        where.append(DbDialectUtil.getDbRuleFactory().dbField("and host_online.`host_online_state` =1"));
      } else {
        where.append(DbDialectUtil.getDbRuleFactory().dbField("and (host_online.`host_online_state` =0 or host_online.`host_online_state` is null) "));
      }  
    String ipRange = sysParamUtil.getPara("ip_range");
    boolean isIps = true;
    StringBuffer ipAdressRange = new StringBuffer();
    if (StringKit.notBlank(ipRange)) {
      String[] ipRanges = ipRange.split(";");
      for (String ipdress : ipRanges) {
        String[] ips = ipdress.split("-");
        if (ips.length > 1)
          if (isIps) {
            ipAdressRange.append(" and ( " + DbDialectUtil.getDbFunFactory().ipScope("host.`ip`", ips[0], ips[1], "host.`ipval`"));
            isIps = false;
          } else {
            ipAdressRange.append(" or " + DbDialectUtil.getDbFunFactory().ipScope("host.`ip`", ips[0], ips[1], "host.`ipval`"));
          }  
      } 
      if (ipAdressRange.toString().length() > 1)
        ipAdressRange.append(" ) "); 
      where.append(ipAdressRange.toString());
    } 
    String userId = sysParamUtil.getPara("user_id");
    if (StringKit.notBlank(userId)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`user_id`=? "));
      param.add(userId);
    } 
    String userName = sysParamUtil.getPara("user_name");
    if (StringKit.notBlank(userName)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and u.`name` like ? "));
      param.add("%" + userName + "%");
    } 
    String name = sysParamUtil.getPara("name");
    if (StringKit.notBlank(name)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`name` like ? "));
      param.add("%" + name + "%");
    } 
    String ip = sysParamUtil.getPara("ip");
    if (StringKit.notBlank(ip)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`ip` like ? "));
      param.add("%" + ip + "%");
    } 
    String info = sysParamUtil.getPara("info");
    if (StringKit.notBlank(info)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and (host.`ip` like ? or u.`name` like ? or host.`name`  like ? ) "));
      param.add("%" + info + "%");
      param.add("%" + info + "%");
      param.add("%" + info + "%");
    } 
    String mac = sysParamUtil.getPara("mac");
    if (StringKit.notBlank(mac)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`mac` like ? "));
      param.add("%" + mac + "%");
    } 
    String type = sysParamUtil.getPara("type");
    if (StringKit.notBlank(type)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`type`=? "));
      param.add(Integer.valueOf(type));
    } 
    String orgId = sysParamUtil.getPara("org_id");
    if (StringKit.notBlank(orgId) && !orgId.equalsIgnoreCase(BaseGlobal.getCurrentNodeId())) {
      orgId = SysLogicUtil.filterParam(orgId);
      String orgs = LogicUtil.getOrgChilds(orgId);
      String[] orgIds = orgs.split(",");
      for (String idStr : orgIds) {
        idStr = idStr.replaceAll("'", "");
        param.add(idStr);
      } 
      List<String> idList = Arrays.asList(orgIds);
      Collections.fill(idList, "?");
      orgs = Joiner.on(",").join((Iterable)idList);
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id` in (") + orgs + ") ");
    } 
    String orgsId = sysParamUtil.getPara("orgs_id");
    if (StringKit.notBlank(orgsId)) {
      orgsId = SysLogicUtil.filterParam(orgsId);
      orgsId = orgsId.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and org.`id` in (select `id` from tb_base_org where `id` in(") + "'" + orgsId + "')) ");
    } 
    String accNameRange = ThreadLocalMap.getOrgpermiss();
    if (StringKit.notBlank(accNameRange)) {
      accNameRange = SysLogicUtil.filterParam(accNameRange);
      accNameRange = LogicUtil.getAccRange(accNameRange);
      accNameRange = accNameRange.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and  org.`id`  in (select `id` from tb_base_org where `id` in(") + "'" + accNameRange + "')) ");
    } 
    String installState = sysParamUtil.getPara("install_state");
    if (StringKit.notBlank(installState)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`install_state`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(installState)));
    } 
    String installSeclevel = sysParamUtil.getPara("install_seclevel");
    if (StringKit.notBlank(installSeclevel)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField("and host.`sec_level`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(installSeclevel)));
    } 
    boolean is_sort = sysParamUtil.getParaToBoolean("is_sort", Boolean.valueOf(true)).booleanValue();
    String sort = sysParamUtil.getPara("sort");
    String order = sysParamUtil.getPara("order", " desc ");
    if (is_sort)
      if (StringKit.notBlank(sort)) {
        sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField("`" + sort + "`"));
        sortBuffer.append(order);
      } else {
        sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" `reg_date` "));
        sortBuffer.append(order);
      }  
    String sql = DbDialectUtil.getDbRuleFactory().dbField("SELECT host.`import_host`,host.`auth_state`, host.`node_id`,host.`install_code`,host.`id`,host.`name`,host.`type`,host.`install_state`,host.`ip`,host.`mac`,u.`name` AS `user_name`,org.`id` AS `org_id`,org.`name` AS `orga_name`, dict_install.`dict_name` AS `install_state_name`,products.`num` as `remark`,products.`products`,case when host_online.`host_online_state` is null then 0 else host_online.`host_online_state` end as `online_state`,host_online.`host_online_state` as `host_online_state`");
    String sqlExceptSelect = DbDialectUtil.getDbRuleFactory().dbField(" FROM tb_base_host host LEFT JOIN tb_base_user  u ON  host.`user_id`=u.`id` LEFT JOIN tb_base_org  org ON org.`id`=u.`org_id` LEFT JOIN tb_base_host_online host_online ON host.`id`=host_online.`host_id` LEFT JOIN  (SELECT `dict_id`,`dict_name` FROM  tb_base_dict WHERE  `dict_type`='3') dict_install  ON host.`install_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_install.`dict_id`", "int") + "  LEFT JOIN tb_base_host_extend  products on host.`id`=products.`host_id` ") + findProduct + where.toString() + sortBuffer.toString();
    int pagePosition = sysParamUtil.getParaToInt("page", Integer.valueOf(1)).intValue();
    int pageSize = sysParamUtil.getParaToInt("rows", Integer.valueOf(10)).intValue();
    if (pagePosition == 0 && pageSize == 0) {
      List<Record> recordList = Db.find(sql + sqlExceptSelect, param.toArray());
      Page<Record> page1 = new Page(recordList, 0, 0, 0, 0);
      LogicUtil.getFullOrg(page1.getList(), "org_id", "orga_name");
      return page1;
    } 
    Page<Record> page = DbUtil.paginateByCache("tb_base_host", pagePosition, pageSize, sql, sqlExceptSelect, param.toArray());
    LogicUtil.getFullOrg(page.getList(), "org_id", "orga_name");
    return page;
  }
  
  public static List<Record> hostProductList(Map paramMap) {
    SysParamUtil sysParamUtil = new SysParamUtil(paramMap);
    Map<String, String> param = sysParamUtil.getParam();
    param.put("page", "0");
    param.put("rows", "0");
    Page<Record> page = hostProductPage(param);
    return page.getList();
  }
  
  public static Record show(String hostId) {
    SysLogicUtil.isParamBlank(hostId);
    return getHostByIdDao(hostId);
  }
  
  public static Record showByIpMac(String ip, String mac) {
    Record hostInfo = DbUtil.findFirstByCache(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host where `mac`=? and `ip`=? limit 1"), new Object[] { mac, ip });
    return hostInfo;
  }
  
  public static Record showByIpSNState(String ip, String sn, boolean is_deb) {
    Record hostInfo = null;
    if (is_deb) {
      hostInfo = DbUtil.findFirstByCache(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host where `sn`=? and `ip`=? and `install_state`=2 and `is_deb`=3 limit 1"), new Object[] { sn, ip });
      if (hostInfo == null) {
        hostInfo = DbUtil.findFirstByCache(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host where `sn`=? and `ip`=? and `install_state`=2 and `is_deb`!=3  limit 1"), new Object[] { sn, ip });
      } else {
        return null;
      } 
    } else {
      hostInfo = DbUtil.findFirstByCache(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host where `sn`=? and `ip`=? and `install_state`=2 and `is_deb`!=3 limit 1"), new Object[] { sn, ip });
      if (hostInfo == null) {
        hostInfo = DbUtil.findFirstByCache(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host where `sn`=? and `ip`=? and `install_state`=2 and `is_deb`=3 limit 1"), new Object[] { sn, ip });
      } else {
        return null;
      } 
    } 
    return hostInfo;
  }
  
  public static Map<String, String> destroy(String hostId) {
    return destroy(hostId, true);
  }
  
  public static Map<String, String> destroy(String hostId, boolean notify) {
    SysLogicUtil.isParamBlank(hostId);
    Record hostIdInfo = getHostByIdDao(hostId);
    SysLogicUtil.isParamBlank(hostIdInfo, "主机信息不存在", "1501");
    if (hostIdInfo.getInt("install_state").intValue() == 1)
      SysLogicUtil.throwCustomException("主机已安装，不允许删除", "1502"); 
    if (hasHostAuth(hostId))
      SysLogicUtil.throwCustomException("主机下包含授权信息，不允许删除", "1502"); 
    Record canDel = SysLogicUtil.canDel("delete_host", hostId);
    int ret = canDel.getInt("ret").intValue();
    if (ret != 0) {
      String msg = StringKit.notBlank(canDel.getStr("msg")) ? canDel.getStr("msg") : "主机下包含绑定信息不允许删除";
      SysLogicUtil.throwCustomException(msg, "1205");
    } 
    try {
      DbUtil.update("tb_base_host_version", DbDialectUtil.getDbRuleFactory().dbField("delete from tb_base_host_version where `host_id`=?"), new Object[] { hostId });
      DbUtil.update("tb_base_host_extend", DbDialectUtil.getDbRuleFactory().dbField("delete from tb_base_host_extend where `host_id`=?"), new Object[] { hostId });
      String userId = showUserByHostId(hostId).getStr("user_id");
      DbUtil.deleteById("tb_base_host", "id", hostId);
      Db.update(DbDialectUtil.getDbRuleFactory().dbField("delete from tb_base_host_online where `host_id`="), new Object[] { hostId });
      HostCacheHelp.updateCache(userId);
      AuthoriseCompute.getAuthoriseCompute().deleteProductAuthWhenDelHost(hostId);
    } catch (Exception e) {
      e.printStackTrace();
      throw new ActiveRecordException(e);
    } 
    updateHostVersion(Collections.singletonList(hostId));
    Long hostVersion = SysParamHelp.getVersion("host");
    if (notify)
      SysLogicUtil.sendUpdateInfo("update_host", hostId, hostVersion); 
    Map<String, String> resultMap = new HashMap<>(4);
    resultMap.put("hostIds", hostId);
    return resultMap;
  }
  
  @Before({Tx.class})
  public static void forceDestroy(String hostIds, boolean delHost) {
    SysLogicUtil.isParamBlank(hostIds);
    try {
      String[] hostIdArr = hostIds.split(",");
      List<String> delUserIds = new ArrayList<>();
      List<String> hostList = Arrays.asList(hostIdArr);
      int batchSize = BaseGlobal.BATCH_SIZE.intValue();
      int interval = (int)Math.ceil(hostList.size() / BaseGlobal.BATCH_SIZE.doubleValue());
      int start = 0, end = 0;
      for (int i = 0; i < interval; i++) {
        start = i * batchSize;
        end = ((i + 1) * batchSize > hostList.size()) ? hostList.size() : ((i + 1) * batchSize);
        List<String> subList = hostList.subList(start, end);
        List<Object> params = new ArrayList();
        params.addAll(subList);
        String sql_bind = DbDialectUtil.getDbRuleFactory().dbField(" delete from tb_base_group_bind ");
        StringBuilder sql_bindBuilder = DbUtil.getSingleStatmentInSqlParam(subList, "`obj_id`", new StringBuilder(sql_bind));
        Db.update(sql_bindBuilder.toString(), params.toArray());
        String sql_version = DbDialectUtil.getDbRuleFactory().dbField(" delete from tb_base_host_procduct_version ");
        StringBuilder sql_versionBuilder = DbUtil.getSingleStatmentInSqlParam(subList, "`host_id`", new StringBuilder(sql_version));
        Db.update(sql_versionBuilder.toString(), params.toArray());
        String sql_antivirus = DbDialectUtil.getDbRuleFactory().dbField(" delete from tb_base_asset_antivirus ");
        StringBuilder sql_antivirusBuilder = DbUtil.getSingleStatmentInSqlParam(subList, "`host_id`", new StringBuilder(sql_antivirus));
        Db.update(sql_antivirusBuilder.toString(), params.toArray());
        String sql_change = DbDialectUtil.getDbRuleFactory().dbField(" delete from tb_base_asset_change ");
        StringBuilder sql_changeBuilder = DbUtil.getSingleStatmentInSqlParam(subList, "`host_id`", new StringBuilder(sql_change));
        Db.update(sql_changeBuilder.toString(), params.toArray());
        String sql_hardware = DbDialectUtil.getDbRuleFactory().dbField(" delete from tb_base_asset_hardware ");
        StringBuilder sql_hardwareBuilder = DbUtil.getSingleStatmentInSqlParam(subList, "`host_id`", new StringBuilder(sql_hardware));
        Db.update(sql_hardwareBuilder.toString(), params.toArray());
        String sql_patch = DbDialectUtil.getDbRuleFactory().dbField(" delete from tb_base_asset_patch ");
        StringBuilder sql_patchBuilder = DbUtil.getSingleStatmentInSqlParam(subList, "`host_id`", new StringBuilder(sql_patch));
        Db.update(sql_patchBuilder.toString(), params.toArray());
        String sql_repair = DbDialectUtil.getDbRuleFactory().dbField(" delete from tb_base_asset_repair ");
        StringBuilder sql_repairBuilder = DbUtil.getSingleStatmentInSqlParam(subList, "`host_id`", new StringBuilder(sql_repair));
        Db.update(sql_repairBuilder.toString(), params.toArray());
        String sql_software = DbDialectUtil.getDbRuleFactory().dbField(" delete from tb_base_asset_software ");
        StringBuilder sql_softwareBuilder = DbUtil.getSingleStatmentInSqlParam(subList, "`host_id`", new StringBuilder(sql_software));
        Db.update(sql_softwareBuilder.toString(), params.toArray());
        String sql_extend = DbDialectUtil.getDbRuleFactory().dbField(" delete from tb_base_host_extend ");
        StringBuilder sql_extendBuilder = DbUtil.getSingleStatmentInSqlParam(subList, "`host_id`", new StringBuilder(sql_extend));
        Db.update(sql_extendBuilder.toString(), params.toArray());
        if (delHost) {
          List<Record> userRecord = showUserByHostId(subList);
          delUserIds.addAll((Collection<? extends String>)userRecord.stream().map(record -> record.getStr("user_id")).collect(Collectors.toList()));
          String sql_host = DbDialectUtil.getDbRuleFactory().dbField(" delete from tb_base_host ");
          StringBuilder sql_hostBuilder = DbUtil.getSingleStatmentInSqlParam(subList, "`id`", new StringBuilder(sql_host));
          Db.update(sql_hostBuilder.toString(), params.toArray());
          AuthoriseCompute.getAuthoriseCompute().deleteProductAuthWhenDelHost(subList);
          SysParamHelp.updateVersion("host");
          Long hostVersion = SysParamHelp.getVersion("host");
          subList.forEach(id -> SysLogicUtil.sendUpdateInfo("update_host", id, hostVersion));
        } 
        HostCacheHelp.updateCache(delUserIds);
      } 
    } catch (Exception e) {
      e.printStackTrace();
      throw new ActiveRecordException(e);
    } 
  }
  
  public static String create(String source) {
    return create(source, "");
  }
  
  public static String createHostNac(String source, String id) {
    Record HostRecord = getSimpleHostByIdDao(id);
    if (HostRecord != null)
      SysLogicUtil.throwCustomException("主机已存在", "1504"); 
    SysLogicUtil.isParamBlank(source);
    Record record = SysLogicUtil.getRecord(source);
    String org_id = record.getStr("org_id");
    if (StringKit.isBlank(org_id)) {
      SysLogicUtil.throwCustomException("组织机构不存在", "1505");
    } else {
      Record orgRecord = OrgaHelp.getOrgaByIdDao(org_id);
      if (orgRecord == null)
        SysLogicUtil.throwCustomException("组织机构不存在", "1505"); 
    } 
    String userName = record.getStr("user_name");
    Record userRecord = UserHelp.showOrgUserName(org_id, userName);
    if (userRecord == null) {
      Record userRecored = new Record();
      userRecored.set("name", userName);
      userRecored.set("org_id", org_id);
      String userId = UserHelp.simpleCreate(JsonKit.toJson(userRecored), true);
      record.set("user_id", userId);
    } else {
      String userId = userRecord.getStr("id");
      record.set("user_id", userId);
    } 
    String ip = record.getStr("ip");
    if (StringKit.notBlank(ip))
      if (StringKit.notBlank(userName)) {
        record.set("name", userName + "主机");
      } else {
        ip = ip.replaceAll(".", "一");
        record.set("name", ip);
      }  
    record.remove("user_name");
    record.remove("org_id");
    record.set("type", Integer.valueOf(1));
    record.set("install_state", Integer.valueOf(0));
    return save(record, id, true, true);
  }
  
  public static String create(String source, String id) {
    SysLogicUtil.isParamBlank(source);
    Record record = SysLogicUtil.getRecord(source);
    if (StringKit.isBlank(record.getStr("user_id")) || UserHelp.getSimpleUserByIdDao(record.getStr("user_id")) == null)
      SysLogicUtil.throwCustomException("主机用户不存在", "1503"); 
    return save(record, id);
  }
  
  public static String getUserErrorMessages(int orgNo, int org_user_work, int userJob) {
    String errors = "";
    if (orgNo == 2)
      errors = errors + "用户组织机构编码,"; 
    if (org_user_work == 2)
      errors = errors + "用户工作证号,"; 
    if (userJob == 2)
      errors = errors + "用户职务,"; 
    if (StringKit.notBlank(errors)) {
      int lindex = errors.lastIndexOf(",");
      errors = errors.substring(0, lindex);
    } 
    return errors;
  }
  
  public static String getHostErrorMessages(Record record, int hostclass, int hostroom, int hostcode, int fixedno, int equse, int typenew) {
    String host_class = (String)record.get("host_class");
    String room_num = (String)record.get("room_num");
    String host_code = (String)record.get("code");
    String fixed_no = (String)record.get("fixed_no");
    String eq_use = (String)record.get("eq_use");
    String type_new = record.getStr("type_new");
    String errors = "";
    if (hostclass == 2 && StringKit.isBlank(host_class))
      errors = errors + "主机机器类型,"; 
    if (hostroom == 2 && StringKit.isBlank(room_num))
      errors = errors + "主机房间号,"; 
    if (hostcode == 2 && StringKit.isBlank(host_code))
      errors = errors + "主机编码,"; 
    if (fixedno == 2 && StringKit.isBlank(fixed_no))
      errors = errors + "固定资产编号,"; 
    if (equse == 2 && StringKit.isBlank(eq_use))
      errors = errors + "用途,"; 
    if (typenew == 2 && StringKit.isBlank(type_new))
      errors = errors + "型号,"; 
    if (StringKit.notBlank(errors)) {
      int lindex = errors.lastIndexOf(",");
      errors = errors.substring(0, lindex);
    } 
    return errors;
  }
  
  public static int getSysparamValue(String paramname) {
    String id = "";
    int paramvalue = 0;
    if ("host_class".equals(paramname)) {
      id = "F9E5DB84-DF81-429B-96DE-9954DC8A5006";
    } else if ("host_room".equals(paramname)) {
      id = "F9E5DB84-DF81-429B-96DE-9954DC8A5008";
    } else if ("host_code".equals(paramname)) {
      id = "F9E5DB84-DF81-429B-96DE-9954DC8A5010";
    } else if ("fixed_no".equals(paramname)) {
      id = "F4C885F8-1437-YYYY-LLLL-963BDAAD2601";
    } else if ("eq_use".equals(paramname)) {
      id = "F4C885F8-1437-YYYY-LLLL-963BDAAD2602";
    } else if ("type_new".equals(paramname)) {
      id = "F4C885F8-1437-YYYY-LLLL-963BDAAD2603";
    } 
    Record sysparamRecord = SysParamHelp.show(id);
    if (sysparamRecord != null)
      paramvalue = LogicUtil.parseIntSafe(sysparamRecord.getStr("param_value")); 
    return paramvalue;
  }
  
  public static String excelImport(String source, String totalsize) {
    List<Record> recordList = new ArrayList<>();
    try {
      recordList = SysLogicUtil.getExportRecords(source);
    } catch (CustomException ex) {
      throw new CustomException("文件内容不正确", "9997");
    } 
    if (recordList.size() == 0)
      return ""; 
    StringBuffer msgBuffer = new StringBuffer();
    List<Record> addOrgRecords = Lists.newArrayList();
    List<Record> addUserRecords = Lists.newArrayList();
    List<Record> addHostRecords = Lists.newArrayList();
    List<Record> updateHostRecords = Lists.newArrayList();
    Set<String> orgIds = Sets.newHashSet();
    Set<String> userIds = Sets.newHashSet();
    Set<String> hostIds = Sets.newHashSet();
    Set<Integer> orgHash = Sets.newHashSet();
    Set<Integer> userHash = Sets.newHashSet();
    List<Record> orgRecords = DbUtil.findByCache(DbDialectUtil.getDbRuleFactory().dbField("select `id`,`name`,`parent_id`,`status`,`node_id` from tb_base_org where status !=2"));
    LogicUtil.setFullOrgPath(orgRecords, "id", "org_path", "", false);
    Map<String, String> parentIds = Maps.newHashMap();
    Map<String, String> orgIdMappingNodeIdMap = Maps.newHashMap();
    Map<String, String> parentStatus = Maps.newHashMap();
    for (Record r : orgRecords) {
      String orgPath = r.getStr("org_path");
      if (null != orgPath && !"".equals(orgPath))
        orgHash.add(Integer.valueOf(orgPath.hashCode())); 
      parentIds.put(orgPath, r.getStr("id"));
      parentStatus.put(orgPath, String.valueOf(r.getInt("status")));
      orgIds.add(r.getStr("id"));
      orgIdMappingNodeIdMap.put(r.getStr("id"), r.getStr("node_id"));
    } 
    List<Record> userRecords = DbUtil.findByCache(DbDialectUtil.getDbRuleFactory().dbField("select `id`,`name`,`org_id`,`node_id` from tb_base_user where u_status !=2 "));
    Map<Integer, String> userMap = Maps.newHashMap();
    Map<String, String> userIdMappingNodeIdMap = Maps.newHashMap();
    for (Record u : userRecords) {
      String uid = u.getStr("id");
      String orgId = u.getStr("org_id");
      int ucode = (u.getStr("name") + orgId).hashCode();
      userHash.add(Integer.valueOf(ucode));
      userMap.put(Integer.valueOf(ucode), uid);
      userIdMappingNodeIdMap.put(uid, u.getStr("node_id"));
    } 
    OrgaHelp.getCurrentNodeIdDao();
    int orgNo = 0;
    Record orgNoInfo = SysParamHelp.show("F9E5DB84-DF81-429B-96DE-9954DC8A5011");
    if (orgNoInfo != null)
      orgNo = LogicUtil.parseIntSafe(orgNoInfo.getStr("param_value")); 
    int org_user_work = 0;
    Record orgUserWorkNum = SysParamHelp.show("F9E5DB84-DF81-429B-96DE-9954DC8A5007");
    if (orgUserWorkNum != null)
      org_user_work = LogicUtil.parseIntSafe(orgUserWorkNum.getStr("param_value")); 
    int userJob = 0;
    Record userJobRecord = SysParamHelp.show("F9E5DB84-DF81-429B-96DE-9954DC8A5005");
    if (userJobRecord != null)
      userJob = LogicUtil.parseIntSafe(userJobRecord.getStr("param_value")); 
    boolean isCheck = false;
    if (orgNo == 2 || org_user_work == 2 || userJob == 2)
      isCheck = true; 
    int newUnitCount = 0;
    for (Record record : recordList) {
      Record hostRecord = new Record();
      String rowindex = (String)record.get("rowindex");
      String userName = (String)record.get("user_name");
      String orgaNames = (String)record.get("org_name");
      String region = (String)record.get("region");
      if (StringKit.isBlank(orgaNames) || orgaNames.length() <= 0)
        continue; 
      if (orgaNames.substring(0, 1).equals("\\"))
        orgaNames = orgaNames.substring(1, orgaNames.length()); 
      String trimOrgNames = trimOrg(orgaNames);
      String[] orgaName = orgaNames.split("\\\\");
      String node_id = BaseGlobal.getCurrentNodeId();
      String orgFullName = BaseGlobal.getCurrentNodeName();
      boolean isScuess = false;
      String parentStatuStr = "1";
      if (!orgFullName.equals(trimOrgNames) && !orgFullName.equals(trimOrg(orgaName[0])))
        trimOrgNames = orgFullName + "\\" + trimOrgNames; 
      if (!orgHash.contains(Integer.valueOf(trimOrgNames.hashCode()))) {
        for (String orgname : orgaName) {
          String trimOrgname = trimOrg(orgname);
          if (!orgFullName.equals(trimOrgname))
            orgFullName = orgFullName + "\\" + trimOrgname; 
          if (orgHash.contains(Integer.valueOf(orgFullName.hashCode()))) {
            node_id = parentIds.get(orgFullName);
            parentStatuStr = parentStatus.get(orgFullName);
            if (StringKit.isBlank(parentStatuStr))
              parentStatuStr = "1"; 
          } else {
            if (isCheck) {
              String usererrormsg = getUserErrorMessages(orgNo, org_user_work, userJob);
              isScuess = true;
              msgBuffer.append("第" + rowindex + "行" + orgaNames + "下用户:" + userName + "存在必填项【" + usererrormsg + "】无法自动创建，此用户下的主机导入失败。<br>");
              break;
            } 
            String parentOrgNodeId = orgIdMappingNodeIdMap.get(node_id);
            if (!SysLogicUtil.isCurrentNodeData(parentOrgNodeId)) {
              msgBuffer.append("第" + rowindex + "行不能导入(非本级站点部门下禁止创建子部门)。<br/>");
              isScuess = true;
              break;
            } 
            Record creOrgRecord = new Record();
            String id = SysLogicUtil.getUUID();
            creOrgRecord.set("parent_id", node_id);
            creOrgRecord.set("id", id);
            creOrgRecord.set("name", trimOrgname);
            creOrgRecord.set("region", region);
            creOrgRecord.set("custom_org", Integer.valueOf(0));
            creOrgRecord.set("status", Integer.valueOf(LogicUtil.parseIntSafe(parentStatuStr)));
            if (orgname.startsWith("[") && orgname.endsWith("]")) {
              creOrgRecord.set("flag", Integer.valueOf(1));
              newUnitCount++;
            } else if (orgname.startsWith("{") && orgname.endsWith("}")) {
              creOrgRecord.set("flag", Integer.valueOf(3));
            } else {
              creOrgRecord.set("flag", Integer.valueOf(0));
            } 
            node_id = id;
            parentIds.put(orgFullName, node_id);
            orgIdMappingNodeIdMap.put(node_id, BaseGlobal.getCurrentNodeId());
            parentStatus.put(orgFullName, parentStatuStr);
            orgHash.add(Integer.valueOf(orgFullName.hashCode()));
            addOrgRecords.add(creOrgRecord);
          } 
        } 
      } else {
        node_id = parentIds.get(trimOrgNames);
      } 
      if (isScuess)
        continue; 
      String userId = "";
      int hashCode = (userName + node_id).hashCode();
      if (!userHash.contains(Integer.valueOf(hashCode))) {
        if (isCheck) {
          isScuess = true;
          String usererrormsg = getUserErrorMessages(orgNo, org_user_work, userJob);
          msgBuffer.append("第" + rowindex + "行" + orgaNames + "用户:" + userName + "存在必填项【" + usererrormsg + "】无法自动创建，此用户下的主机导入失败<br>");
          continue;
        } 
        String orgNodeId = orgIdMappingNodeIdMap.get(node_id);
        if (!SysLogicUtil.isCurrentNodeData(orgNodeId)) {
          msgBuffer.append("第" + rowindex + "行不能导入(非本级站点部门下禁止创建用户)。<br/>");
          continue;
        } 
        Record user = new Record();
        String id = SysLogicUtil.getUUID();
        userId = id;
        user.set("name", userName);
        user.set("org_id", node_id);
        user.set("node_id", BaseGlobal.getCurrentNodeId());
        user.set("id", id);
        user.set("custom_user", Integer.valueOf(0));
        user.set("create_date", SysLogicUtil.nowDateTime());
        Record sysRecord = SysParamHelp.SysPlatform();
        if (sysRecord != null && "military".equals(sysRecord.get("param_value"))) {
          user.set("pwduser", record.get("pwduser"));
          user.set("keyuser", record.get("keyuser"));
        } 
        userIds.add(id);
        addUserRecords.add(user);
        userHash.add(Integer.valueOf(hashCode));
        userMap.put(Integer.valueOf(hashCode), id);
        userIdMappingNodeIdMap.put(id, BaseGlobal.getCurrentNodeId());
      } else {
        userId = userMap.get(Integer.valueOf(hashCode));
      } 
      String userNodeId = userIdMappingNodeIdMap.get(userId);
      if (!SysLogicUtil.isCurrentNodeData(userNodeId)) {
        msgBuffer.append("第" + rowindex + "行不能导入(非本级站点用户下禁止创建主机)。<br/>");
        continue;
      } 
      String name = (String)record.get("name");
      String installCode = (String)record.get("install_code");
      installCode = installCode.trim();
      String ipString = (String)record.get("ip");
      String mac = (String)record.get("mac");
      if (ObjectUtil.isEmpty(installCode)) {
        hostRecord.set("id", SysLogicUtil.getUUID());
        String str1 = (String)record.get("type");
        str1 = "联网".equals(str1) ? "1" : "0";
        hostRecord.set("name", name);
        hostRecord.set("ip", record.get("ip"));
        hostRecord.set("user_id", userId);
        hostRecord.set("sn", record.get("sn"));
        hostRecord.set("mac", record.get("mac"));
        hostRecord.set("code", record.get("code"));
        hostRecord.set("room_num", record.get("room_num"));
        String host_class = (String)record.get("host_class");
        if (StringKit.isBlank(host_class)) {
          hostRecord.set("host_class", Integer.valueOf(-1));
        } else {
          hostRecord.set("host_class", Integer.valueOf(LogicUtil.parseIntSafe(record.getStr("host_class"))));
        } 
        hostRecord.set("fixed_no", record.get("fixed_no"));
        hostRecord.set("eq_use", record.get("eq_use"));
        hostRecord.set("type_new", record.get("type_new"));
        hostRecord.set("node_id", BaseGlobal.getCurrentNodeId());
        hostRecord.set("type", Integer.valueOf(LogicUtil.parseIntSafe(str1)));
        String sec_level = record.getStr("sec_level");
        if (StringKit.isBlank(sec_level))
          sec_level = "0"; 
        hostRecord.set("sec_level", Integer.valueOf(LogicUtil.parseIntSafe(record.getStr("sec_level"))));
        installCode = getInstallCode();
        hostRecord.set("install_code", installCode);
        hostRecord.set("osversioninfo", "");
        if (StringKit.isBlank((String)record.get("oper_sys"))) {
          hostRecord.set("oper_sys", "window_32");
        } else {
          hostRecord.set("oper_sys", "");
        } 
        if (StringKit.notBlank(record.getStr("ip"))) {
          Long ipval = Long.valueOf(LogicUtil.ipToLong(record.getStr("ip")));
          hostRecord.set("ipval", ipval);
        } else {
          record.set("ipval", Long.valueOf(Long.parseLong("0")));
        } 
        hostIds.add(hostRecord.getStr("id"));
        addHostRecords.add(hostRecord);
        continue;
      } 
      Record host = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select `id`,`node_id` from tb_base_host where `install_code`=?"), new Object[] { installCode });
      if (ObjectUtil.isEmpty(host)) {
        msgBuffer.append("第" + rowindex + "行，安装码（" + installCode + "）对应主机不存在<br>");
        continue;
      } 
      String hostNodeId = host.getStr("node_id");
      if (!SysLogicUtil.isCurrentNodeData(hostNodeId)) {
        msgBuffer.append("第" + rowindex + "行不能导入(非本级站点主机禁止修改)。<br/>");
        continue;
      } 
      String type = (String)record.get("type");
      type = "联网".equals(type) ? "1" : "0";
      hostRecord.set("user_id", userId);
      hostRecord.set("name", name);
      hostRecord.set("ip", record.get("ip"));
      hostRecord.set("mac", record.get("mac"));
      hostRecord.set("sn", record.get("sn"));
      hostRecord.set("sec_level", Integer.valueOf(LogicUtil.parseIntSafe(record.getStr("sec_level"))));
      hostRecord.set("type", Integer.valueOf(LogicUtil.parseIntSafe(type)));
      hostRecord.set("code", record.get("code"));
      hostRecord.set("room_num", record.get("room_num"));
      hostRecord.set("install_code", installCode);
      updateHostRecords.add(hostRecord);
    } 
    if (newUnitCount > 0) {
      Record sysParamRecord = SysParamHelp.show("F9E5DB84-DF81-429B-96DE-9954DC8A6001");
      int orgMaxSize = 0;
      if (sysParamRecord != null && StringKit.notBlank(sysParamRecord.getStr("param_value")))
        orgMaxSize = Integer.valueOf(sysParamRecord.getStr("param_value")).intValue(); 
      if (orgMaxSize != 0) {
        Long currentUnitCount = OrgaHelp.queryUnitCount();
        if (currentUnitCount.longValue() + newUnitCount > orgMaxSize)
          return "单位数量[" + (currentUnitCount.longValue() + newUnitCount) + "]已超出组织机构单位最大数[" + orgMaxSize + "]，请修改Excel数据"; 
      } 
    } 
    int successCount = addHostRecords.size() + updateHostRecords.size();
    int rowCount = LogicUtil.parseIntSafe(totalsize);
    if (rowCount > 0 && rowCount != successCount) {
      String tips = "成功导入主机<em style='color:red'>" + successCount + "条</em>，未导入<em style='color:red'>" + (rowCount - successCount) + "条</em>，请将未导入的信息修改正确，再重新导入或手工录入。";
      msgBuffer.insert(0, "<em style='color:red'>" + tips + "</em><br/>");
    } 
    OrgaHelp.create_batch(addOrgRecords);
    UserHelp.create_batch(addUserRecords);
    tcreate_batch(addHostRecords);
    List<String> updateHostIds = tupdate_batch(updateHostRecords);
    hostIds.addAll(updateHostIds);
    if (CollUtil.isNotEmpty(orgIds))
      NotifyInterceptor.updateOrgVersion(new ArrayList<>(orgIds)); 
    SysLogicUtil.sendUpdateInfo("update_org", Joiner.on(",").join((Iterable)orgIds), SysParamHelp.getVersion("org"));
    SysLogicUtil.sendUpdateInfo("update_user", Joiner.on(",").join((Iterable)userIds), SysParamHelp.getVersion("user"));
    SysLogicUtil.sendUpdateInfo("update_host", Joiner.on(",").join((Iterable)hostIds), SysParamHelp.getVersion("host"));
    return msgBuffer.toString();
  }
  
  private static void tcreate_batch(List<Record> records) {
    if (records.size() != 0) {
      String sql = DbDialectUtil.getDbRuleFactory().dbField("insert into tb_base_host(`host_class`,`fixed_no`,`type_new`,`eq_use`,`id`,`name`,`ip`,`user_id`,`sn`,`mac`,`code`,`room_num`,`type`,`node_id`,`sec_level`,`install_code`,`osversioninfo`,`oper_sys`,`create_date`,`last_modify_date`,`ipval`) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,'" + SysLogicUtil.nowDateTime() + "','" + SysLogicUtil.nowDateTime().toString() + "',?)");
      DbUtil.batch(sql, "host_class,fixed_no,type_new,eq_use,id,name,ip,user_id,sn,mac,code,room_num,type,node_id,sec_level,install_code,osversioninfo,oper_sys,ipval", records, 500, new String[] { "tb_base_host" });
      CacheKit.remove("defaultCache", "tb_base_host");
      ArrayList<String> ids = new ArrayList<>(records.size());
      ArrayList<String> userIds = new ArrayList<>(records.size());
      for (Record record : records) {
        ids.add(record.getStr("id"));
        userIds.add(record.get("user_id"));
      } 
      HostCacheHelp.updateCache(userIds);
      updateHostVersion(ids);
      HostOnlineHelp.batchCreate(records);
    } 
  }
  
  private static List<String> tupdate_batch(List<Record> records) {
    List<String> hostIds = new ArrayList<>();
    List<String> userIds = new ArrayList<>();
    if (ObjectUtil.isNotEmpty(records)) {
      for (Record record : records) {
        DbUtil.update("tb_base_host", 
            DbDialectUtil.getDbRuleFactory().dbField("UPDATE `tb_base_host` SET `user_id` = ?,`name` = ?,`ip` = ?,`mac` = ?,`sn` = ?,`sec_level` = ?,   `type` = ?, `code` = ?,`room_num` = ? WHERE `install_code` = ? "), new Object[] { record

              
              .getStr("user_id"), record.getStr("name"), record.getStr("ip"), record.getStr("mac"), record
              .getStr("sn"), record.getInt("sec_level"), record.getInt("type"), record.getStr("code"), record
              .getStr("room_num"), record.getStr("install_code") });
        Record host = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select `id` from tb_base_host where `install_code`=?"), new Object[] { record.getStr("install_code") });
        hostIds.add(host.getStr("id"));
        userIds.add(record.getStr("user_id"));
      } 
      HostCacheHelp.updateCache(userIds);
      updateHostVersion(hostIds);
      for (String hostId : hostIds)
        updateInfoVersion(hostId); 
    } 
    return hostIds;
  }
  
  private static void create_batch(List<Record> records) {
    if (!records.isEmpty()) {
      String sql = DbDialectUtil.getDbRuleFactory().dbField("insert into tb_base_host(`id`,`name`,`ip`,`user_id`,`sn`,`mac`,`code`,`room_num`,`type`,`node_id`,`sec_level`,`install_code`,`osversioninfo`,`oper_sys`,`create_date`,`last_modify_date`,`ipval`) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,'" + SysLogicUtil.nowDateTime() + "','" + SysLogicUtil.nowDateTime().toString() + "',?)");
      DbUtil.batch(sql, "id,name,ip,user_id,sn,mac,code,room_num,type,node_id,sec_level,install_code,osversioninfo,oper_sys,ipval", records, 500, new String[] { "tb_base_host" });
      CacheKit.remove("defaultCache", "tb_base_host");
      ArrayList<String> ids = new ArrayList<>(records.size());
      ArrayList<String> userIds = new ArrayList<>(records.size());
      for (Record record : records) {
        ids.add(record.getStr("id"));
        userIds.add(record.get("user_id"));
      } 
      HostCacheHelp.updateCache(userIds);
      updateHostVersion(ids);
      HostOnlineHelp.batchCreate(records);
    } 
  }
  
  public static void create_batch_dataService(List<Record> records) {
    if (records.size() != 0) {
      ArrayList<String> ids = new ArrayList<>(records.size());
      ArrayList<String> userIds = new ArrayList<>(records.size());
      String sql = DbDialectUtil.getDbRuleFactory().dbField("insert into tb_base_host(`id`,`name`,`ip`,`user_id`,`sn`,`mac`,`code`,`room_num`,`type`,`node_id`,`sec_level`,`install_code`,`dataservice`,`sid`,`create_date`,`last_modify_date`,`ipval`) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,'" + SysLogicUtil.nowDateTime().toString() + "','" + SysLogicUtil.nowDateTime().toString() + "',?)");
      for (Record record : records) {
        if (StringKit.notBlank(record.getStr("ip"))) {
          Long ipval = Long.valueOf(LogicUtil.ipToLong(record.getStr("ip")));
          record.set("ipval", ipval);
        } else {
          record.set("ipval", Long.valueOf(0L));
        } 
        Db.update(sql, new Object[] { 
              record.getStr("id"), record.getStr("name"), record.getStr("ip"), record.getStr("user_id"), record.getStr("sn"), record.getStr("mac"), record.getStr("code"), record.getStr("room_num"), record.getStr("type"), record.getStr("node_id"), 
              record.getStr("sec_level"), record.getStr("install_code"), record.getStr("dataservice"), record.getStr("sid"), record.getLong("ipval") });
        userIds.add(record.get("user_id"));
        HostOnlineHelp.create(record.getStr("id"));
        ids.add(record.getStr("id"));
      } 
      HostCacheHelp.updateCache(userIds);
      CacheKit.remove("defaultCache", "tb_base_host");
      updateHostVersion(ids);
    } 
  }
  
  public static void szgd_create_batch_dataService(List<Record> records) {
    if (records.size() != 0) {
      Calendar calendar = Calendar.getInstance();
      calendar.setTime(new Date());
      calendar.set(12, -5);
      String newDateTime = (new SimpleDateFormat("yyyy-MM-dd HH:mm:ss")).format(calendar.getTime());
      String sql = DbDialectUtil.getDbRuleFactory().dbField("insert into tb_base_host(`id`,`name`,`ip`,`user_id`,`sn`,`mac`,`code`,`room_num`,`type`,`node_id`,`sec_level`,`install_code`,`dataservice`,`sid`,`create_date`,`last_modify_date`,`ipval`,`online_state`,`install_state`,`oper_sys`,`osversioninfo`,`sync_state`,`p_sync_state`,`remark`,`unreg_date`,`feature`,`reg_date`) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?," + DbDialectUtil.getDbFunFactory().datetimeFormat("?") + "," + DbDialectUtil.getDbFunFactory().datetimeFormat("?") + ",?,?,?,?,?,?,?,?," + DbDialectUtil.getDbFunFactory().datetimeFormat("?") + "," + DbDialectUtil.getDbFunFactory().datetimeFormat("?") + ",?," + DbDialectUtil.getDbFunFactory().datetimeFormat("?") + ")");
      ArrayList<Record> newRecords = new ArrayList<>();
      ArrayList<String> ids = new ArrayList<>(records.size());
      ArrayList<String> userIds = new ArrayList<>(records.size());
      for (Record record : records) {
        if (StringKit.notBlank(record.getStr("ip"))) {
          Long ipval = Long.valueOf(LogicUtil.ipToLong(record.getStr("ip")));
          record.set("ipval", ipval);
        } else {
          record.set("ipval", Long.valueOf(0L));
        } 
        newRecords.add(record);
        ids.add(record.getStr("id"));
        userIds.add(record.get("user_id"));
      } 
      DbUtil.batch(sql, "id,name,ip,user_id,sn,mac,code,room_num,type,node_id,sec_level,install_code,dataservice,sid,create_date,last_modify_date,ipval,online_state,install_state,oper_sys,osversioninfo,sync_state,p_sync_state,remark,unreg_date,feature,reg_date`", newRecords, 500, new String[] { "tb_base_host" });
      HostCacheHelp.updateCache(userIds);
      CacheKit.remove("defaultCache", "tb_base_host");
      updateHostVersion(ids);
      HostOnlineHelp.batchCreate(records);
    } 
  }
  
  public static void szgd_update_batch_sec_dataService(List<Record> records) {
    if (records.size() != 0) {
      String sql = DbDialectUtil.getDbRuleFactory().dbField("update tb_base_host set `name`=? ,`user_id`=?,`dataservice`=?,`sid`=?,`last_modify_date`=? ,`sn`=?,`mac`=?,`oper_sys`=? ,`online_state`=?,`install_state`=?,`type`=?,`sec_level`=?,`node_id`=?,`install_code`=?,`code`=?,`remark`=?,`create_date`=?,`reg_date`=?,`last_modify_date`=? where `id`=?");
      ArrayList<String> ids = new ArrayList<>(records.size());
      ArrayList<String> userIds = new ArrayList<>(records.size());
      for (Record record : records) {
        String dataservice = record.getStr("dataservice");
        if (StringKit.isBlank(dataservice))
          dataservice = ""; 
        String sid = record.getStr("sid");
        if (StringKit.isBlank(sid))
          sid = ""; 
        Record userIdRecode = showUserByHostId(record.getStr("id"));
        Db.update(sql, new Object[] { 
              record.getStr("name"), record.getStr("user_id"), record.getStr("dataservice"), record.getStr("sid"), SysLogicUtil.nowDateTime(), record.getStr("sn"), record.getStr("mac"), record.getStr("oper_sys"), record.getStr("online_state"), record.getStr("install_state"), 
              record.getStr("type"), record.getStr("sec_level"), record.getStr("node_id"), record.getStr("install_code"), record.getStr("code"), record.getStr("remark"), record.getStr("create_date"), record.getStr("reg_date"), record.getStr("last_modify_date"), record.getStr("id") });
        if (StringKit.notBlank(userIdRecode.getStr("user_id")))
          userIds.add(userIdRecode.getStr("user_id")); 
        if (StringKit.notBlank(record.getStr("user_id")))
          userIds.add(record.get("user_id")); 
        ids.add(record.getStr("id"));
      } 
      HostCacheHelp.updateCache(userIds);
      CacheKit.removeAll("defaultCache");
      updateHostVersion(ids);
    } 
  }
  
  public static void update_batch_sec_dataService(List<Record> records) {
    if (records.size() != 0) {
      String sql = DbDialectUtil.getDbRuleFactory().dbField("update tb_base_host set `name`=? ,`user_id`=?,`dataservice`=?,`sid`=?,`last_modify_date`=? ,`sn`=?,`mac`=? where `id`=?");
      ArrayList<String> ids = new ArrayList<>(records.size());
      ArrayList<String> userIds = new ArrayList<>(records.size());
      for (Record record : records) {
        String dataservice = record.getStr("dataservice");
        if (StringKit.isBlank(dataservice))
          dataservice = ""; 
        String sid = record.getStr("sid");
        if (StringKit.isBlank(sid))
          sid = ""; 
        Record userIdRecode = showUserByHostId(record.getStr("id"));
        Db.update(sql, new Object[] { record.getStr("name"), record.getStr("user_id"), record.getStr("dataservice"), record.getStr("sid"), SysLogicUtil.nowDateTime(), record.getStr("sn"), record.getStr("mac"), record.getStr("id") });
        if (StringKit.notBlank(userIdRecode.getStr("user_id")))
          userIds.add(userIdRecode.getStr("user_id")); 
        if (StringKit.notBlank(record.getStr("user_id")))
          userIds.add(record.get("user_id")); 
        ids.add(record.getStr("id"));
      } 
      HostCacheHelp.updateCache(userIds);
      CacheKit.removeAll("defaultCache");
      updateHostVersion(ids);
    } 
  }
  
  public static void update_batch_dataService(List<Record> records) {
    if (records.size() != 0) {
      String sql = DbDialectUtil.getDbRuleFactory().dbField("update tb_base_host set `name`=? ,`user_id`=?,`dataservice`=?,`sid`=?,`last_modify_date`=? where `id`=?");
      ArrayList<String> ids = new ArrayList<>(records.size());
      ArrayList<String> userIds = new ArrayList<>(records.size());
      for (Record record : records) {
        String dataservice = record.getStr("dataservice");
        if (StringKit.isBlank(dataservice))
          dataservice = ""; 
        String sid = record.getStr("sid");
        if (StringKit.isBlank(sid))
          sid = ""; 
        Record userIdRecode = showUserByHostId(record.getStr("id"));
        Db.update(sql, new Object[] { record.getStr("name"), record.getStr("user_id"), record.getStr("dataservice"), record.getStr("sid"), SysLogicUtil.nowDateTime(), record.getStr("id") });
        if (StringKit.notBlank(userIdRecode.getStr("user_id")))
          userIds.add(userIdRecode.getStr("user_id")); 
        if (StringKit.notBlank(record.getStr("user_id")))
          userIds.add(record.get("user_id")); 
        ids.add(record.getStr("id"));
      } 
      HostCacheHelp.updateCache(userIds);
      CacheKit.removeAll("defaultCache");
      updateHostVersion(ids);
    } 
  }
  
  public static void create_sys_batch(String source) {
    List<Record> oldRecords = SysLogicUtil.getRecords(source);
    List<Record> records = new ArrayList<>();
    if (oldRecords.size() != 0) {
      ArrayList<String> ids = new ArrayList<>(oldRecords.size());
      ArrayList<String> userIds = new ArrayList<>(oldRecords.size());
      for (Record record : oldRecords) {
        if (StringKit.notBlank(record.getStr("ip"))) {
          Long ipval = Long.valueOf(LogicUtil.ipToLong(record.getStr("ip")));
          record.set("ipval", ipval);
        } else {
          record.set("ipval", "0");
        } 
        records.add(record);
        ids.add(record.getStr("id"));
        userIds.add(record.getStr("user_id"));
      } 
      String sql = DbDialectUtil.getDbRuleFactory().dbField("insert into tb_base_host(`id`,`name`,`ip`,`user_id`,`sn`,`mac`,`code`,`room_num`,`type`,`node_id`,`sec_level`,`install_code`,`create_date`,`last_modify_date`,`ipval`) values(?,?,?,?,?,?,?,?,?,?,?,?,'" + SysLogicUtil.nowDateTime().toString() + "','" + SysLogicUtil.nowDateTime().toString() + "',?)");
      DbUtil.batch(sql, "id,name,ip,user_id,sn,mac,code,room_num,type,node_id,sec_level,install_code,ipval", records, 500, new String[] { "tb_base_host" });
      CacheKit.remove("defaultCache", "tb_base_host");
      HostCacheHelp.updateCache(userIds);
      updateHostVersion(ids);
      HostOnlineHelp.batchCreate(records);
    } 
  }
  
  public static void batchCreate(String source) {
    SysLogicUtil.isParamBlank(source);
    List<Record> recordList = SysLogicUtil.getRecords(source);
    ArrayList<String> ids = new ArrayList<>(recordList.size());
    for (Record record : recordList) {
      if (StringKit.isBlank(record.getStr("user_id")) || UserHelp.getSimpleUserByIdDao(record.getStr("user_id")) == null)
        SysLogicUtil.throwCustomException("主机用户不存在", "1503"); 
      save(record, "", false, false);
      ids.add(record.getStr("id"));
    } 
    updateHostVersion(ids);
  }
  
  public static String save(Record record) {
    return save(record, "");
  }
  
  public static String save(Record record, String id) {
    return save(record, id, false, true);
  }
  
  public static String save(Record record, String id, boolean isnac, boolean upVer) {
    OrgaHelp.getCurrentNodeIdDao();
    String installCode = getInstallCode();
    String uuid = id;
    while (true) {
      Record insCodeRecord = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host where `install_code`=? limit 1"), new Object[] { installCode });
      if (insCodeRecord == null)
        break; 
      installCode = getInstallCode();
    } 
    record.set("install_code", installCode);
    if (record.getStr("node_id") == null)
      record.set("node_id", BaseGlobal.getCurrentNodeId()); 
    if (StringKit.isBlank(uuid))
      uuid = SysLogicUtil.getUUID(); 
    record.set("id", uuid);
    SysLogicUtil.filterCurrentNodeData(record);
    String userId = record.getStr("user_id");
    Record simpleUserByIdDao = UserHelp.getSimpleUserByIdDao(userId);
    SysLogicUtil.filterCurrentNodeData(simpleUserByIdDao);
    String deviceSn = record.getStr("device_sn");
    String areaIp = record.getStr("area_ip");
    record.remove(new String[] { "sync_date", "orga_name", "user_name", "unreg_date", "online_timespan", "tel_num", "last_online_date", "device_sn", "area_ip" });
    record.set("reg_date", SysLogicUtil.nowDateTime());
    Record sysParamInfo = SysParamHelp.show("F4C885F8-1437-4991-814D-963BDAAD2188");
    String param = sysParamInfo.getStr("param_value");
    if ("1".equals(param) && StringKit.notBlank(id) && !isnac) {
      record.set("is_online_active", "1");
      record.set("install_state", "2");
      record.set("active_date", SysLogicUtil.nowDateTime());
    } 
    Record paramRecord = SysParamHelp.show("F4C885F8-1437-4991-814D-963BDAAD2197");
    if ("1".equals(paramRecord.getStr("param_value"))) {
      String type = record.getStr("type");
      if (StringKit.isBlank(type))
        type = "1"; 
      if (!"0".equals(type))
        record.set("auth_state", Integer.valueOf(1)); 
    } 
    record.set("create_date", SysLogicUtil.nowDateTime());
    record.set("last_modify_date", SysLogicUtil.nowDateTime());
    if (StringKit.notBlank(record.getStr("ip"))) {
      Long ipval = Long.valueOf(LogicUtil.ipToLong(record.getStr("ip")));
      record.set("ipval", ipval);
    } 
    record.remove("is_current_node_data");
    DbUtil.save("tb_base_host", "id", record);
    HostOnlineHelp.create(uuid);
    Record hostExtend = new Record();
    hostExtend.set("host_id", uuid);
    hostExtend.set("num", "0");
    hostExtend.set("products", "");
    hostExtend.set("host_policy_version", "1");
    hostExtend.set("device_sn", deviceSn);
    hostExtend.set("area_ip", areaIp);
    DbUtil.save("tb_base_host_extend", "id", hostExtend);
    createHostVersion(uuid, "1", 2);
    Record msg = new Record();
    msg.set("userId", record.getStr("user_id"));
    msg.set("hostId", uuid);
    msg.set("upVer", Boolean.valueOf(upVer));
    msg.set("isNotify", Boolean.valueOf(!isnac));
    HostAsyncHandleHelp.sendMsgToQueue(msg);
    return uuid;
  }
  
  public static String rpcSave(Record record, String id, boolean isnac) {
    OrgaHelp.getCurrentNodeIdDao();
    String installCode = getInstallCode();
    String uuid = id;
    while (true) {
      Record insCodeRecord = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host where `install_code`=? limit 1"), new Object[] { installCode });
      if (insCodeRecord == null)
        break; 
      installCode = getInstallCode();
    } 
    record.set("install_code", installCode);
    if (record.getStr("node_id") == null)
      record.set("node_id", BaseGlobal.getCurrentNodeId()); 
    if (StringKit.isBlank(uuid))
      uuid = SysLogicUtil.getUUID(); 
    record.set("id", uuid);
    record.remove(new String[] { "sync_date", "orga_name", "user_name", "unreg_date", "online_timespan", "tel_num" });
    record.set("reg_date", SysLogicUtil.nowDateTime());
    record.set("is_online_active", "1");
    record.set("install_state", "2");
    record.set("active_date", SysLogicUtil.nowDateTime());
    record.set("auth_state", Integer.valueOf(1));
    record.set("create_date", SysLogicUtil.nowDateTime());
    record.set("last_modify_date", SysLogicUtil.nowDateTime());
    if (StringKit.notBlank(record.getStr("ip")))
      try {
        String[] ips = record.getStr("ip").split(",");
        if (ips.length > 0) {
          Long ipval = Long.valueOf(LogicUtil.ipToLong(ips[0]));
          record.set("ipval", ipval);
        } 
      } catch (Exception exception) {} 
    DbUtil.save("tb_base_host", "id", record);
    HostOnlineHelp.create(uuid);
    Record hostExtend = new Record();
    hostExtend.set("host_id", uuid);
    hostExtend.set("num", "0");
    hostExtend.set("products", "");
    hostExtend.set("host_policy_version", "1");
    DbUtil.save("tb_base_host_extend", "id", hostExtend);
    updateHostVersion(Collections.singletonList(uuid));
    createHostVersion(uuid, "1");
    return uuid;
  }
  
  public static void batchUpdate(String ids, String option) {
    batchUpdate(ids, option, Boolean.valueOf(false), false);
  }
  
  public static void batchUpdate(String ids, String option, Boolean isUninstall, boolean isDelHostUser) {
    SysLogicUtil.isParamBlank(ids);
    String[] idArr = ids.split(",");
    boolean forceDestroyFlag = "5".equals(option);
    ArrayList<String> hostList = new ArrayList<>();
    ArrayList<String> userIds = new ArrayList<>();
    for (String id : idArr) {
      hostList.add(id);
      Record record = new Record();
      record.set("id", id);
      record.set("install_state", option);
      if ("2".equals(option)) {
        record.set("is_online_active", "1");
        record.set("active_date", SysLogicUtil.nowDateTime());
      } else if ("5".equals(option)) {
        record.set("unreg_date", SysLogicUtil.nowDateTime());
        if (isUninstall.booleanValue()) {
          record.set("remark", "已卸载");
        } else {
          record.set("remark", "强制注销");
        } 
        userIds.add(showUserByHostId(id).getStr("user_id"));
      } 
      if (forceDestroyFlag) {
        update(JsonKit.toJson(record), true, false);
      } else {
        if (isDelHostUser)
          record.set("uninstall_del_user", "1"); 
        update(JsonKit.toJson(record), true, false);
      } 
      addHostIdCatch(id);
    } 
    HostCacheHelp.updateCache(userIds);
    if (forceDestroyFlag) {
      forceDestroy(ids, false);
      SysParamHelp.updateVersion("host");
      Long hostVersion = SysParamHelp.getVersion("host");
      SysLogicUtil.sendUpdateInfo("update_host", ids, hostVersion);
    } 
  }
  
  public static void batchUpdateSec(String ids, String sec) {
    SysLogicUtil.isParamBlank(ids);
    String[] idArr = ids.split(",");
    for (String id : idArr) {
      Record record = new Record();
      record.set("id", id);
      record.set("sec_level", sec);
      update(JsonKit.toJson(record), true, false);
    } 
    SysLogicUtil.sendUpdateInfo("update_host", ids, null);
  }
  
  public static void update(String source) {
    update(source, true, true);
  }
  
  public static void update(String source, boolean isUpdateVersion, boolean notify) {
    SysLogicUtil.isParamBlank(source);
    Record record = SysLogicUtil.getRecord(source);
    Record user = null;
    if (StringKit.notBlank(record.getStr("user_id"))) {
      user = UserHelp.getSimpleUserByIdDao(record.getStr("user_id"));
      if (user == null)
        SysLogicUtil.throwCustomException("主机用户不存在", "1503"); 
    } 
    SysLogicUtil.isParamBlank(record.getStr("id"));
    record.remove(new String[] { "create_date", "orga_name", "user_name" });
    String id = record.getStr("id");
    if (isUpdateVersion) {
      record.set("sync_state", Integer.valueOf(0));
      updateInfoVersion(id);
    } 
    record.remove("dict_online_name");
    record.remove("auth_state");
    String state = record.getStr("install_state");
    record.set("last_modify_date", SysLogicUtil.nowDateTime());
    record.remove("online_timespan");
    if (StringKit.notBlank(record.getStr("ip"))) {
      Long ipval = Long.valueOf(LogicUtil.ipToLong(record.getStr("ip")));
      record.set("ipval", ipval);
    } 
    record.remove("tel_num");
    ArrayList<String> userIds = new ArrayList<>();
    Record userIdRecode = showUserByHostId(record.getStr("id"));
    DbUtil.update("tb_base_host", "id", record);
    if (StringKit.notBlank(userIdRecode.getStr("user_id")))
      userIds.add(userIdRecode.getStr("user_id")); 
    if (StringKit.notBlank(record.getStr("user_id")))
      userIds.add(record.get("user_id")); 
    Record msg = new Record();
    msg.set("userId", record.getStr("user_id"));
    msg.set("hostId", id);
    msg.set("upVer", Boolean.valueOf(true));
    msg.set("isNotify", Boolean.valueOf(notify));
    msg.set("state", state);
    if (user != null)
      msg.set("orgId", user.getStr("org_id")); 
    HostAsyncHandleHelp.sendMsgToQueue(msg);
  }
  
  public static void updateEdit(String source, boolean isUpdateVersion, boolean notify) {
    RLock reentrantLock = null;
    RLock lock = RedisLockFactory.getLock("ITX:DIS_LOCK:FOURLOCKKEY");
    lock.lock();
    try {
      SysLogicUtil.isParamBlank(source);
      Record record = SysLogicUtil.getRecord(source);
      Record oldHostrecord = getSimpleHostByIdDao(record.getStr("id"));
      SysLogicUtil.filterCurrentNodeData(oldHostrecord);
      String hostId = record.getStr("id", null);
      String userId = record.getStr("user_id", null);
      Record user = null;
      if (StringKit.notBlank(userId)) {
        user = UserHelp.getSimpleUserByIdDao(userId);
        if (user == null)
          SysLogicUtil.throwCustomException("主机用户不存在", "1503"); 
        SysLogicUtil.filterCurrentNodeData(user);
        String orgId = user.getStr("org_id", null);
        String oldOrgId = getHostWithOrgIdById(hostId).getStr("org_id", null);
        reentrantLock = AuthoriseCompute.getAuthoriseCompute().getReentrantLock();
        OrgAuthHelp.canChageOrgAuth(orgId, oldOrgId, hostId, "host", reentrantLock);
      } 
      SysLogicUtil.isParamBlank(hostId);
      record.remove(new String[] { "create_date", "orga_name", "user_name" });
      String id = record.getStr("id");
      if (isUpdateVersion) {
        record.set("sync_state", Integer.valueOf(0));
        updateInfoVersion(id);
      } 
      if (StringKit.isBlank(record.getStr("remark")))
        record.set("remark", ""); 
      if (StringKit.isBlank(record.getStr("code")))
        record.set("code", ""); 
      record.remove("dict_online_name");
      record.remove("auth_state");
      String state = record.getStr("install_state");
      record.set("last_modify_date", SysLogicUtil.nowDateTime());
      record.remove("online_timespan");
      if (StringKit.notBlank(record.getStr("ip"))) {
        Long ipval = Long.valueOf(LogicUtil.ipToLong(record.getStr("ip")));
        record.set("ipval", ipval);
      } 
      record.remove("tel_num");
      ArrayList<String> userIds = new ArrayList<>();
      Record userIdRecode = showUserByHostId(record.getStr("id"));
      record.remove("is_current_node_data");
      DbUtil.update("tb_base_host", "id", record);
      if (StringKit.notBlank(userIdRecode.getStr("user_id")))
        userIds.add(userIdRecode.getStr("user_id")); 
      if (StringKit.notBlank(record.getStr("user_id")))
        userIds.add(record.get("user_id")); 
      updatePolicy(hostId, "0");
      RpcCacheHelp.publishInvalidRpcCacheMessage("HostFlow.GetPolicy", hostId);
      List<String> hostIds = new ArrayList<>();
      hostIds.add(hostId);
      Notify.policyHostChange(hostIds);
      Record msg = new Record();
      msg.set("userId", record.getStr("user_id"));
      msg.set("hostId", id);
      msg.set("upVer", Boolean.valueOf(true));
      msg.set("isNotify", Boolean.valueOf(notify));
      msg.set("state", state);
      if (user != null)
        msg.set("orgId", user.getStr("org_id")); 
      HostAsyncHandleHelp.sendMsgToQueue(msg);
    } finally {
      try {
        if (reentrantLock != null && reentrantLock.isLocked()) {
          reentrantLock.unlock();
          logger.info("主机更新解锁！");
        } 
      } catch (Exception e) {
        logger.error("主机更新解锁出错！", e);
      } 
      lock.unlock();
    } 
  }
  
  public static void updatePolicy(String ids, String type) {
    String host_ids = "";
    StringBuffer host_idsffer = new StringBuffer();
    String[] hosts = ids.split(",");
    List<String> hostList = new ArrayList<>();
    for (String str : hosts) {
      host_idsffer.append("'");
      host_idsffer.append(str);
      host_idsffer.append("'");
      host_idsffer.append(",");
      hostList.add(str);
    } 
    if (host_idsffer.length() > 0) {
      int batchSize = BaseGlobal.BATCH_SIZE.intValue();
      int interval = (int)Math.ceil(hostList.size() / BaseGlobal.BATCH_SIZE.doubleValue());
      int start = 0, end = 0;
      for (int i = 0; i < interval; i++) {
        start = i * batchSize;
        end = ((i + 1) * batchSize > hostList.size()) ? hostList.size() : ((i + 1) * batchSize);
        List<String> subList = hostList.subList(start, end);
        List<Object> params = new ArrayList();
        params.add(Integer.valueOf(LogicUtil.parseIntSafe(type)));
        params.add(SysLogicUtil.nowDateTime());
        params.addAll(subList);
        String sql = DbDialectUtil.getDbRuleFactory().dbField(" update tb_base_host set `p_sync_state`=?,`last_modify_date`=? ");
        sql = DbUtil.getSingleStatmentInSqlParam(subList, "`id`", new StringBuilder(sql)).toString();
        Db.update(sql, params.toArray());
      } 
    } 
  }
  
  public static void updateExtendPolicy(String ids, String version) {
    String[] hosts = ids.split(",");
    List<String> hostIds = Arrays.asList(hosts);
    List<Object> params = new ArrayList();
    params.add(version);
    params.addAll(hostIds);
    String sql = DbDialectUtil.getDbRuleFactory().dbField(" update tb_base_host_extend set `host_policy_version`=?  ");
    sql = DbUtil.getSingleStatmentInSqlParam(hostIds, "`host_id`", new StringBuilder(sql)).toString();
    Db.update(sql, params.toArray());
  }
  
  public static void updateHostAuthState(int state, String host_id) {
    DbUtil.update("tb_base_host", DbDialectUtil.getDbRuleFactory().dbField("update tb_base_host set `auth_state`=?, `last_modify_date` = ?  where `id`=?"), new Object[] { Integer.valueOf(state), SysLogicUtil.nowDateTime(), host_id });
    updateHostVersion(Collections.singletonList(host_id));
    DbUtil.update("tb_base_host_version", DbDialectUtil.getDbRuleFactory().dbField("update tb_base_host_version set `version`=`version`+1 where `host_id`=? and `type`='1'"), new Object[] { host_id });
  }
  
  @Before({Tx.class})
  public static void registerHost(String source) {
    SysLogicUtil.isParamBlank(source);
    Record record = SysLogicUtil.getRecord(source);
    String userId = record.getStr("user_id");
    String orgId = record.getStr("org_id");
    String userName = record.getStr("user_name");
    String hostId = record.getStr("id");
    try {
      if (StringKit.notBlank(userName)) {
        int ret = UserHelp.containUser(orgId, userName, "");
        if (ret == 1) {
          SysLogicUtil.throwCustomException("同一部门下该用户已存在", "10020");
        } else {
          OrgaHelp.getCurrentNodeIdDao();
          Record user = new Record();
          user.set("node_id", BaseGlobal.getCurrentNodeId());
          user.set("id", userId);
          user.set("name", userName);
          user.set("org_id", orgId);
          user.set("create_date", SysLogicUtil.nowDateTime());
          String user_last_modify_date = "";
          if ("1".equals(BaseGlobal.catchType)) {
            user_last_modify_date = LogicUtil.getLastMaxTime(BaseGlobal.USER);
          } else {
            user_last_modify_date = BaseGlobal.getLastMaxTimeMap("user_last_modify_date");
          } 
          String lastModifyDate = LogicUtil.getMaxDate(user_last_modify_date);
          user.set("modify_date", Timestamp.valueOf(lastModifyDate));
          DbUtil.save("tb_base_user", "id", user);
          SysParamHelp.updateVersion("user");
          Long userVersion = SysParamHelp.getVersion("user");
          SysLogicUtil.sendUpdateInfo("update_user", userId, userVersion);
          BaseGlobal.setLastMaxTimeMap("user_last_modify_date", lastModifyDate);
        } 
      } 
      record.remove("org_id");
      if (StringKit.isBlank(userId) || UserHelp.getSimpleUserByIdDao(userId) == null)
        SysLogicUtil.throwCustomException("主机用户不存在", "1503"); 
      record.set("type", Integer.valueOf(1));
      save(record, hostId);
    } catch (CustomException e) {
      throw new ActiveRecordException(e);
    } 
    SysParamHelp.updateVersion("host");
    Long hostVersion = SysParamHelp.getVersion("host");
    SysLogicUtil.sendUpdateInfo("update_host", hostId, hostVersion);
    createHostVersion(hostId, "1");
  }
  
  public static List<Record> showUserHost(String id) {
    SysLogicUtil.isParamBlank(id);
    Record urserInfo = UserHelp.getSimpleUserByIdDao(id);
    SysLogicUtil.isParamBlank(urserInfo, "主机用户不存在", "1503");
    return getHostByUserIdDao(id);
  }
  
  public static List<Record> showUserHosts(String userId) {
    Assert.notBlank(userId, "用户id不能为空", new Object[0]);
    Record userInfo = UserHelp.getSimpleUserByIdDao(userId);
    SysLogicUtil.isParamBlank(userInfo, "主机用户不存在", "1503");
    return getHostsByUserIdDao(userId);
  }
  
  public static Map<String, String> batchDestroy(String hostIds) {
    return batchDestroy(hostIds, true);
  }
  
  public static Map<String, String> batchDestroy(String hostIds, boolean notify) {
    SysLogicUtil.isParamBlank(hostIds);
    hostIds = SysLogicUtil.filterParam(hostIds);
    String[] hosts = hostIds.split(",");
    try {
      ArrayList<String> delUserIds = new ArrayList<>();
      for (String hostId : hosts) {
        Record hostIdInfo = getHostByIdDao(hostId);
        if (hostIdInfo != null && hostIdInfo.getInt("install_state").intValue() >= 1)
          SysLogicUtil.throwCustomException("主机已安装，不允许删除", "1502"); 
        if (hasHostAuth(hostId))
          SysLogicUtil.throwCustomException("主机下包含授权信息，不允许删除", "1502"); 
        Record canDel = SysLogicUtil.canDel("delete_host", hostId);
        int ret = canDel.getInt("ret").intValue();
        if (ret != 0) {
          String msg = StringKit.notBlank(canDel.getStr("msg")) ? canDel.getStr("msg") : "主机下包含绑定信息不允许删除";
          SysLogicUtil.throwCustomException(msg, "1205");
        } 
        String userId = showUserByHostId(hostId).getStr("user_id");
        DbUtil.deleteById("tb_base_host", "id", hostId);
        delUserIds.add(userId);
        Db.update(DbDialectUtil.getDbRuleFactory().dbField("delete from tb_base_host_online where `host_id`=?"), new Object[] { hostId });
        DbUtil.update("tb_base_host_extend", DbDialectUtil.getDbRuleFactory().dbField("delete from tb_base_host_extend where `host_id`=?"), new Object[] { hostId });
      } 
      HostCacheHelp.updateCache(delUserIds);
      AuthoriseCompute.getAuthoriseCompute().deleteProductAuthWhenDelHost(Arrays.asList(hosts));
      SysParamHelp.updateVersion("host");
      Long hostVersion = SysParamHelp.getVersion("host");
      if (notify)
        SysLogicUtil.sendUpdateInfo("update_host", hostIds, hostVersion); 
    } catch (Exception ex) {
      throw new ActiveRecordException(ex);
    } 
    Map<String, String> resultMap = new HashMap<>(4);
    resultMap.put("hostIds", hostIds);
    return resultMap;
  }
  
  public static void batchCancelDestroy(String hostIds) {
    SysLogicUtil.isParamBlank(hostIds);
    hostIds = SysLogicUtil.filterParam(hostIds);
    String[] hosts = hostIds.split(",");
    try {
      ArrayList<String> delUserIds = new ArrayList<>();
      for (String hostId : hosts) {
        forceDestroy(hostId, false);
        String userId = showUserByHostId(hostId).getStr("user_id");
        DbUtil.deleteById("tb_base_host", "id", hostId);
        delUserIds.add(userId);
        Db.update(DbDialectUtil.getDbRuleFactory().dbField("delete from tb_base_host_online where `host_id`=?"), new Object[] { hostId });
      } 
      HostCacheHelp.updateCache(delUserIds);
      AuthoriseCompute.getAuthoriseCompute().deleteProductAuthWhenDelHost(Arrays.asList(hosts));
      SysParamHelp.updateVersion("host");
      Long hostVersion = SysParamHelp.getVersion("host");
      SysLogicUtil.sendUpdateInfo("update_host", hostIds, hostVersion);
    } catch (Exception ex) {
      throw new ActiveRecordException(ex);
    } 
  }
  
  public static Record getHostByIdDao(String id) {
    Record hostInfo = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select host.`feature`,host.`fixed_no`,host.`eq_use`,host.`type_new`,host.`active_date`,host.`host_class`, host.`install_code`,host.`auth_state`,host.`id`,host.`code`,host.`room_num`,host.`name`,host.`type`,host.`install_state`,hostonline.`host_online_state` as `online_state`,host.`sync_date`,host.`p_sync_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`unreg_date`,host.`sync_date`,host.`last_modify_date`,host.`host_version`,host.`ext`,host.`user_id`,host.`remark`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,org.`region` as `region`,dict_type.`dict_name` as `type_name`, dict_install.`dict_name` as `install_state_name`,dict_online.`dict_name` as `dict_online_name`,dict_sync_state.`dict_name` as `dict_sync_state_name`,dict_p_sync_state.`dict_name` as `dict_p_sync_state_name`,dict_sec_level.`dict_name` as `dict_sec_level_name`,host.`osversioninfo`,  hostonline.`host_online_state` ,  host.`oper_sys` from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` left join tb_base_host_online hostonline on hostonline.`host_id`=host.`id` left join (select * from  tb_base_dict where  `dict_type`='2') dict_type on host.`type`=" + 









          
          DbDialectUtil.getDbFunFactory().cast("dict_type.`dict_id`", "int") + " left join (select * from  tb_base_dict where  `dict_type`='3') dict_install on host.`install_state`=" + 
          DbDialectUtil.getDbFunFactory().cast("dict_install.`dict_id`", "int") + "  left join (select * from  tb_base_dict where  `dict_type`='4') dict_online on host.`online_state`=" + 
          DbDialectUtil.getDbFunFactory().cast("dict_online.`dict_id`", "int") + " left join (select * from  tb_base_dict where  `dict_type`='5') dict_sync_state on host.`sync_state`=" + 
          DbDialectUtil.getDbFunFactory().cast("dict_sync_state.`dict_id`", "int") + " left join (select * from  tb_base_dict where  `dict_type`='5') dict_p_sync_state on host.`p_sync_state`=" + 
          DbDialectUtil.getDbFunFactory().cast("dict_p_sync_state.`dict_id`", "int") + "  left join (select * from  tb_base_dict where  `dict_type`='1') dict_sec_level on host.`sec_level`=" + 
          DbDialectUtil.getDbFunFactory().cast("dict_sec_level.`dict_id`", "int") + "   where  host.`id`= ? limit 1"), new Object[] { id });
    LogicUtil.getHostRecord(hostInfo);
    return hostInfo;
  }
  
  public static List<Record> getHostInfoByIp(String ip) {
    List<Record> hosts = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host where `install_state`=2 and `ip`= ?"), new Object[] { ip });
    return hosts;
  }
  
  public static Record getHostByIdAuthStateDao(String id) {
    Record hostInfo = Db.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select host.`auth_state`, host.`feature`,host.`active_date`, host.`install_code`, host.`import_host`,host.`id`,host.`code`,host.`room_num`,host.`name`,host.`type`,host.`install_state`,host.`online_state`,host.`sync_date`,host.`p_sync_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`unreg_date`,host.`sync_date`,host.`last_modify_date`,host.`host_version`,host.`ext`,host.`user_id`,host.`remark`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,org.`region` as `region`,dict_type.`dict_name` as type_name, dict_install.`dict_name` as `install_state_name`,dict_online.`dict_name` as `dict_online_name`,dict_sync_state.`dict_name` as `dict_sync_state_name`,dict_p_sync_state.`dict_name` as `dict_p_sync_state_name`,dict_sec_level.`dict_name` as `dict_sec_level_name`  from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` left join (select * from  tb_base_dict where  `dict_type`='2') dict_type on host.`type`=" + DbDialectUtil.getDbFunFactory().cast("dict_type.`dict_id`", "int") + "  left join (select * from  tb_base_dict where  `dict_type`='3') dict_install on host.`install_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_install.`dict_id`", "int") + "  left join (select * from  tb_base_dict where  `dict_type`='4') dict_online on host.`online_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_online.`dict_id`", "int") + " left join (select * from  tb_base_dict where  `dict_type`='5') dict_sync_state on host.`sync_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_sync_state.`dict_id`", "int") + " left join (select * from  tb_base_dict where  `dict_type`='5') dict_p_sync_state on host.`p_sync_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_p_sync_state.`dict_id`", "int") + "   left join (select * from  tb_base_dict where  `dict_type`='1') dict_sec_level on host.`sec_level`=" + DbDialectUtil.getDbFunFactory().cast("dict_sec_level.`dict_id`", "int") + "   where  host.`id`=? limit 1"), new Object[] { id });
    return hostInfo;
  }
  
  public static String getHostByIdsecLevelDao(String id) {
    return Db.queryLong(DbDialectUtil.getDbRuleFactory().dbField("select count(`id`)  from tb_base_host host  where (`install_state`=0 or `install_state`=1 or `install_state`=2 or `install_state`=3)  and `sec_level`=?"), new Object[] { id }) + "";
  }
  
  public static String getHostCheckSecHost(String id) {
    String currentNodeId = BaseGlobal.getCurrentNodeId();
    Long secLeve = Db.queryLong(DbDialectUtil.getDbRuleFactory().dbField("select count(`id`)  from tb_base_host host  where `node_id` = ?  and  `sec_level`>?  and `install_state`< 4"), new Object[] { currentNodeId, Integer.valueOf(LogicUtil.parseIntSafe(id)) });
    int sevleType = UserHelp.getSeclevelType();
    Long mLeve = Long.valueOf(0L);
    if (sevleType == 0) {
      String userseclev = getUserByHostLevel.get(id);
      mLeve = Db.queryLong(DbDialectUtil.getDbRuleFactory().dbField("select count(u.`id`)  from tb_base_user_ext ue, tb_base_user u  where ue.id = u.id and  u.`node_id` = ?  and   ue.`mlevel`<?  and ue.`mlevel`>0"), new Object[] { currentNodeId, Integer.valueOf(LogicUtil.parseIntSafe(userseclev)) });
    } 
    return (secLeve.longValue() + mLeve.longValue()) + "";
  }
  
  public static Record getAuthHostByIdDao(String id) {
    return Db.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select `auth_state` from tb_base_host host  where  (`install_state` =2 or `install_state`=3) and host.`id`=? limit 1"), new Object[] { id });
  }
  
  public static List<Record> getSampleHostInfo() {
    return Db.find(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host host  where  (`install_state`=1 or `install_state` =2 or `install_state`=3) "));
  }
  
  public static List<Record> getSampleHostId() {
    return Db.find(DbDialectUtil.getDbRuleFactory().dbField("select id from tb_base_host host  where  (`install_state`=1 or `install_state` =2 or `install_state`=3) "));
  }
  
  public static Record getSimpleHostByIdDao(String id) {
    Record hostInfo = DbUtil.findFirstByCache(DbDialectUtil.getDbRuleFactory().dbField("select `feature`,`id`,`name`,`type`,`install_state`,`room_num`,`online_state`,`sync_state`,`p_sync_state`,`ip`,`mac`,`sn`,`sec_level`,`reg_date`,`unreg_date`,`sync_date`,`last_modify_date`,`host_version`,`ext`,`user_id`,`node_id`,`install_code`,`fixed_no`,`eq_use`,`type_new`,`code`,`remark`,`oper_sys`, `osversioninfo`,`uninstall_del_user`,`user_id` from tb_base_host where `id`=? limit 1"), new Object[] { id });
    LogicUtil.getHostRecord(hostInfo);
    return hostInfo;
  }
  
  public static List<Record> getHostsByIdDao(List<String> ids) {
    String sql = DbDialectUtil.getDbRuleFactory().dbField("select host.`oper_sys`,host.`install_code`,host.`id`,host.`eq_use`,host.`fixed_no`,host.`type_new`,host.`code`,host.`name`,host.`type`,host.`room_num`,host.`install_state`,host.`online_state`,host.`sync_date`,host.`p_sync_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`unreg_date`,host.`sync_date`,host.`last_modify_date`,host.`host_version`,host.`ext`,host.`user_id`,host.`remark`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,dict_type.`dict_name` as `type_name`, dict_install.`dict_name` as `install_state_name`,dict_online.`dict_name` as `dict_online_name`,dict_sync_state.`dict_name` as `dict_sync_state_name`,dict_p_sync_state.`dict_name` as `dict_p_sync_state_name`,dict_sec_level.`dict_name` as `dict_sec_level_name`,org.`region`  from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` left join (select * from  tb_base_dict where `dict_type`='2') dict_type on host.`type`=" + DbDialectUtil.getDbFunFactory().cast("dict_type.`dict_id`", "int") + "  left join (select * from  tb_base_dict where  `dict_type`='3') dict_install on host.`install_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_install.`dict_id`", "int") + "  left join (select * from  tb_base_dict where  `dict_type`='4') dict_online on host.`online_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_online.`dict_id`", "int") + " left join (select * from  tb_base_dict where  `dict_type`='5') dict_sync_state on host.`sync_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_sync_state.`dict_id`", "int") + " left join (select * from  tb_base_dict where  `dict_type`='5') dict_p_sync_state on host.`p_sync_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_p_sync_state.`dict_id`", "int") + "   left join (select * from  tb_base_dict where  `dict_type`='1') dict_sec_level on host.`sec_level`=" + DbDialectUtil.getDbFunFactory().cast("dict_sec_level.`dict_id`", "int") + " ");
    StringBuilder sqlBuilder = DbUtil.getSingleStatmentInSqlParam(ids, "host.`id`", new StringBuilder(sql));
    List<Record> hostInfos = DbUtil.findByCache(sqlBuilder.toString(), ids.toArray());
    LogicUtil.getHostRecordList(hostInfos);
    return hostInfos;
  }
  
  public static Record getHostWithOrgIdById(String id) {
    return DbUtil.findFirstByCache(DbDialectUtil.getDbRuleFactory().dbField("select u.`org_id`,h.`id`,h.`name`,h.`install_state`,h.`user_id` from tb_base_host h LEFT JOIN tb_base_user u ON (h.`user_id`=u.`id`) where h.`id`=? limit 1"), new Object[] { id });
  }
  
  public static List<Record> getConsoleHosts() {
    List<Record> hostInfos = DbUtil.findByCache(DbDialectUtil.getDbRuleFactory().dbField("select host. `oper_sys`,host.`install_code`,host.`eq_use`,host.`fixed_no`,host.`type_new`,host.`id`,host.`code`,host.`name`,host.`room_num`,host.`type`,host.`install_state`,host.`online_state`,host.`sync_date`,host.`p_sync_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`unreg_date`,host.`sync_date`,host.`last_modify_date`,host.`host_version`,host.`ext`,host.`user_id`,host.`remark`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,dict_type.`dict_name` as `type_name`, dict_install.`dict_name` as `install_state_name`,dict_online.`dict_name` as `dict_online_name`,dict_sync_state.`dict_name` as `dict_sync_state_name`,dict_p_sync_state.`dict_name` as `dict_p_sync_state_name`,dict_sec_level.`dict_name` as `dict_sec_level_name`,org.`region`  from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` left join (select * from  tb_base_dict where  `dict_type`='2') dict_type on host.`type`=" + DbDialectUtil.getDbFunFactory().cast("dict_type.`dict_id`", "int") + "  left join (select * from  tb_base_dict where  `dict_type`='3') dict_install on host.`install_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_install.`dict_id`", "int") + "  left join (select * from  tb_base_dict where  `dict_type`='4') dict_online on host.`online_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_online.`dict_id`", "int") + " left join (select * from  tb_base_dict where  `dict_type`='5') dict_sync_state on host.`sync_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_sync_state.`dict_id`", "int") + " left join (select * from  tb_base_dict where  `dict_type`='5') dict_p_sync_state on host.`p_sync_state`=" + DbDialectUtil.getDbFunFactory().cast("dict_p_sync_state.`dict_id`", "int") + "   left join (select * from  tb_base_dict where  `dict_type`='1') dict_sec_level on host.`sec_level`=" + DbDialectUtil.getDbFunFactory().cast("dict_sec_level.`dict_id`", "int") + " where host. `install_state`=2 or host. `install_state`=3"));
    LogicUtil.getHostRecordList(hostInfos);
    return hostInfos;
  }
  
  public static List<Record> getHostByUserIdDao(String id) {
    List<Record> hostInfoList = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField("select host.`id`,host.`name`,host.`type`,host.`install_state`,host.`room_num`,host.`online_state`,host.`sync_date`,host.`p_sync_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`unreg_date`,host.`sync_date`,host.`last_modify_date`,host.`host_version`,host.`ext`,host.`user_id`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name` from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id`   where  host.`user_id`=? limit 1"), new Object[] { id });
    LogicUtil.getHostRecordList(hostInfoList);
    return hostInfoList;
  }
  
  public static List<Record> getHostsByUserIdDao(String userId) {
    List<Record> hostInfoList = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField("SELECT HOST.`id`,HOST.`name`,ON_LINE.`host_online_state`,HOST.`install_state` , HOST.`ip`,HOST.`mac`,HOST.`active_date`,HOST.`user_id`,HOST.`oper_sys`,HOST.`node_id`,ON_LINE.`last_online_date`FROM tb_base_host  HOST LEFT JOIN tb_base_host_online ON_LINE On HOST.`id`  = ON_LINE.`host_id`WHERE HOST.`install_state` < 4 and HOST.`user_id` =? ORDER BY ON_LINE.`last_online_date` desc"), new Object[] { userId });
    LogicUtil.getHostRecordList(hostInfoList);
    LogicUtil.getDictRecordList("7", hostInfoList);
    return hostInfoList;
  }
  
  public static List<Record> getHostIdsByUserIdDao(String userId) {
    List<Record> hostInfoList = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField("SELECT HOST.`id` FROM tb_base_host where `install_state` < 4 and `user_id` = ?"), new Object[] { userId });
    return hostInfoList;
  }
  
  public static Map<String, String> getAllUserHostNums() {
    List<Record> hostInfoList = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField("SELECT `user_id` , count(*) num FROM tb_base_host where `install_state` < 4 group by `user_id` "));
    HashMap<String, String> resultMap = new HashMap<>();
    for (Record recode : hostInfoList)
      resultMap.put(recode.getStr("user_id"), recode.get("num").toString()); 
    return resultMap;
  }
  
  public static String getUserHostNum(String userId) {
    Record record = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("SELECT count(*) num FROM tb_base_host where `install_state` < 4 and `user_id` = ? "), new Object[] { userId });
    if (ObjectUtil.isNull(record))
      return null; 
    return record.get("num").toString();
  }
  
  public static Map<String, String> getUsersHostNum(List<String> userIds) {
    String sql = DbDialectUtil.getDbRuleFactory().dbField("SELECT `user_id` , count(*) num FROM tb_base_host where  `install_state` < 4  ");
    List<Object> paramList = Lists.newArrayList();
    if (!userIds.isEmpty()) {
      String inPlaceholder = userIds.stream().map(type -> "?").collect(Collectors.joining(","));
      sql = sql + DbDialectUtil.getDbRuleFactory().dbField(" and `user_id` in ( " + inPlaceholder + ") ");
      paramList.addAll(userIds);
    } 
    sql = sql + DbDialectUtil.getDbRuleFactory().dbField("  group by `user_id`  ");
    List<Record> hostInfoList = DbUtil.find(sql, paramList.toArray());
    HashMap<String, String> resultMap = new HashMap<>();
    hostInfoList.forEach(r -> (String)resultMap.put(r.getStr("user_id"), r.get("num").toString()));
    for (String id : userIds) {
      if (!resultMap.containsKey(id))
        resultMap.put(id, "0"); 
    } 
    return resultMap;
  }
  
  public static void getUserHostNumByPage(Page<Record> userPage) {
    if (Objects.isNull(userPage))
      return; 
    List<Record> userList = userPage.getList();
    if (CollUtil.isEmpty(userList))
      return; 
    int size = userList.size();
    if (size < 1 || size > LogicUtil.parseIntSafe(YqPropertiesUtil.me().getProperty("queryUserlimitSize", "100")))
      return; 
    String[] ids = (String[])userList.stream().map(userRecord -> userRecord.getStr("id")).toArray(x$0 -> new String[x$0]);
    Map<String, String> usersHostNumMap = HostCacheHelp.getDbValue(ids);
    for (Record user : userList) {
      String hostNum = usersHostNumMap.get(user.getStr("id"));
      user.set("hostNum", StringKit.isBlank(hostNum) ? "0" : hostNum);
      String nodeId = user.getStr("node_id");
      int isCurrentNodeData = checkIsCurrentNodeData(nodeId) ? 1 : 0;
      user.set("is_current_node_data", Integer.valueOf(isCurrentNodeData));
    } 
  }
  
  private static boolean checkIsCurrentNodeData(String nodeId) {
    return StringUtils.equals(BaseGlobal.getCurrentNodeId(), nodeId);
  }
  
  public static boolean userIsContainHost(String userId) {
    Record userInfo = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host acc  where `user_id`=?  and  `install_state`<4 limit 1"), new Object[] { userId });
    return !(userInfo == null);
  }
  
  public static String getInstallCode() {
    StringBuffer sb = new StringBuffer();
    String str = "23456789abcdefghgkmnpqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ";
    Random r = new Random();
    for (int i = 0; i < 4; i++) {
      int num = r.nextInt(str.length());
      sb.append(str.charAt(num));
      str = str.replace(str.charAt(num) + "", "");
    } 
    String code = sb.toString().toUpperCase();
    long hasCode = Db.queryLong(DbDialectUtil.getDbRuleFactory().dbField("select count(1) from tb_base_host where `install_code`=?"), new Object[] { code }).longValue();
    if (hasCode > 0L)
      getInstallCode(); 
    return code;
  }
  
  public static String findParent(Record parent) {
    String path = parent.getStr("name");
    if (parent.get("parent") != null)
      path = findParent((Record)parent.get("parent")) + "\\" + path; 
    return path;
  }
  
  public static Record getHostFeatureByid(String id) {
    return DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select host.`last_modify_date` ,host.`fixed_no`,host.`eq_use`,host.`type_new`,host.`remark`,host.`room_num`,host.`install_code`,host.`id`,host.`code`,host.`name`,host.`type`,host.`install_state`,host.`online_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`host_version`,host.`ext`,host.`user_id`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,org.`region` as `region` from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` where host.`id` = ?  limit 1"), new Object[] { id });
  }
  
  public static Record getHostByident(Map paramMap) {
    SysParamUtil sysParamUtil = new SysParamUtil(paramMap);
    Record record = null;
    String domainAcc = sysParamUtil.getPara("domain_acc");
    String installCode = sysParamUtil.getPara("install_code");
    String mac = sysParamUtil.getPara("mac");
    String sn = sysParamUtil.getPara("sn");
    String ip = sysParamUtil.getPara("ip");
    if (StringKit.notBlank(domainAcc)) {
      String accSql = DbDialectUtil.getDbRuleFactory().dbField(" SELECT * FROM tb_base_acc WHERE `dataservice`='domain' AND `is_deleted` != 2 AND ") + DbDialectUtil.getDbFunFactory().showBinary() + DbDialectUtil.getDbRuleFactory().dbField(" `name`=?");
      Record accRecord = DbUtil.findFirstByCache(accSql, new Object[] { domainAcc });
      if (accRecord != null) {
        String userId = (accRecord.get("user_id") == null) ? "" : accRecord.get("user_id").toString();
        if (StringKit.notBlank(userId)) {
          List<Record> recordList = DbUtil.findByCache(DbDialectUtil.getDbRuleFactory().dbField("select host.`last_modify_date` ,host.`remark`,host.`room_num`,host.`fixed_no`,host.`eq_use`,host.`type_new`,host.`install_code`,host.`id`,host.`code`,host.`name`,host.`type`,host.`install_state`,host.`online_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`host_version`,host.`ext`,host.`user_id`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,org.`region` as `region` from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` where host.`user_id` = ?  and host.`install_state`=0 "), new Object[] { userId });
          if (recordList.size() == 1) {
            for (Record hostRecord : recordList)
              record = hostRecord; 
            return record;
          } 
        } 
      } 
    } 
    if (StringKit.notBlank(installCode)) {
      record = DbUtil.findFirstByCache(DbDialectUtil.getDbRuleFactory().dbField("select host.`last_modify_date` ,host.`fixed_no`,host.`eq_use`,host.`type_new`,host.`remark`,host.`room_num`,host.`install_code`,host.`id`,host.`code`,host.`name`,host.`type`,host.`install_state`,host.`online_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`host_version`,host.`ext`,host.`user_id`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,org.`region` as `region` from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` where host.`install_code` = ? and host.`install_state`=0  limit 1"), new Object[] { installCode });
      if (record == null) {
        record = new Record();
        record.set("msg", "无法匹配到安装码");
      } 
      return record;
    } 
    Map<String, Record> recordMap = new HashMap<>();
    String sysMac = "";
    if (StringKit.notBlank(mac)) {
      sysMac = mac;
      String[] macs = mac.split(",");
      for (String sinMac : macs) {
        List<Record> recordList = DbUtil.findByCache(DbDialectUtil.getDbRuleFactory().dbField("select host.`last_modify_date` ,host.`remark`,host.`room_num`,host.`fixed_no`,host.`eq_use`,host.`type_new`,host.`install_code`,host.`id`,host.`code`,host.`name`,host.`type`,host.`install_state`,host.`online_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`host_version`,host.`ext`,host.`user_id`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,org.`region` as `region` from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` where host.`mac` like '%") + sinMac + DbDialectUtil.getDbRuleFactory().dbField("%'  and host.`install_state`=0 "));
        if (recordList != null)
          for (Record hostRecord : recordList) {
            String[] hostMacs = hostRecord.getStr("mac").split(",");
            boolean isMatching = false;
            for (String match : hostMacs) {
              if (match.equalsIgnoreCase(sinMac)) {
                isMatching = true;
                break;
              } 
            } 
            if (isMatching)
              recordMap.put(hostRecord.getStr("id"), hostRecord); 
          }  
      } 
    } 
    if (recordMap.size() == 1) {
      Iterator iterator = recordMap.entrySet().iterator();
      if (iterator.hasNext()) {
        Object obj = iterator.next();
        Map.Entry entry = (Map.Entry)obj;
        return (Record)entry.getValue();
      } 
    } 
    String sysSn = "";
    List<Record> snList = new ArrayList<>();
    if (StringKit.notBlank(sn)) {
      sysSn = sn;
      String[] sns = sn.split(",");
      for (String sinSn : sns) {
        List<Record> recordList = DbUtil.findByCache(DbDialectUtil.getDbRuleFactory().dbField("select host.`last_modify_date` ,host.`remark`,host.`install_code`,host.`fixed_no`,host.`eq_use`,host.`type_new`,host.`room_num`,host.`id`,host.`code`,host.`name`,host.`type`,host.`install_state`,host.`online_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`host_version`,host.`ext`,host.`user_id`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,org.`region` as `region` from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` where host.`sn` like '%") + sinSn + DbDialectUtil.getDbRuleFactory().dbField("%'  and host.`install_state`=0 "));
        if (recordList != null)
          for (Record hostRecord : recordList) {
            String[] hostMacs = hostRecord.getStr("sn").split(",");
            boolean isMatching = false;
            for (String match : hostMacs) {
              if (match.equals(sinSn)) {
                isMatching = true;
                break;
              } 
            } 
            if (isMatching) {
              snList.add(hostRecord);
              recordMap.put(hostRecord.getStr("id"), hostRecord);
            } 
          }  
      } 
    } 
    if (recordMap.size() == 1 && snList.size() == 1)
      return snList.get(0); 
    List<Record> ipList = new ArrayList<>();
    String sysIp = "";
    if (StringKit.notBlank(ip)) {
      sysIp = ip;
      String[] ips = ip.split(",");
      for (String sinIp : ips) {
        if (!"127.0.0.1".equals(sinIp)) {
          List<Record> recordList = DbUtil.findByCache(DbDialectUtil.getDbRuleFactory().dbField("select host.`last_modify_date` ,host.`fixed_no`,host.`eq_use`,host.`type_new`,host.`remark`,host.`room_num`,host.`install_code`,host.`id`,host.`code`,host.`name`,host.`type`,host.`install_state`,host.`online_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`host_version`,host.`ext`,host.`user_id`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,org.`region` as `region` from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` where host.`ip` like '%") + sinIp + DbDialectUtil.getDbRuleFactory().dbField("%' and host.`install_state`=0"));
          if (recordList != null)
            for (Record hostRecord : recordList) {
              String[] hostMacs = hostRecord.getStr("ip").split(",");
              boolean isMatching = false;
              for (String match : hostMacs) {
                if (match.equals(sinIp)) {
                  isMatching = true;
                  break;
                } 
              } 
              if (isMatching) {
                ipList.add(hostRecord);
                recordMap.put(hostRecord.getStr("id"), hostRecord);
              } 
            }  
        } 
      } 
    } 
    if (recordMap.size() == 1 && ipList.size() == 1)
      return ipList.get(0); 
    Record mathRecord = mathcRule(recordMap, sysMac, sysSn, sysIp);
    if (mathRecord != null)
      return mathRecord; 
    mathRecord = OtherSysHostMachtThread.getOtherSysHostMachtThread().matchHost(sysMac, sn, ip);
    if (mathRecord != null)
      return mathRecord; 
    record = new Record();
    record.set("msg", "没有匹配到未安装的主机");
    return record;
  }
  
  public static Record getHostByidentDebNot3in1(Map paramMap) {
    SysParamUtil sysParamUtil = new SysParamUtil(paramMap);
    Record record = null;
    String domainAcc = sysParamUtil.getPara("domain_acc");
    String installCode = sysParamUtil.getPara("install_code");
    String mac = sysParamUtil.getPara("mac");
    String sn = sysParamUtil.getPara("sn");
    String ip = sysParamUtil.getPara("ip");
    if (StringKit.notBlank(domainAcc)) {
      String accSql = DbDialectUtil.getDbRuleFactory().dbField(" SELECT * FROM tb_base_acc WHERE `dataservice`='domain' AND `is_deleted` != 2 AND ") + DbDialectUtil.getDbFunFactory().showBinary() + DbDialectUtil.getDbRuleFactory().dbField(" `name`=?");
      Record accRecord = DbUtil.findFirstByCache(accSql, new Object[] { domainAcc });
      if (accRecord != null) {
        String user_id = (accRecord.get("user_id") == null) ? "" : accRecord.get("user_id").toString();
        if (StringKit.notBlank(user_id)) {
          List<Record> recordList = DbUtil.findByCache(DbDialectUtil.getDbRuleFactory().dbField("select host.`last_modify_date` ,host.`remark`,host.`room_num`,host.`fixed_no`,host.`eq_use`,host.`type_new`,host.`install_code`,host.`id`,host.`code`,host.`name`,host.`type`,host.`install_state`,host.`online_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`host_version`,host.`ext`,host.`user_id`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,org.`region` as `region` from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` where host.`user_id` = ?  and host.`install_state`=0 and  host.`dataservice`!=?"), new Object[] { user_id, "zf3in1" });
          if (recordList != null && 
            recordList.size() == 1) {
            for (Record hostRecord : recordList)
              record = hostRecord; 
            return record;
          } 
        } 
      } 
    } 
    if (StringKit.notBlank(installCode)) {
      record = DbUtil.findFirstByCache(DbDialectUtil.getDbRuleFactory().dbField("select host.`last_modify_date` ,host.`fixed_no`,host.`eq_use`,host.`type_new`,host.`remark`,host.`room_num`,host.`install_code`,host.`id`,host.`code`,host.`name`,host.`type`,host.`install_state`,host.`online_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`host_version`,host.`ext`,host.`user_id`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,org.`region` as `region` from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` where host.`install_code` = ? and host.`install_state`=0  and  host.`dataservice`!=? limit 1"), new Object[] { installCode, "zf3in1" });
      if (record == null) {
        record = new Record();
        record.set("msg", "无法匹配到安装码");
      } 
      return record;
    } 
    Map<String, Record> recordMap = new HashMap<>();
    String sysMac = "";
    if (StringKit.notBlank(mac)) {
      sysMac = mac;
      String[] macs = mac.split(",");
      for (String sinMac : macs) {
        List<Record> recordList = DbUtil.findByCache(DbDialectUtil.getDbRuleFactory().dbField("select host.`last_modify_date` ,host.`remark`,host.`room_num`,host.`fixed_no`,host.`eq_use`,host.`type_new`,host.`install_code`,host.`id`,host.`code`,host.`name`,host.`type`,host.`install_state`,host.`online_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`host_version`,host.`ext`,host.`user_id`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,org.`region` as `region` from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` where host.`mac` like '%") + sinMac + DbDialectUtil.getDbRuleFactory().dbField("%'  and host.`install_state`=0  and host.`dataservice`!=?"), new Object[] { "zf3in1" });
        if (recordList != null)
          for (Record hostRecord : recordList) {
            String[] hostMacs = hostRecord.getStr("mac").split(",");
            boolean isMatching = false;
            for (String match : hostMacs) {
              if (match.equalsIgnoreCase(sinMac)) {
                isMatching = true;
                break;
              } 
            } 
            if (isMatching)
              recordMap.put(hostRecord.getStr("id"), hostRecord); 
          }  
      } 
    } 
    if (recordMap.size() == 1) {
      Iterator iterator = recordMap.entrySet().iterator();
      if (iterator.hasNext()) {
        Object obj = iterator.next();
        Map.Entry entry = (Map.Entry)obj;
        return (Record)entry.getValue();
      } 
    } 
    String sysSn = "";
    List<Record> snList = new ArrayList<>();
    if (StringKit.notBlank(sn)) {
      sysSn = sn;
      String[] sns = sn.split(",");
      for (String sinSn : sns) {
        List<Record> recordList = DbUtil.findByCache(DbDialectUtil.getDbRuleFactory().dbField("select host.`last_modify_date` ,host.`remark`,host.`install_code`,host.`fixed_no`,host.`eq_use`,host.`type_new`,host.`room_num`,host.`id`,host.`code`,host.`name`,host.`type`,host.`install_state`,host.`online_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`host_version`,host.`ext`,host.`user_id`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,org.`region` as `region` from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` where host.`sn` like '%") + sinSn + DbDialectUtil.getDbRuleFactory().dbField("%'  and host.`install_state`=0  and host.`dataservice`!=?"), new Object[] { "zf3in1" });
        if (recordList != null)
          for (Record hostRecord : recordList) {
            String[] hostMacs = hostRecord.getStr("sn").split(",");
            boolean isMatching = false;
            for (String match : hostMacs) {
              if (match.equals(sinSn)) {
                isMatching = true;
                break;
              } 
            } 
            if (isMatching) {
              snList.add(hostRecord);
              recordMap.put(hostRecord.getStr("id"), hostRecord);
            } 
          }  
      } 
    } 
    if (recordMap.size() == 1 && snList.size() == 1)
      return snList.get(0); 
    List<Record> ipList = new ArrayList<>();
    String sysIp = "";
    if (StringKit.notBlank(ip)) {
      sysIp = ip;
      String[] ips = ip.split(",");
      for (String sinIp : ips) {
        if (!"127.0.0.1".equals(sinIp)) {
          List<Record> recordList = DbUtil.findByCache(DbDialectUtil.getDbRuleFactory().dbField("select host.`last_modify_date` ,host.`fixed_no`,host.`eq_use`,host.`type_new`,host.`remark`,host.`room_num`,host.`install_code`,host.`id`,host.`code`,host.`name`,host.`type`,host.`install_state`,host.`online_state`,host.`ip`,host.`mac`,host.`sn`,host.`sec_level`,host.`reg_date`,host.`host_version`,host.`ext`,host.`user_id`,u.`name` as `user_name`,org.`id` as `org_id`,org.`name` as `orga_name`,org.`region` as `region` from tb_base_host host left join tb_base_user  u on host.`user_id`=u.`id` left join tb_base_org  org on org.`id`=u.`org_id` where host.`ip` like '%") + sinIp + DbDialectUtil.getDbRuleFactory().dbField("%' and host.`install_state`=0 and host.`dataservice`!=?"), new Object[] { "zf3in1" });
          if (recordList != null)
            for (Record hostRecord : recordList) {
              String[] hostMacs = hostRecord.getStr("ip").split(",");
              boolean isMatching = false;
              for (String match : hostMacs) {
                if (match.equals(sinIp)) {
                  isMatching = true;
                  break;
                } 
              } 
              if (isMatching) {
                ipList.add(hostRecord);
                recordMap.put(hostRecord.getStr("id"), hostRecord);
              } 
            }  
        } 
      } 
    } 
    if (recordMap.size() == 1 && ipList.size() == 1)
      return ipList.get(0); 
    Record mathRecord = mathcRule(recordMap, sysMac, sysSn, sysIp);
    if (mathRecord != null)
      return mathRecord; 
    mathRecord = OtherSysHostMachtThread.getOtherSysHostMachtThread().matchHost(sysMac, sn, ip);
    if (mathRecord != null)
      return mathRecord; 
    record = new Record();
    record.set("msg", "没有匹配到未安装的主机");
    return record;
  }
  
  public static Record mathcRule(Map<String, Record> recordMap, String sysMac, String sysSn, String sysIp) {
    Map<String, Record> fMap = new HashMap<>();
    Map<String, Record> macSnMap = new HashMap<>();
    Map<String, Record> macIpMap = new HashMap<>();
    Map<String, Record> snIPMap = new HashMap<>();
    for (Map.Entry<String, Record> obj : recordMap.entrySet()) {
      Map.Entry entry = obj;
      Record entryRecord = (Record)entry.getValue();
      String macString = entryRecord.getStr("mac");
      String snString = entryRecord.getStr("sn");
      String ipString = entryRecord.getStr("ip");
      if (StringKit.isBlank(macString))
        macString = ""; 
      if (StringKit.isBlank(snString))
        snString = ""; 
      if (StringKit.isBlank(ipString))
        ipString = ""; 
      String[] hostMacs = macString.split(",");
      for (String match : hostMacs) {
        String[] hostsns = snString.split(",");
        for (String sns : hostsns) {
          StringBuffer matchSnBuffer = new StringBuffer();
          if (StringKit.notBlank(match))
            matchSnBuffer.append(match); 
          if (StringKit.notBlank(sns)) {
            if (matchSnBuffer.length() > 0)
              matchSnBuffer.append(","); 
            matchSnBuffer.append(sns);
          } 
          String featMacSn = matchSnBuffer.toString();
          if (StringKit.notBlank(featMacSn))
            macSnMap.put(featMacSn, entryRecord); 
          String[] hostsip = ipString.split(",");
          for (String ips : hostsip) {
            StringBuffer matchMacIPBuffer = new StringBuffer();
            if (StringKit.notBlank(match))
              matchMacIPBuffer.append(match); 
            if (StringKit.notBlank(ips)) {
              if (matchMacIPBuffer.length() > 0)
                matchMacIPBuffer.append(","); 
              matchMacIPBuffer.append(ips);
            } 
            String macIp = matchMacIPBuffer.toString();
            if (StringKit.notBlank(macIp))
              macIpMap.put(macIp, entryRecord); 
            StringBuffer matchSnIPBuffer = new StringBuffer();
            if (StringKit.notBlank(sns))
              matchSnIPBuffer.append(sns); 
            if (StringKit.notBlank(ips)) {
              if (matchSnIPBuffer.length() > 0)
                matchSnIPBuffer.append(","); 
              matchSnIPBuffer.append(ips);
            } 
            String snIP = matchSnIPBuffer.toString();
            if (StringKit.notBlank(snIP))
              snIPMap.put(snIP, entryRecord); 
            StringBuffer matchBuffer = new StringBuffer();
            if (StringKit.notBlank(match))
              matchBuffer.append(match); 
            if (StringKit.notBlank(sns)) {
              if (matchBuffer.length() > 0)
                matchBuffer.append(","); 
              matchBuffer.append(sns);
            } 
            if (matchBuffer.length() > 0)
              matchBuffer.append(","); 
            if (StringKit.notBlank(ips))
              matchBuffer.append(ips); 
            String feat = matchBuffer.toString();
            if (StringKit.notBlank(feat))
              fMap.put(feat, entryRecord); 
          } 
        } 
      } 
    } 
    String fKey = sysMac + "," + sysSn + "," + sysIp;
    Record record = fMap.get(fKey);
    if (record != null)
      return record; 
    fKey = sysMac + "," + sysSn;
    record = macSnMap.get(fKey);
    if (record != null)
      return record; 
    fKey = sysMac + "," + sysIp;
    record = macIpMap.get(fKey);
    if (record != null)
      return record; 
    fKey = sysSn + "," + sysIp;
    record = macIpMap.get(fKey);
    if (record != null)
      return record; 
    return null;
  }
  
  public static Record createHostVersion(String hostId, String type) {
    return createHostVersion(hostId, type, 1);
  }
  
  public static Record createHostVersion(String hostId, String type, int version) {
    Record hostInfoVersion = new Record();
    hostInfoVersion.set("host_id", hostId);
    hostInfoVersion.set("type", Integer.valueOf(LogicUtil.parseIntSafe(type)));
    hostInfoVersion.set("version", Integer.valueOf(version));
    hostInfoVersion.set("time", SysLogicUtil.nowDateTime());
    DbUtil.save("tb_base_host_version", hostInfoVersion);
    return hostInfoVersion;
  }
  
  public static void updateHostVersion(String hostId, String version, String type) {
    Object time = SysLogicUtil.nowDateTime();
    DbUtil.update("tb_base_host_version", DbDialectUtil.getDbRuleFactory().dbField("update tb_base_host_version set `version`=?,`time`=? where `host_id`=? and `type`=") + type, new Object[] { Integer.valueOf(LogicUtil.parseIntSafe(version)), time, hostId });
  }
  
  public static Record showInfoVersion(String hostId) {
    SysLogicUtil.isParamBlank(hostId);
    Record hostIdInfo = getHostByIdDao(hostId);
    SysLogicUtil.isParamBlank(hostIdInfo, "主机信息不存在", "1501");
    Record hostInfoVersion = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host_version where `host_id`=? and `type`=1 limit 1"), new Object[] { hostId });
    if (hostInfoVersion == null && hostIdInfo.getInt("install_state").intValue() != 5)
      hostInfoVersion = createHostVersion(hostId, "1"); 
    return hostInfoVersion;
  }
  
  public static void updateInfoVersion(String hostId) {
    SysLogicUtil.isParamBlank(hostId);
    Record hostIdInfo = getHostByIdDao(hostId);
    SysLogicUtil.isParamBlank(hostIdInfo, "主机信息不存在", "1501");
    Record hostInfoVersion = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host_version where `host_id`=? and `type`=1 limit 1"), new Object[] { hostId });
    if (hostInfoVersion == null && hostIdInfo.getInt("install_state").intValue() != 5) {
      hostInfoVersion = createHostVersion(hostId, "1");
    } else if (hostIdInfo.getInt("install_state").intValue() == 5) {
      SysLogicUtil.throwCustomException("该主机已卸载不能执行导入", "1502");
    } 
    int version = LogicUtil.parseIntSafe(hostInfoVersion.get("version") + "");
    version++;
    updateHostVersion(hostId, version + "", "1");
  }
  
  public static Record showPolicyVersion(String hostId) {
    SysLogicUtil.isParamBlank(hostId);
    Record hostIdInfo = getHostByIdDao(hostId);
    SysLogicUtil.isParamBlank(hostIdInfo, "主机信息不存在", "1501");
    Record hostInfoVersion = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host_version where `host_id`=? and `type`=2  limit 1"), new Object[] { hostId });
    if (hostInfoVersion == null && hostIdInfo.getInt("install_state").intValue() != 5)
      hostInfoVersion = createHostVersion(hostId, "2"); 
    return hostInfoVersion;
  }
  
  public static void updatePolicyVersion(String hostId) {
    SysLogicUtil.isParamBlank(hostId);
    Record hostIdInfo = getHostByIdDao(hostId);
    SysLogicUtil.isParamBlank(hostIdInfo, "主机信息不存在", "1501");
    Record hostInfoVersion = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host_version where `host_id`=?  and `type`=2 limit 1"), new Object[] { hostId });
    if (hostInfoVersion == null && hostIdInfo.getInt("install_state").intValue() != 5)
      hostInfoVersion = createHostVersion(hostId, "2"); 
    int version = LogicUtil.parseIntSafe(hostInfoVersion.get("version") + "");
    version++;
    updateHostVersion(hostId, version + "", "2");
  }
  
  public static void updateHostVersion(Map paramMap) {
    SysLogicUtil.isParamBlank(paramMap.get("id"), "主机参数不正确", "0001");
    SysLogicUtil.isParamBlank(paramMap.get("host_version"), "主机信息版本未输入", "0001");
    SysLogicUtil.isParamBlank(paramMap.get("policy_version"), "主机策略版本未输入", "0001");
    List<Record> records = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host_version where `host_id`=?  "), new Object[] { paramMap.get("id") });
    boolean isNewest = false;
    Record hostRecord = new Record();
    hostRecord.set("id", paramMap.get("id"));
    for (Record recrod : records) {
      if (recrod.getInt("type").intValue() == 1 && 
        paramMap.get("host_version").equals(recrod.get("version") + "")) {
        isNewest = true;
        hostRecord.set("sync_state", Integer.valueOf(1));
      } 
      if (recrod.getInt("type").intValue() == 2 && 
        paramMap.get("policy_version").equals(recrod.get("version") + "")) {
        isNewest = true;
        hostRecord.set("p_sync_state", Integer.valueOf(1));
      } 
    } 
    if (isNewest) {
      hostRecord.remove("dict_online_name");
      if (StringKit.notBlank(hostRecord.getStr("ip"))) {
        Long ipval = Long.valueOf(LogicUtil.ipToLong(hostRecord.getStr("ip")));
        hostRecord.set("ipval", ipval);
      } 
      hostRecord.set("last_modify_date", SysLogicUtil.nowDateTime());
      DbUtil.update("tb_base_host", hostRecord);
    } 
  }
  
  public static void syncHostPolicyInfo(Map paramMap) {
    SysLogicUtil.isParamBlank(paramMap.get("host_id"), "主机参数不正确", "0001");
    SysLogicUtil.isParamBlank(paramMap.get("host_version"), "主机信息版本未输入", "0001");
    SysLogicUtil.isParamBlank(paramMap.get("policy_version"), "主机策略版本未输入", "0001");
    List<Record> records = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host_version where `host_id`=? "), new Object[] { paramMap.get("host_id") });
    for (Record recrod : records) {
      if ("1".equals(recrod.get("type")) && 
        !paramMap.get("host_version").equals(recrod.get("version")))
        Record record = show((String)recrod.get("id")); 
      if (!"2".equals(recrod.get("type")) || 
        !paramMap.get("policy_version").equals(recrod.get("version")));
    } 
  }
  
  public static void hostOffline() {
    logger.info("主机批量下线开始");
    String currentServiceAddress = BaseGlobal.getCuurentWebAddress();
    logger.info("主机批量下线管理端地址【" + currentServiceAddress + "】的主机");
    List<Record> currentServiceHosts = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField("select host_id from tb_base_host_online where `host_online_ip` = ? "), new Object[] { currentServiceAddress });
    logger.info("批量下线的主机共有" + currentServiceHosts.size() + "条");
    List<Record> records = new ArrayList<>();
    for (Record record : currentServiceHosts) {
      record.set("host_online_state", HostOnlineHelp.HostOnlineState.OFFLINE.getState());
      records.add(record);
    } 
    HostOnlineHelp.updateHostOnlineState(records);
    logger.info("主机批量下线完成");
  }
  
  public static void hostOnline(List<Record> hostOnlines) {
    String delsql = DbDialectUtil.getDbRuleFactory().dbField("delete from  tb_base_host_online where `host_id`=?");
    DbUtil.batch(delsql, "host_id", hostOnlines, 2000, new String[] { "tb_base_host_online" });
    String sql = DbDialectUtil.getDbRuleFactory().dbField("insert into tb_base_host_online(`host_id`,`host_online_state`) values (?,?)");
    DbUtil.batch(sql, "host_id,host_online_state", hostOnlines, 2000, new String[] { DbDialectUtil.getDbRuleFactory().dbField("tb_base_host_online") });
  }
  
  public static void exportHostConsole(String source) {
    SysLogicUtil.isParamBlank(source, "上传报文不正确", "0001");
    source = source.replaceAll("\\n", "");
    List<Record> records = SysLogicUtil.getRecords(source);
    List<String> userIds = Lists.newArrayList();
    List<String> hostIds = Lists.newArrayList();
    for (Record record : records) {
      String hostJson = record.getStr("host");
      String[] attHost = { 
          "id", "name", "type", "install_state", "online_state", "sync_state", "p_sync_state", "ip", "mac", "sn", 
          "sec_level", "reg_date", "unreg_date", "sync_date", "last_modify_date", "host_version", "ext", "user_id", "node_id", "install_code", 
          "code", "remark", "org_id", "user_name", "feature", "room_num", "proto", "oper_sys", "osversioninfo", "is_deb", 
          "fixed_no", "eq_use", "type_new", "os_installtime", "host_class" };
      Record hostInfo = SysLogicUtil.getRecord(hostJson);
      String oldmac = hostInfo.getStr("mac");
      if (StringKit.notBlank(oldmac))
        hostInfo.set("mac", oldmac.replace(":", "-")); 
      String systemVer = hostInfo.getStr("system_ver");
      if (StringKit.notBlank(systemVer))
        hostInfo.set("osversioninfo", systemVer); 
      Record hostRecord = SysLogicUtil.filteraChosenNoDefaultRecord(hostInfo, attHost);
      String oper_sys = hostInfo.getStr("oper_sys");
      if (StringKit.isBlank(oper_sys))
        hostInfo.set("oper_sys", "window_32"); 
      String hostSecLevel = hostRecord.getStr("sec_level");
      if ("4".equals(hostSecLevel))
        hostSecLevel = "3"; 
      Record secLevelRange = SysParamHelp.show("F8E5DB84-DF81-429B-96DE-9954DC8A3995");
      String paramValue = secLevelRange.getStr("param_value");
      String[] parms = paramValue.split(",");
      HashMap<String, String> paramMap = new HashMap<>();
      for (String para : parms)
        paramMap.put(para, para); 
      if (paramMap.get(hostSecLevel) == null)
        SysLogicUtil.throwCustomException("主机的密级不在系统有效密级范围内", "15003"); 
      String proto_version = hostRecord.getStr("proto");
      if (StringKit.notBlank(proto_version))
        hostInfo.set("host_version", proto_version); 
      hostRecord.remove("proto");
      SysLogicUtil.isParamBlank(hostRecord.getStr("id"), "上传报文不正确", "0001");
      String nodeId = (String)hostRecord.get("node_id");
      Record currOrg = OrgaHelp.getCurrentNodeDao();
      if (nodeId != null && !currOrg.getStr("id").equals(nodeId))
        SysLogicUtil.throwCustomException("导入信息非本站点信息", "15002"); 
      if (StringKit.isBlank(hostRecord.getStr("user_id"))) {
        if (StringKit.isBlank(hostRecord.getStr("org_id")))
          SysLogicUtil.throwCustomException("组织机构信息错误", "15001"); 
        Record showUserRecord = UserHelp.showOrgUserName(hostRecord.getStr("org_id"), hostRecord.getStr("user_name"));
        if (showUserRecord != null) {
          hostRecord.set("user_id", showUserRecord.getStr("id"));
        } else {
          Record useRecord = new Record();
          useRecord.set("name", hostRecord.getStr("user_name"));
          useRecord.set("org_id", hostRecord.getStr("org_id"));
          String userId = UserHelp.create(JsonKit.toJson(useRecord), false, null, null);
          userIds.add(userId);
          Record logRecord = new Record();
          logRecord.set("type", "客户端");
          logRecord.set("log", "创建用户[" + hostRecord.getStr("user_name") + "]");
          if (StringKit.notBlank(hostRecord.getStr("ip")))
            logRecord.set("log_ip", hostRecord.getStr("ip")); 
          LogHelp.create(JsonKit.toJson(logRecord));
          hostRecord.set("user_id", userId);
        } 
      } 
      if ("".equals(hostRecord.get("last_modify_date")) || hostRecord.get("last_modify_date") == null)
        hostRecord.set("last_modify_date", SysLogicUtil.nowDateTime()); 
      hostRecord.remove("org_id");
      hostRecord.remove("user_name");
      String hostId = hostRecord.getStr("id");
      Record searchHostInfo = getHostByIdDao(hostRecord.getStr("id"));
      String installState = "";
      String type = hostRecord.getStr("type");
      String host_id = "";
      if (searchHostInfo == null) {
        hostRecord.set("install_state", Integer.valueOf(2));
        installState = "2";
        hostIds.add(hostId);
        save(hostRecord, hostId);
      } else {
        installState = hostRecord.getStr("install_state");
        hostRecord.remove("install_state");
        hostRecord.remove("reg_date");
        hostIds.add(hostId);
        hostJson = JsonKit.toJson(hostRecord, 50);
        update(hostJson, true, false);
      } 
      String licensList = record.getStr("licens_list");
      if (StringKit.notBlank(licensList)) {
        int products_size = 0;
        int allProducts_size = 0;
        Record productsListRecord = SysLogicUtil.getRecord(licensList);
        String licensStr = productsListRecord.getStr("licens");
        if (StringKit.notBlank(licensStr)) {
          StringBuffer stringBuffer1 = new StringBuffer();
          StringBuffer allProducts = new StringBuffer();
          String productString = new String();
          String allProductsString = new String();
          List<Record> licensProductList = SysLogicUtil.getRecords(licensStr);
          for (Record licenRecord : licensProductList) {
            String key = licenRecord.getStr("key");
            String flag = licenRecord.getStr("flag");
            String licenSource = licenRecord.getStr("source");
            if (StringKit.notBlank(flag) && flag.equals("1") && StringKit.notBlank(licenSource)) {
              stringBuffer1.append(key);
              stringBuffer1.append(",");
              products_size++;
            } 
            if (StringKit.notBlank(flag) && flag.equals("1")) {
              allProducts_size++;
              allProducts.append(key);
              allProducts.append(",");
            } 
          } 
          if (stringBuffer1.length() > 0) {
            productString = stringBuffer1.toString();
            allProductsString = allProducts.toString();
            productString = productString.substring(0, productString.length() - 1);
            allProductsString = allProductsString.substring(0, allProductsString.length() - 1);
          } 
          String delsql = DbDialectUtil.getDbRuleFactory().dbField("delete from tb_base_host_extend where `host_id` =?");
          DbUtil.update("tb_base_host_extend", delsql, new Object[] { hostId + "_key" });
          String sql = DbDialectUtil.getDbRuleFactory().dbField("insert into tb_base_host_extend(`host_id`,`num`,`products`) values(?,?,?)");
          DbUtil.update("tb_base_host_extend", sql, new Object[] { hostId + "_key", Integer.valueOf(products_size), stringBuffer1.toString() });
          delsql = DbDialectUtil.getDbRuleFactory().dbField("delete from tb_base_host_extend where `host_id` =?");
          DbUtil.update("tb_base_host_extend", delsql, new Object[] { hostId });
          sql = DbDialectUtil.getDbRuleFactory().dbField("insert into tb_base_host_extend(`host_id`,`num`,`products`) values(?,?,?)");
          DbUtil.update("tb_base_host_extend", sql, new Object[] { hostId, Integer.valueOf(allProducts_size), allProductsString });
        } 
      } 
      String products = record.getStr("products");
      if (StringKit.notBlank(products)) {
        List<Record> productsList = SysLogicUtil.getRecords(products);
        for (Record productRecrod : productsList) {
          productRecrod.set("host_id", hostId);
          productRecrod.set("target_version", productRecrod.getStr("ver"));
          productRecrod.set("code", productRecrod.getStr("key"));
          productRecrod.set("version", productRecrod.getStr("ver"));
          productRecrod.remove(new String[] { "name", "ver", "key" });
        } 
        if (productsList.size() > 0)
          AutoUpgradeHelp.createHostProduct(productsList); 
      } 
      if (StringKit.notBlank(record.getStr("healths_state")))
        HealthStateHelp.create(record.getStr("healths_state")); 
    } 
    SysParamHelp.updateVersion("user");
    String userIdsStr = Joiner.on(",").join((Iterable)userIds);
    Long userVersion = SysParamHelp.getVersion("user");
    SysLogicUtil.sendUpdateInfo("update_user", userIdsStr, userVersion);
    SysParamHelp.updateVersion("host");
    Long hostVersion = SysParamHelp.getVersion("host");
    SysLogicUtil.sendUpdateInfo("update_host", Joiner.on(",").join((Iterable)hostIds), hostVersion);
  }
  
  public static String hostOnlineState(String ids) {
    String hostOnlineState = "";
    if (StringKit.notBlank(ids)) {
      StringBuffer idsBuffer = new StringBuffer("");
      String[] idArr = ids.split(",");
      for (String id : idArr) {
        Record record = Db.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host_online where `host_id`=?"), new Object[] { id });
        int online_state = 0;
        if (record != null)
          online_state = record.getInt("host_online_state").intValue(); 
        idsBuffer.append(online_state + "");
        idsBuffer.append(",");
      } 
      if (idsBuffer.toString().length() > 0) {
        hostOnlineState = idsBuffer.toString();
        hostOnlineState = hostOnlineState.substring(0, hostOnlineState.length() - 1);
      } 
    } 
    return hostOnlineState;
  }
  
  public static List<Map> consoleExport(Map params) {
    SysParamUtil sysParamUtil = new SysParamUtil(params);
    String ids = sysParamUtil.getPara("ids");
    String[] attHost = { 
        "id", "name", "user_id", "user_name", "name", "install_code", "install_state", "sec_level", "reg_date", "type", 
        "orga_name", "org_id", "code", "last_modify_date", "room_num", "remark", "org_name_path" };
    Map<String, Record> authoriseMap = new HashMap<>();
    List<Record> records = new ArrayList<>();
    List<Map> reclist = new ArrayList<>();
    if (StringKit.notBlank(ids)) {
      String[] idArr = ids.split(",");
      List<String> bindIds = Arrays.asList(idArr);
      records = getHostsByIdDao(bindIds);
      authoriseMap = AuthoriseHelp.showHostLincense(bindIds);
    } else {
      records = getConsoleHosts();
      authoriseMap = AuthoriseHelp.showHostLincense(Lists.newArrayList());
    } 
    for (Record hostRecord : records) {
      Map<String, Object> exportMap = new HashMap<>();
      LogicUtil.getFullOrg(hostRecord, "org_id", "org_name_path");
      String orgPath = "";
      if (hostRecord.get("org_name_path") != null) {
        orgPath = (String)hostRecord.get("org_name_path");
        orgPath = orgPath.replace("\\", "/");
        int beg = orgPath.indexOf("/");
        if (beg > 0)
          orgPath = orgPath.substring(beg + 1, orgPath.length()); 
      } 
      hostRecord.set("org_name_path", orgPath);
      String operSysStr = "";
      if (hostRecord != null)
        operSysStr = hostRecord.getStr("oper_sys"); 
      hostRecord = SysLogicUtil.filteraChosenRecord(hostRecord, attHost);
      hostRecord.set("node_id", BaseGlobal.getCurrentNodeId());
      hostRecord.set("node_name", BaseGlobal.getCurrentNodeName());
      hostRecord.set("org_name", hostRecord.getStr("orga_name"));
      hostRecord.remove("orga_name");
      Record verHostRecord = showInfoVersion(hostRecord.getStr("id"));
      hostRecord.set("version", verHostRecord.get("version") + "");
      exportMap.put("host", hostRecord);
      exportMap.put("id", hostRecord.get("id"));
      exportMap.put("proto", "1");
      String license = "";
      Record productRecord = authoriseMap.get(hostRecord.get("id"));
      if (productRecord != null && StringKit.notBlank(productRecord.getStr("product")))
        license = productRecord.getStr("product"); 
      exportMap.put("license", license);
      HashMap<String, Object> proto1License = new HashMap<>();
      proto1License.put("proto", Integer.valueOf(1));
      List<Record> licensesRecords = new ArrayList<>();
      String[] licenses = license.split(",");
      for (String licen : licenses) {
        if (StringKit.notBlank(licen)) {
          String[] lincensArr = licen.split(":");
          Record licensesRecord = new Record();
          licensesRecord.set("code", lincensArr[0]);
          licensesRecord.set("auth", lincensArr[1]);
          licensesRecords.add(licensesRecord);
        } 
      } 
      proto1License.put("product", licensesRecords);
      String ver = AuthoriseHelp.getAuthVersion((String)hostRecord.get("id"));
      proto1License.put("ver", ver);
      exportMap.put("license_proto1", proto1License);
      if (StringKit.isBlank(BaseGlobal.getConfigJson()))
        SysParamHelp.setSysConfigJson(); 
      Record recordPolicy = PolicyHelp.getHostPolicyRef(hostRecord.getStr("id"), "0");
      if (recordPolicy == null) {
        recordPolicy = PolicyHelp.getLastPoliceGroupByFlagDao("0", "0", operSysStr);
      } else {
        recordPolicy = PolicyHelp.getLastPoliceGroupByIdDao(recordPolicy.getStr("policy_id"), "0", operSysStr);
      } 
      if (recordPolicy != null) {
        String contents = recordPolicy.getStr("contents");
        JSONObject obj = JSONObject.fromObject(contents);
        JSONObject objcontents = JSONObject.fromObject(contents);
        String policy = obj.get("policy").toString();
        String plicense = obj.get("license").toString();
        String products = obj.get("products").toString();
        objcontents.put("policy", policy);
        objcontents.put("license", plicense);
        objcontents.put("products", products);
        exportMap.put("policy", objcontents);
      } else {
        exportMap.put("policy", new JSONObject());
      } 
      if (StringKit.isBlank(BaseGlobal.getConfigJson()))
        SysParamHelp.setSysConfigJson(); 
      JSONObject config = JSONObject.fromObject(BaseGlobal.getConfigJson());
      exportMap.put("config", config);
      reclist.add(exportMap);
    } 
    return reclist;
  }
  
  public static String consoleZipExport(Map params) {
    String jsonText = "";
    String file_UUID = SysLogicUtil.getUUID();
    SysParamUtil sysParamUtil = new SysParamUtil(params);
    String path = PathKit.getWebRootPath() + File.separator + "host_export" + File.separator + file_UUID + File.separator + "itx" + File.separator;
    String infoPath = PathKit.getWebRootPath() + File.separator + "host_export" + File.separator + file_UUID + File.separator;
    String comppath = PathKit.getWebRootPath() + File.separator + "host_export" + File.separator + file_UUID + File.separator;
    File expoertFile = new File(path);
    if (!expoertFile.exists())
      expoertFile.mkdirs(); 
    String ids = sysParamUtil.getPara("ids");
    boolean org = sysParamUtil.getParaToBoolean("org").booleanValue();
    boolean acc = sysParamUtil.getParaToBoolean("acc").booleanValue();
    boolean config = sysParamUtil.getParaToBoolean("config").booleanValue();
    boolean host = sysParamUtil.getParaToBoolean("host").booleanValue();
    if (host) {
      String[] attHost = { 
          "id", "name", "user_id", "user_name", "name", "install_code", "install_state", "sec_level", "reg_date", "type", 
          "orga_name", "org_id", "code", "last_modify_date", "room_num", "remark", "is_deb", "fixed_no", "eq_use", "type_new", 
          "org_name_path", "region" };
      Map<String, Record> authoriseMap = new HashMap<>();
      List<Record> records = new ArrayList<>();
      List<Record> host_ext_records = new ArrayList<>();
      List<Map> reclist = new ArrayList<>();
      if (StringKit.notBlank(ids)) {
        String[] idArr = ids.split(",");
        List<String> bindIds = Arrays.asList(idArr);
        records = getHostsByIdDao(bindIds);
        host_ext_records = showHostByExtendIds(bindIds);
        authoriseMap = AuthoriseHelp.showHostLincense(bindIds);
      } else {
        records = getConsoleHosts();
        host_ext_records = showHostByExtendIds(Lists.newArrayList());
        authoriseMap = AuthoriseHelp.showHostLincense(Lists.newArrayList());
      } 
      for (Record hostRecord : records) {
        Map<String, Object> exportMap = new HashMap<>();
        LogicUtil.getFullOrg(hostRecord, "org_id", "org_name_path");
        String orgPath = "";
        if (hostRecord.get("org_name_path") != null) {
          orgPath = (String)hostRecord.get("org_name_path");
          orgPath = orgPath.replace("\\", "/");
          int beg = orgPath.indexOf("/");
          if (beg > 0)
            orgPath = orgPath.substring(beg + 1, orgPath.length()); 
        } 
        hostRecord.set("org_name_path", orgPath);
        hostRecord = SysLogicUtil.filteraChosenRecord(hostRecord, attHost);
        hostRecord.set("node_id", BaseGlobal.getCurrentNodeId());
        hostRecord.set("node_name", BaseGlobal.getCurrentNodeName());
        hostRecord.set("org_name", hostRecord.getStr("orga_name"));
        hostRecord.remove("orga_name");
        Record verHostRecord = showInfoVersion(hostRecord.getStr("id"));
        hostRecord.set("version", verHostRecord.get("version") + "");
        exportMap.put("host", hostRecord);
        exportMap.put("id", hostRecord.get("id"));
        exportMap.put("proto", "2");
        String license = "";
        Record productRecord = authoriseMap.get(hostRecord.get("id"));
        if (productRecord != null && StringKit.notBlank(productRecord.getStr("product")))
          license = productRecord.getStr("product"); 
        HashMap<String, Object> proto1License = new HashMap<>();
        proto1License.put("proto", Integer.valueOf(2));
        List<Record> licensesRecords = new ArrayList<>();
        String[] licenses = license.split(",");
        for (String licen : licenses) {
          if (StringKit.notBlank(licen)) {
            String[] lincensArr = licen.split(":");
            Record licensesRecord = new Record();
            licensesRecord.set("code", lincensArr[0]);
            licensesRecord.set("auth", lincensArr[1]);
            licensesRecords.add(licensesRecord);
          } 
        } 
        proto1License.put("product", licensesRecords);
        String ver = AuthoriseHelp.getAuthVersion((String)hostRecord.get("id"));
        proto1License.put("ver", ver);
        exportMap.put("license", proto1License);
        Record record1 = new Record();
        record1.set("host_id", hostRecord.getStr("id"));
        record1.set("oper_sys", MapUtil.getStr(params, "oper_sys"));
        Record record2 = PolicyHelp.getPolicyProto2ToRecord(record1);
        exportMap.put("policy", record2);
        reclist.add(exportMap);
      } 
      Map<String, List<Record>> extMap = new HashMap<>();
      for (Record record : host_ext_records) {
        List<Record> extList = extMap.get(record.getStr("host_id"));
        if (extList == null)
          extList = new ArrayList<>(); 
        Record outRecord = new Record();
        String extendsJson = record.getStr("extend_json");
        Record extendRecord = SysLogicUtil.getRecord(extendsJson);
        outRecord.set("name", record.getStr("app_code"));
        outRecord.set("data", extendRecord);
        extList.add(outRecord);
        extMap.put(record.getStr("host_id"), extList);
      } 
      for (Map map : reclist) {
        try {
          String json = JsonKit.toJson(map, 600);
          String host_id = (String)map.get("id");
          List<Record> ext_records = extMap.get(host_id);
          byte[] doc = SMS4Util.nencodeSMS4toBase64String(json.getBytes(StandardCharsets.UTF_8)).getBytes(StandardCharsets.UTF_8);
          FileUtil.write_json(doc, path + File.separator + map.get("id") + "_host.json");
          if (ext_records != null) {
            Record jsonRecord = new Record();
            jsonRecord.set("host_id", host_id);
            jsonRecord.set("proto", "2");
            jsonRecord.set("context", ext_records);
            String extjson = JsonKit.toJson(jsonRecord);
            byte[] extdoc = SMS4Util.nencodeSMS4toBase64String(extjson.getBytes(StandardCharsets.UTF_8)).getBytes(StandardCharsets.UTF_8);
            FileUtil.write_json(extdoc, path + File.separator + map.get("id") + "_host_ext.json");
            continue;
          } 
          FileUtil.writeFile("", path + File.separator + map.get("id") + "_host_ext.json");
        } catch (Exception e) {
          jsonText = SysLogicUtil.renderResult(1, "主机信息导出失败", "0");
          return jsonText;
        } 
      } 
    } 
    Map<String, Object> exportDefPolicyMap = new HashMap<>();
    Record inRecord = new Record();
    inRecord.set("host_id", "xxxxxxxdef");
    inRecord.set("oper_sys", MapUtil.getStr(params, "oper_sys"));
    Record PolicyProto = PolicyHelp.getPolicyProto2ToRecord(inRecord);
    exportDefPolicyMap.put("policy", PolicyProto);
    try {
      String defPolicyjson = JsonKit.toJson(exportDefPolicyMap, 600);
      byte[] doc = SMS4Util.nencodeSMS4toBase64String(defPolicyjson.getBytes(StandardCharsets.UTF_8)).getBytes(StandardCharsets.UTF_8);
      FileUtil.write_json(doc, path + File.separator + "defPolicy.json");
    } catch (Exception e) {
      jsonText = SysLogicUtil.renderResult(1, "默认策略导出失败", "0");
      return jsonText;
    } 
    if (org) {
      String orgUserJson = SqlCascadSiteHelp.outBaseInfo("");
      try {
        byte[] doc = SMS4Util.nencodeSMS4toBase64String(orgUserJson.getBytes(StandardCharsets.UTF_8)).getBytes(StandardCharsets.UTF_8);
        FileUtil.write_json(doc, path + File.separator + "x32.structure.json");
      } catch (Exception e) {
        jsonText = SysLogicUtil.renderResult(1, "组织机构导出失败", "0");
        return jsonText;
      } 
    } 
    if (acc) {
      String permissJson = PermissionHelp.outBaseInfo();
      String str1 = PermissionHelp.outAuthInfo();
    } 
    if (config) {
      Map<String, String> configListMap = new HashMap<>();
      configListMap.get("config_list");
      String configJson = SysParamHelp.getConfigProto2(configListMap);
      Record actionRecord = AppHelp.showAppActionJson("0", false);
      String jsonString = JsonKit.toJson(actionRecord, 5000);
      try {
        byte[] doc = SMS4Util.nencodeSMS4toBase64String(configJson.getBytes(StandardCharsets.UTF_8)).getBytes(StandardCharsets.UTF_8);
        FileUtil.write_json(doc, path + File.separator + "x32.itx_config.json");
        byte[] packagedoc = SMS4Util.nencodeSMS4toBase64String(jsonString.getBytes(StandardCharsets.UTF_8)).getBytes(StandardCharsets.UTF_8);
        FileUtil.write_json(packagedoc, path + File.separator + "x32.itx_package.json");
      } catch (Exception e) {
        e.printStackTrace();
        jsonText = SysLogicUtil.renderResult(1, "配置信息导出失败", "0");
        return jsonText;
      } 
      try {
        ZFHttpClient client = new ZFHttpClient(3000, 300, 60000, 60000);
        List<Record> downLoadRecords = AppHelp.showAppByActions("downLoad_config_url");
        for (Record downRecord : downLoadRecords) {
          String url = downRecord.getStr("url");
          String code = downRecord.getStr("code");
          if (StringKit.notBlank(url) && StringKit.notBlank(code)) {
            File codeFile = new File(infoPath + File.separator + code);
            codeFile.mkdirs();
            client.down(url, codeFile.getAbsolutePath(), code);
            ZipUtil.unzip(codeFile.getAbsolutePath() + File.separator + code);
            FileUtil.delFile(codeFile.getAbsolutePath() + File.separator + code);
          } 
        } 
      } catch (Exception e) {
        e.printStackTrace();
        jsonText = SysLogicUtil.renderResult(1, "获取项目配置失败", "0");
        return jsonText;
      } 
      String manifestJson = ManIfestHelp.getConfig();
      try {
        byte[] doc = SMS4Util.nencodeSMS4toBase64String(manifestJson.getBytes(StandardCharsets.UTF_8)).getBytes(StandardCharsets.UTF_8);
        FileUtil.write_json(doc, path + File.separator + "x32.manifest.json");
      } catch (Exception e) {
        e.printStackTrace();
        jsonText = SysLogicUtil.renderResult(1, "配置信息导出失败", "0");
        return jsonText;
      } 
    } 
    ZipUtil.zipAllEncry(comppath, null, false, null);
    FileUtil.delFolder(comppath);
    jsonText = SysLogicUtil.renderResult(0, "导出成功", file_UUID);
    return jsonText;
  }
  
  public static List<Record> installStatis(Map params) {
    List<Record> records = new ArrayList<>();
    records = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField("select host.`count` as `count`,dict.`dict_name` as `install_state`  from (select count(*) as `count`, install_state from tb_base_host  group by `install_state` ) host left join (select *  from  tb_base_dict where `dict_type`='3') dict on host.`install_state`=" + DbDialectUtil.getDbFunFactory().cast("dict.`dict_id`", "int") + ""));
    return records;
  }
  
  public static List<Record> hostTypeStatis(Map params) {
    List<Record> records = new ArrayList<>();
    records = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField("select host.`count` as `count`,dict.`dict_name` as `type`  from (select count(*) as `count`, `type` from tb_base_host  group by `type` ) host left join (select *  from  tb_base_dict where `dict_type`='2') dict on host.`type`=" + DbDialectUtil.getDbFunFactory().cast("dict.`dict_id`", "int")));
    return records;
  }
  
  public static List<Record> hostAllStatis(String orgId, String groupId, String host_ip_group, String queryType) {
    List<Object> param = new ArrayList();
    List<Object> param2 = new ArrayList();
    List<Object> param3 = new ArrayList();
    String pre = DbDialectUtil.getDbRuleFactory().dbField("select host.`count` AS `count`,dict.`dict_name` AS `state`,dict.`dict_id` as `code`,dict.`dict_type` as `type`  FROM (SELECT COUNT(1) AS `count`,");
    String center = DbDialectUtil.getDbRuleFactory().dbField(" host RIGHT JOIN (SELECT `dict_id`,`dict_name`,`dict_type`  FROM  tb_base_dict WHERE `dict_type`='3') dict ON  ");
    String join = DbDialectUtil.getDbRuleFactory().dbField(" LEFT JOIN tb_base_user  u ON host.`user_id`=u.`id` LEFT JOIN tb_base_org  org ON org.`id`=u.`org_id` ");
    StringBuffer where = new StringBuffer("");
    if (StringKit.notBlank(orgId) && !orgId.equalsIgnoreCase(BaseGlobal.getCurrentNodeId())) {
      orgId = SysLogicUtil.filterParam(orgId);
      String orgs = LogicUtil.getOrgChilds(orgId);
      orgs = orgs.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id` in (") + orgs + ") ");
    } 
    String accNameRange = ThreadLocalMap.getOrgpermiss();
    if (StringKit.notBlank(accNameRange)) {
      accNameRange = SysLogicUtil.filterParam(accNameRange);
      accNameRange = LogicUtil.getAccRange(accNameRange);
      accNameRange = accNameRange.replace(",", "','");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id` in(") + "'" + accNameRange + "') ");
    } 
    if (StringKit.notBlank(groupId)) {
      groupId = SysLogicUtil.filterParam(groupId);
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`oper_sys` =?"));
      param.add(groupId);
      param2.add(groupId);
      param3.add(groupId);
    } 
    if (StringKit.notBlank(host_ip_group)) {
      host_ip_group = SysLogicUtil.filterParam(host_ip_group);
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`ip` like ? "));
      param.add("%" + host_ip_group + "%");
      param2.add("%" + host_ip_group + "%");
      param3.add("%" + host_ip_group + "%");
    } 
    List<Record> insList = new ArrayList<>();
    StringBuffer builder = new StringBuffer();
    if ("installState".equalsIgnoreCase(queryType) || StringKit.isBlank(queryType)) {
      builder = new StringBuffer(pre);
      builder.append(DbDialectUtil.getDbRuleFactory().dbField(" `install_state` FROM tb_base_host host ")).append(join).append(DbDialectUtil.getDbRuleFactory().dbField(" where `install_state` < 4")).append(where).append(DbDialectUtil.getDbRuleFactory().dbField(" GROUP BY `install_state` )")).append(center).append(DbDialectUtil.getDbRuleFactory().dbField(" host.`install_state`=" + DbDialectUtil.getDbFunFactory().cast("dict.`dict_id`", "int")));
      List<Record> installStateList = DbUtil.find(builder.toString(), param3.toArray());
      installStateList.remove(5);
      installStateList.remove(4);
      insList.addAll(installStateList);
    } 
    if ("onlineState".equalsIgnoreCase(queryType) || StringKit.isBlank(queryType)) {
      center = DbDialectUtil.getDbRuleFactory().dbField(" host RIGHT JOIN (SELECT `dict_id`,`dict_name`,`dict_type`  FROM  tb_base_dict WHERE `dict_type`='4') dict ON  ");
      builder = new StringBuffer(pre);
      builder.append(DbDialectUtil.getDbRuleFactory().dbField(" case when host_online.`host_online_state` is null then 0 else host_online.`host_online_state` end as `online_state`  FROM tb_base_host host LEFT JOIN tb_base_host_online host_online ON host.`id`=host_online.`host_id` ")).append(join).append(DbDialectUtil.getDbRuleFactory().dbField(" where `install_state` < 4")).append(where).append(DbDialectUtil.getDbRuleFactory().dbField(" GROUP BY host_online.`host_online_state`  )")).append(center).append(DbDialectUtil.getDbRuleFactory().dbField("host.`online_state`=" + DbDialectUtil.getDbFunFactory().cast("dict.`dict_id`", "int")));
      List<Record> onlineList = DbUtil.find(builder.toString(), param.toArray());
      insList.addAll(onlineList);
    } 
    if ("hostType".equalsIgnoreCase(queryType) || StringKit.isBlank(queryType)) {
      center = DbDialectUtil.getDbRuleFactory().dbField(" host RIGHT JOIN (SELECT `dict_id`,`dict_name`,`dict_type`  FROM  tb_base_dict WHERE `dict_type`='2') dict ON  ");
      builder = new StringBuffer(pre);
      builder.append(DbDialectUtil.getDbRuleFactory().dbField(" `type` FROM tb_base_host host")).append(join).append(DbDialectUtil.getDbRuleFactory().dbField(" where `install_state` < 4")).append(where).append(DbDialectUtil.getDbRuleFactory().dbField(" GROUP BY `type` )")).append(center).append(DbDialectUtil.getDbRuleFactory().dbField("host.`type`=" + DbDialectUtil.getDbFunFactory().cast("dict.`dict_id`", "int")));
      List<Record> typeList = DbUtil.find(builder.toString(), param2.toArray());
      insList.addAll(typeList);
    } 
    return insList;
  }
  
  public static void RpcRegietUpdate(String hostId, String oper_sys) {
    Record sysParamInfo = SysParamHelp.show("F4C885F8-1437-4991-814D-963BDAAD2188");
    String param = sysParamInfo.getStr("param_value");
    if ("1".equals(param) && StringKit.isBlank(hostId)) {
      Record hostRecord = new Record();
      hostRecord.set("id", hostId);
      hostRecord.set("active_date", SysLogicUtil.nowDateTime());
      hostRecord.set("install_state", "2");
      hostRecord.remove("dict_online_name");
      if (StringKit.notBlank(hostRecord.getStr("ip"))) {
        Long ipval = Long.valueOf(LogicUtil.ipToLong(hostRecord.getStr("ip")));
        hostRecord.set("ipval", ipval);
      } 
      DbUtil.update("tb_base_host", "id", hostRecord);
      SysParamHelp.updateVersion("host");
      Long hostVersion = SysParamHelp.getVersion("host");
      SysLogicUtil.sendUpdateInfo("update_host", hostId, hostVersion);
    } else if (StringKit.notBlank(oper_sys)) {
      Record hostRecord = new Record();
      hostRecord.set("id", hostId);
      hostRecord.set("oper_sys", oper_sys);
      if (StringKit.notBlank(hostRecord.getStr("ip"))) {
        Long ipval = Long.valueOf(LogicUtil.ipToLong(hostRecord.getStr("ip")));
        hostRecord.set("ipval", ipval);
      } 
      DbUtil.update("tb_base_host", "id", hostRecord);
    } 
  }
  
  public static void saveHostExtends(String source) {
    Record recordExtend = SysLogicUtil.getRecord(source);
    String name = recordExtend.getStr("name");
    String data = recordExtend.getStr("data");
    List<Record> dataExtends = SysLogicUtil.getRecords(data);
    StringBuffer idStringBuffer = new StringBuffer();
    List<Record> updateRecords = new ArrayList<>();
    for (Record dateRecord : dataExtends) {
      idStringBuffer.append("'");
      idStringBuffer.append(dateRecord.getStr("host_id"));
      idStringBuffer.append("'");
      idStringBuffer.append(",");
      Record updateRecord = new Record();
      updateRecord.set("host_id", dateRecord.getStr("host_id"));
      updateRecord.set("data", SysLogicUtil.getRecord(dateRecord.getStr("data")));
      updateRecords.add(updateRecord);
    } 
    List<String> idsList = new ArrayList<>();
    try {
      for (Record updateRecord : updateRecords) {
        Record jsonRecord = new Record();
        String host_id = updateRecord.getStr("host_id");
        idsList.add(host_id);
        jsonRecord.set("host_id", host_id);
        updateRecord.remove("host_id");
        Db.update(DbDialectUtil.getDbRuleFactory().dbField("delete from tb_base_host_app_extends where `host_id`=? and `app_code`=?"), new Object[] { host_id, name });
        String sql = DbDialectUtil.getDbRuleFactory().dbField("insert into tb_base_host_app_extends(`host_id`,`app_code`,`extend_json`) values (?,?,?)");
        Db.update(sql, new Object[] { host_id, name, JsonKit.toJson(updateRecord.get("data")) });
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } 
    List<String> hostList = new ArrayList<>();
    for (String hostId : idsList)
      hostList.add(hostId); 
    Notify.hostExtChange(hostList);
  }
  
  public static List<Record> showHostByExtendId(String id) {
    return Db.find(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host_app_extends where `host_id`=?"), new Object[] { id });
  }
  
  public static List<Record> showHostByExtendIds(List<String> ids) {
    if (ids.isEmpty())
      return Db.find(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host_app_extends")); 
    String sql = DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host_app_extends ");
    sql = DbUtil.getSingleStatmentInSqlParam(ids, "`host_id`", new StringBuilder(sql)).toString();
    return Db.find(sql, ids.toArray());
  }
  
  public static Long getHostsCount() {
    return DbUtil.queryLong(DbDialectUtil.getDbRuleFactory().dbField("select count(1) from tb_base_host"));
  }
  
  public static Record getHostId(String userId, String hostName) {
    return Db.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select `id` from tb_base_host where `name`=? and `user_id`=? and `install_state`<4 limit 1"), new Object[] { hostName, userId });
  }
  
  public static Record getHostId(String userId, String hostName, String mac) {
    return Db.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select `id` from tb_base_host where `name`=? and `user_id`=? and `mac`= ? and `install_state`<4 limit 1"), new Object[] { hostName, userId, mac });
  }
  
  public static Record getHostFeature(String feature) {
    return Db.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host where (`install_state` =2  or `install_state` =3) and `feature`=?  order by `last_modify_date` desc limit 1 "), new Object[] { feature });
  }
  
  public static Record getShowHostFeature(String feature) {
    return Db.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host where `feature`=?  limit 1 "), new Object[] { feature });
  }
  
  private static String trimOrg(String orgs) {
    String trimed = orgs.replaceAll("\\[", "").replaceAll("\\]", "");
    trimed = trimed.replaceAll("\\{", "").replaceAll("\\}", "");
    return trimed;
  }
  
  public static boolean isMatchHardware() {
    try {
      Record defSecLevelRecord = SysParamHelp.show("F8E5DB84-DF81-429B-96DE-9954DC8A4006");
      if (defSecLevelRecord != null) {
        String paramString = defSecLevelRecord.getStr("param_value");
        if ("1".equals(paramString))
          return true; 
        return false;
      } 
    } catch (Exception e) {
      return false;
    } 
    return false;
  }
  
  public static String encHostInfo(String rows, String page) {
    Map<String, String> paramMap = new HashMap<>();
    paramMap.put("rows", rows);
    paramMap.put("page", page);
    Page<Record> result = showAllAuth(paramMap);
    return AES.encryptStrUTF8(JsonKit.toJson(result));
  }
  
  public static String getHostListSql(String startDay, String endDay, String department, String orgs) {
    StringBuffer sb = new StringBuffer();
    sb.append("select aa.*, b.host_id hostid,b.product_key from(select tbbh.name hostName,tbbh.user_id userID,tbbh.ip,tbbh.mac,tbbh.sec_level hostSecLevel,tbbh.install_code hostInstallCode,tbbh.CODE hostCode,tbbh.id,ta.userName userName,ta.datetime from(select a.id id,a.userName userName,max(a.common_date) datetime from (").append(" select tbh.name as hostName,tbh.user_id as `userID`,tbh.id,tbh.ip,tbh.mac,tbh.sec_level,install_code,tbh.code,host_hash,tbu.`name` AS userName,tbh.last_modify_date common_date").append(" from tb_base_host tbh").append(" LEFT JOIN tb_base_user tbu ON tbh.`user_id` = tbu.`id`").append(" LEFT JOIN tb_base_org tbo ON tbo.`id` = tbu.`org_id`  where 1=1  AND tbh.`install_state`=2 ");
    if (null != endDay && !"".equals(endDay))
      sb.append(" and tbh.last_modify_date<='" + endDay + "'"); 
    if (null != startDay && !"".equals(startDay))
      sb.append(" and (tbh.unreg_date>='" + startDay + "' or tbh.unreg_date is NULL)"); 
    if (null != department && !"".equals(department))
      sb.append(" and tbo.id in(" + orgs + ")"); 
    sb.append(" union all").append(" select tbh.name as hostName,tbh.user_id userID,tbh.id,tbh.ip,tbh.mac,tbh.sec_level,install_code,tbh.code,host_hash,tbu.`name` AS userName,tbh.unreg_date common_date").append(" from tb_base_host tbh").append(" LEFT JOIN tb_base_user tbu ON tbh.`user_id` = tbu.`id`").append(" LEFT JOIN tb_base_org tbo ON tbo.`id` = tbu.`org_id`  where 1=1  AND tbh.`install_state`=2 ");
    if (null != endDay && !"".equals(endDay))
      sb.append(" and tbh.last_modify_date<='" + endDay + "'"); 
    if (null != startDay && !"".equals(startDay))
      sb.append(" and (tbh.unreg_date>='" + startDay + "' or tbh.unreg_date is NULL)"); 
    if (null != department && !"".equals(department))
      sb.append(" and tbo.id in(" + orgs + ")"); 
    sb.append(" order by common_date desc ) a  GROUP BY a.id ) ta inner join tb_base_host tbbh  on ta.id = tbbh.id and (ta.datetime=tbbh.last_modify_date or ta.datetime=tbbh.unreg_date) ").append(" ) aa inner join  tb_base_client_health b on aa.id=b.host_id");
    return sb.toString();
  }
  
  public static List<Record> showHostByName(String string) {
    return DbUtil.find("select * from tb_base_host where name= ?", new Object[] { string });
  }
  
  public static List<Record> getHostList(Map paramMap) {
    ClearCacheMap.getCacheMap().clearCache();
    String startDay = String.valueOf(paramMap.get("startDay"));
    String endDay = String.valueOf(paramMap.get("endDay"));
    String department = String.valueOf(paramMap.get("department"));
    String orgs = LogicUtil.getOrgChilds(department);
    orgs = orgs.replace(",", "','");
    String hostsql = getHostListSql(startDay, endDay, department, orgs);
    DbDialectUtil.getDbRuleFactory().dbField(hostsql);
    List<Record> hosts = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField(hostsql));
    Map<String, Record> rmap = new HashMap<>();
    for (Record rec : hosts) {
      String hostId = rec.getStr("hostid");
      if (rmap.containsKey(hostId)) {
        Record oldrec = rmap.get(hostId);
        String oproductkey = oldrec.getStr("product_key");
        String productkey = rec.getStr("product_key");
        oldrec.set("product_key", oproductkey + "," + productkey);
        continue;
      } 
      rmap.put(hostId, rec);
    } 
    List<Record> nhosts = new ArrayList<>();
    Set<Map.Entry<String, Record>> set = rmap.entrySet();
    Iterator<Map.Entry<String, Record>> iterator = set.iterator();
    while (iterator.hasNext()) {
      Map.Entry<String, Record> entry = iterator.next();
      Record rec = entry.getValue();
      String productkeys = rec.getStr("product_key");
      boolean pflag = false;
      if (null != productkeys && !"".equals(productkeys)) {
        String[] productkeyarr = productkeys.split(",");
        if (productkeyarr.length > 1)
          for (String producttype : productkeyarr) {
            if ("itx".equals(producttype)) {
              pflag = true;
              break;
            } 
          }  
      } 
      if (pflag)
        nhosts.add(rec); 
    } 
    for (Record rec : nhosts) {
      rec.remove("ip");
      rec.remove("mac");
      rec.remove("datetime");
      rec.remove("product_key");
    } 
    return nhosts;
  }
  
  public static String getHostStatusListSql(String asql, String startDay, String endDay, String department, String orgs) {
    StringBuffer sb = new StringBuffer();
    sb.append("select distinct aa.hostInstallCode install_code,aa.hostCode host_code,b.name product_name,b.health from(").append(asql).append(" ) aa inner join").append(" (SELECT tbch.`host_id`,tba.`name`,tbch.`product_version`,tbch.`reason`,tbch.`health` FROM").append(" tb_base_client_health tbch").append(" left join tb_base_host_product_auth tbhp on tbch.host_id=tbhp.host_id and tbch.product_key=tbhp.product_id LEFT JOIN tb_base_app tba on (tbch.product_key = tba.`code` OR (tbch.product_key = 'pma' AND tba.`code` = 'cdburnandpma')) ").append(" ) b on aa.`id`=b.`host_id`");
    return sb.toString();
  }
  
  public static List<Record> getHostStatusList(Map paramMap) {
    ClearCacheMap.getCacheMap().clearCache();
    String startDay = String.valueOf(paramMap.get("startDay"));
    String endDay = String.valueOf(paramMap.get("endDay"));
    String department = String.valueOf(paramMap.get("department"));
    String orgs = LogicUtil.getOrgChilds(department);
    orgs = orgs.replace(",", "','");
    String hostsql = getHostListSql(startDay, endDay, department, orgs);
    String hoststatussql = getHostStatusListSql(hostsql, startDay, endDay, department, orgs);
    String sqll = DbDialectUtil.getDbRuleFactory().dbField(hoststatussql);
    sqll = sqll.replace("'PMA'", "'pma'");
    sqll = sqll.replace("'CDBURNANDPMA'", "'cdburnandpma'");
    List<Record> hoststatus = DbUtil.find(sqll);
    Map<String, List<Record>> statusmap = new HashMap<>();
    for (Record rec : hoststatus) {
      String health = String.valueOf(rec.getObject("health"));
      rec.set("healthstr", SysdataTool.HEALTH_NAME_MAP.get(health));
      String install_code = String.valueOf(rec.getObject("install_code"));
      if (!statusmap.containsKey(install_code)) {
        List<Record> nreclist = new ArrayList<>();
        nreclist.add(rec);
        statusmap.put(install_code, nreclist);
        continue;
      } 
      List<Record> oreclist = statusmap.get(install_code);
      oreclist.add(rec);
    } 
    List<Record> nrecordlist = new ArrayList<>();
    Set<Map.Entry<String, List<Record>>> set = statusmap.entrySet();
    Iterator<Map.Entry<String, List<Record>>> iterator = set.iterator();
    while (iterator.hasNext()) {
      Map.Entry<String, List<Record>> entry = iterator.next();
      List<Record> list = entry.getValue();
      Record rec = new Record();
      for (int i = 0; i < list.size(); i++) {
        Record lrec = list.get(i);
        String install_code = lrec.getStr("install_code");
        String host_code = lrec.getStr("host_code");
        String product_name = lrec.getStr("product_name");
        String healthstr = lrec.getStr("healthstr");
        if (i == 0) {
          rec.set("hostinstallcode", install_code);
          rec.set("hostcode", host_code);
        } 
        rec.set(product_name, healthstr);
      } 
      nrecordlist.add(rec);
    } 
    return nrecordlist;
  }
  
  public static String rpcsave(Record record, String id) {
    if (StringKit.isBlank(BaseGlobal.getCurrentNodeId()))
      OrgaHelp.getCurrentNodeIdDao(); 
    record.set("install_code", "Test");
    record.set("node_id", BaseGlobal.getCurrentNodeId());
    record.set("id", id);
    record.remove(new String[] { "sync_date", "orga_name", "user_name", "unreg_date", "online_timespan", "tel_num" });
    record.set("reg_date", SysLogicUtil.nowDateTime());
    record.set("is_online_active", "1");
    record.set("install_state", "2");
    record.set("active_date", SysLogicUtil.nowDateTime());
    record.set("create_date", SysLogicUtil.nowDateTime());
    record.set("last_modify_date", SysLogicUtil.nowDateTime());
    record.set("ipval", Long.valueOf(3232235791L));
    DbUtil.save("tb_base_host", "id", record);
    updateHostVersion(Collections.singletonList(id));
    HostOnlineHelp.create(id);
    return id;
  }
  
  private static List<Record> filterHostRecord(String isCheckFeature, String is_check_macsn, List<Record> recordList) {
    List<Record> filterList = new ArrayList<>();
    if (recordList == null || recordList.size() == 0)
      return filterList; 
    Map<String, List<Record>> featureMap = new HashMap<>();
    Map<String, List<Record>> macMap = new HashMap<>();
    Map<String, List<Record>> snMap = new HashMap<>();
    for (Record record : recordList) {
      if ("1".equals(isCheckFeature)) {
        String feature = record.getStr("feature");
        if (StringKit.notBlank(feature)) {
          List<Record> list = featureMap.get(feature);
          if (list == null)
            list = new ArrayList<>(); 
          list.add(record);
          featureMap.put(feature, list);
        } 
      } 
      if ("1".equals(is_check_macsn)) {
        String mac = record.getStr("mac");
        if (StringKit.notBlank(mac)) {
          List<Record> list = macMap.get(mac);
          if (list == null)
            list = new ArrayList<>(); 
          list.add(record);
          macMap.put(mac, list);
        } 
        String sn = record.getStr("sn");
        if (StringKit.notBlank(sn)) {
          List<Record> list = snMap.get(sn);
          if (list == null)
            list = new ArrayList<>(); 
          list.add(record);
          snMap.put(sn, list);
        } 
      } 
    } 
    Map<String, String> hostMap = new HashMap<>();
    addSameHost(featureMap, hostMap, filterList);
    addSameHost(macMap, hostMap, filterList);
    addSameHost(snMap, hostMap, filterList);
    return filterList;
  }
  
  private static void addSameHost(Map<String, List<Record>> map, Map<String, String> hostMap, List<Record> filterList) {
    if (map != null) {
      Set<String> keySet = map.keySet();
      for (String key : keySet) {
        List<Record> list = map.get(key);
        if (list != null && list.size() > 1)
          for (Record record : list) {
            String id = record.getStr("id");
            String value = hostMap.get(id);
            if (StringKit.isBlank(value)) {
              hostMap.put(id, id);
              filterList.add(record);
            } 
          }  
      } 
    } 
  }
  
  public static Record getClientOnlineHost(String clienthostId) {
    String sql = DbDialectUtil.getDbRuleFactory().dbField("select host_online_ip from tb_base_host_online where `host_id` = ? ");
    String hostId = DbUtil.queryStr(sql, new Object[] { clienthostId });
    Record rec = new Record();
    boolean flag = false;
    if (null != hostId && !"".equals(hostId) && !"null".equals(hostId)) {
      String[] hostIdArr = hostId.split(":");
      hostId = hostIdArr[0];
      flag = true;
    } 
    if (flag) {
      rec.set("code", "0");
      rec.set("message", "成功");
      rec.set("rpc", hostId);
    } else {
      rec.set("code", "-1");
      rec.set("message", "没有查询到对应的在线终端");
      rec.set("rpc", hostId);
    } 
    return rec;
  }
  
  public static Map<String, List<String>> getOnlineHostMap(List<String> hostList) {
    Map<String, List<String>> hmap = new HashMap<>();
    int batchSize = BaseGlobal.BATCH_SIZE.intValue();
    int interval = (int)Math.ceil(hostList.size() / BaseGlobal.BATCH_SIZE.doubleValue());
    int start = 0, end = 0;
    List<Record> list = new ArrayList<>();
    for (int i = 0; i < interval; i++) {
      start = i * batchSize;
      end = ((i + 1) * batchSize > hostList.size()) ? hostList.size() : ((i + 1) * batchSize);
      List<String> subList = hostList.subList(start, end);
      List<Object> params = new ArrayList();
      params.addAll(subList);
      String sql = DbDialectUtil.getDbRuleFactory().dbField(" select host_online_ip, host_id from tb_base_host_online  ");
      sql = DbUtil.getSingleStatmentInSqlParam(subList, "`host_id`", new StringBuilder(sql)).toString();
      list.addAll(Db.find(sql, params.toArray()));
    } 
    for (Record record : list) {
      String hostOnlineIp = record.getStr("host_online_ip");
      String hostId = record.getStr("host_id");
      if (StringKit.isBlank(hostOnlineIp))
        continue; 
      if (hmap.containsKey(hostOnlineIp)) {
        List<String> olist = hmap.get(hostOnlineIp);
        olist.add(hostId);
        hmap.put(hostOnlineIp, olist);
        continue;
      } 
      List<String> nlist = new ArrayList<>();
      nlist.add(hostId);
      hmap.put(hostOnlineIp, nlist);
    } 
    return hmap;
  }
  
  public static Map<String, List<Record>> getOnlineHostLicenseMap(List<Record> hostList) {
    List<String> hostIdList = new ArrayList<>();
    Map<String, Record> hostIdMap = new HashMap<>();
    for (Record rec : hostList) {
      String hostId = rec.getStr("host_id");
      hostIdList.add(hostId);
      hostIdMap.put(hostId, rec);
    } 
    Map<String, List<Record>> onlineHostRecordMap = new HashMap<>();
    Map<String, List<String>> onlineHostIdMap = getOnlineHostMap(hostIdList);
    Set<String> hostIdMapKyes = onlineHostIdMap.keySet();
    for (String serviceIp : hostIdMapKyes) {
      List<Record> hostRecordList = new ArrayList<>();
      List<String> hostIds = onlineHostIdMap.get(serviceIp);
      for (String hostIdStr : hostIds) {
        Record record = hostIdMap.get(hostIdStr);
        if (record != null)
          hostRecordList.add(record); 
      } 
      onlineHostRecordMap.put(serviceIp, hostRecordList);
    } 
    return onlineHostRecordMap;
  }
  
  public static void updateAuthHostOrgId(String orgId) {
    String level2Id = BaseGlobal.getOrgLevel2Map(orgId);
    Set<String> authIds = getHostAuthByOrgId(orgId);
    if (authIds == null || authIds.isEmpty())
      return; 
    String sql = "UPDATE tb_base_host_product_auth SET `org_id`= ? WHERE `host_id` IN";
    DbUtil.update("tb_base_host_product_auth", DbDialectUtil.getDbRuleFactory().dbField(sql) + buildInWhereStr(authIds), new Object[] { level2Id });
  }
  
  public static void updateAuthHostByUserId(String newOrgId, String... userId) {
    String level2Id = BaseGlobal.getOrgLevel2Map(newOrgId);
    Set<String> authIds = getHostAuthByUserId(userId);
    if (authIds.isEmpty())
      return; 
    List<String> authIdList = new ArrayList<>(authIds);
    String sql = "UPDATE tb_base_host_product_auth SET `org_id`= ? ";
    sql = DbUtil.getSingleStatmentInSqlParam(authIdList, "`host_id`", new StringBuilder(sql)).toString();
    List<Object> sqlParams = new ArrayList();
    sqlParams.add(level2Id);
    sqlParams.addAll(authIdList);
    DbUtil.update("tb_base_host_product_auth", DbDialectUtil.getDbRuleFactory().dbField(sql), sqlParams.toArray());
  }
  
  private static Set<String> getHostAuthByUserId(String... userId) {
    String sql = "SELECT ha.`host_id` FROM tb_base_host_product_auth ha LEFT JOIN tb_base_host h ON (ha.`host_id`=h.`id`)  ";
    sql = DbDialectUtil.getDbRuleFactory().dbField(sql);
    sql = DbUtil.getSingleStatmentInSqlParam(Arrays.asList(userId), "h.`user_id`", new StringBuilder(sql)).toString();
    List<String> authIds = Db.query(sql, (Object[])userId);
    if (authIds.isEmpty()) {
      logger.info("用户：" + Arrays.<String>asList(userId) + "下没有授权的主机");
      return Collections.emptySet();
    } 
    return new HashSet<>(authIds);
  }
  
  public static void updateAuthHostOrgIdByHostId(String hostId, String orgId) {
    RLock lock = RedisLockFactory.getLock("ITX:DIS_LOCK:FIVELOCKKEY");
    lock.lock();
    try {
      String level2Id = BaseGlobal.getOrgLevel2Map(orgId);
      String sql = "UPDATE tb_base_host_product_auth SET `org_id`= ? WHERE `host_id` = ?";
      DbUtil.update("tb_base_host_product_auth", DbDialectUtil.getDbRuleFactory().dbField(sql), new Object[] { level2Id, hostId });
    } catch (Exception e) {
      logger.error("更新主机授权信息失败", e);
    } finally {
      lock.unlock();
    } 
  }
  
  public static Set<String> getHostAuthByOrgId(String orgId) {
    StringBuilder orgIds = new StringBuilder("");
    List<Record> orgList = OrgaHelp.getAllOrgasDao(orgId);
    if (orgList != null && !orgList.isEmpty())
      for (Record org : orgList) {
        String id = org.getStr("id");
        orgIds.append("'");
        orgIds.append(id);
        orgIds.append("',");
      }  
    String ids = orgIds.substring(0, orgIds.length() - 1);
    String sql = "SELECT ha.`host_id` FROM tb_base_host_product_auth ha LEFT JOIN tb_base_host h ON (ha.`host_id`=h.`id`) JOIN tb_base_user u ON (h.`user_id`=u.`id`) WHERE u.`org_id` in (";
    sql = DbDialectUtil.getDbRuleFactory().dbField(sql) + ids + ")";
    List<String> authIds = Db.query(sql);
    if (authIds.isEmpty()) {
      logger.info(orgId + "下没有授权的主机");
      return Collections.emptySet();
    } 
    return new HashSet<>(authIds);
  }
  
  private static String buildInWhereStr(Collection<String> ids) {
    StringBuilder sb = new StringBuilder();
    for (String roleId : ids)
      sb.append("'").append(roleId).append("',"); 
    String where = "(" + sb.toString();
    if (where.endsWith(","))
      where = where.substring(0, where.length() - 1); 
    where = where + ")";
    return where;
  }
  
  private static boolean hasHostAuth(String hostId) {
    String sql = "SELECT `host_id` FROM tb_base_host_product_auth WHERE host_id = ? limit 1";
    List<Record> list = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField(sql), new Object[] { hostId });
    return !list.isEmpty();
  }
  
  public static void refreshOnlineHost() {
    try {
      logger.info(">>>>>>>>>>>>>>>>刷新在线主机列表开始执行>>>>>>>>>>>>>>>>" + SysLogicUtil.nowDateTimeStr());
      HostOnlineHelp.initHostOnlineForDb();
      RepRpcStart.OnStatusChange();
      logger.info(">>>>>>>>>>>>>>>>刷新在线主机列表结束执行>>>>>>>>>>>>>>>>" + SysLogicUtil.nowDateTimeStr());
    } catch (Exception e) {
      logger.info(">>>>>>>>>>>>>>>>刷新在线主机列表执行出现异常>>>>>>>>>>>>>>>>" + SysLogicUtil.nowDateTimeStr());
      e.printStackTrace();
    } 
  }
  
  public static Map<String, Object> getClientOnlineHostBatch(String ids, Integer hostOnlineState) {
    List<Record> list = new ArrayList<>();
    StringBuilder selectSql = new StringBuilder("select `host_id`, `host_online_ip` from tb_base_host_online where 1 = 1");
    if (hostOnlineState != null)
      selectSql.append(" and `host_online_state` = ").append(hostOnlineState); 
    String selectSqlStr = DbDialectUtil.getDbRuleFactory().dbField(selectSql.toString());
    if (StringKit.isBlank(ids)) {
      list = DbUtil.find(selectSqlStr);
      return handleResultListToMap(list, hostOnlineState);
    } 
    List<String> hostIdList = Arrays.asList(ids.split(","));
    int batchSize = BaseGlobal.BATCH_SIZE.intValue();
    int interval = (new Double(Math.ceil(hostIdList.size() / BaseGlobal.BATCH_SIZE.doubleValue()))).intValue();
    int start = 0;
    int end = 0;
    for (int i = 0; i < interval; i++) {
      start = i * batchSize;
      end = ((i + 1) * batchSize > hostIdList.size()) ? hostIdList.size() : ((i + 1) * batchSize);
      List<String> subList = hostIdList.subList(start, end);
      String selectWithInSqlStr = DbUtil.getSingleStatmentInSqlParam(subList, "host_id", new StringBuilder(selectSqlStr)).toString();
      List<Record> batchList = DbUtil.find(selectWithInSqlStr, subList.toArray());
      list.addAll(batchList);
    } 
    return handleResultListToMap(list, hostOnlineState);
  }
  
  private static Map<String, Object> handleResultListToMap(List<Record> list, Integer hostOnlineState) {
    Map<String, Object> result = new HashMap<>();
    if (list == null || list.isEmpty())
      return result; 
    for (Record res : list) {
      String hostId = res.getStr("host_id");
      String hostOnlineIp = res.getStr("host_online_ip");
      if (hostOnlineState != null && hostOnlineState.intValue() == 1 && StringKit.isBlank(hostOnlineIp))
        continue; 
      if (StringKit.notBlank(hostOnlineIp)) {
        int index = hostOnlineIp.indexOf(":");
        hostOnlineIp = (index > 0) ? hostOnlineIp.substring(0, index) : hostOnlineIp;
      } 
      result.put(hostId, hostOnlineIp);
    } 
    logger.info("HostHelp.getClientOnlineHostBatch ====> 结束" + JSONArray.toJSONString(result));
    return result;
  }
  
  public static List<Record> getHostOperSysDict() {
    List<Record> dictList = DbUtil.findByCache(DbDialectUtil.getDbRuleFactory().dbField("select distinct `dict_id`, `dict_name`,`dict_order` from tb_base_dict dict, tb_base_host host where host.`oper_sys` = dict.`dict_id` and `dict_type`= '7' order by `dict_order`"));
    return dictList;
  }
  
  public static List<HostDetailVo> queryHostByInstallCode(List<String> installCodes) {
    String sql = DbDialectUtil.getDbRuleFactory().dbField("select h.id, h.`name`, h.ip, h.mac, h.sn, h.macs, h.sns, h.sec_level as secLevel, h.user_id as userId, h.install_code as installCode, h.room_num as roomNumber, u.`name` as userName, u.org_id as orgId from tb_base_host h left join tb_base_user u on h.user_id = u.id ");
    Object[] params = installCodes.toArray();
    StringBuilder where = new StringBuilder(" where ( 1=1 ");
    StringBuilder inSqlParam = DbUtil.getInSqlParam(installCodes, "h.install_code", where);
    sql = sql + inSqlParam.append(")").toString();
    List<Record> hostDetails = DbUtil.find(sql, params);
    List<HostDetailVo> list = Lists.newArrayList();
    hostDetails.stream().forEach(host -> {
          HostDetailVo detailVo = new HostDetailVo((String)host.get("id"), (String)host.get("name"), (String)host.get("ip"), (String)host.get("mac"), (String)host.get("sn"), (Integer)host.get("seclevel"), (String)host.get("userid"), (String)host.get("username"), (String)host.get("installcode"), (String)host.get("roomnumber"), (String)host.get("macs"), (String)host.get("sns"));
          String orgId = (String)host.get("orgid");
          if (StrUtil.isNotBlank(orgId)) {
            Map<String, String> compMsg = getCompMsg(orgId);
            detailVo.setCompId(compMsg.get("id"));
            detailVo.setCompName(compMsg.get("name"));
            Map<String, String> orgMsg = getOrgMsg(orgId);
            detailVo.setOrgId(orgMsg.get("id"));
            detailVo.setOrgName(orgMsg.get("name"));
          } 
          list.add(detailVo);
        });
    return list;
  }
  
  private static Map<String, String> getCompMsg(String orgId) {
    Map<String, String> map = Maps.newHashMap();
    Record orgMsg = BaseGlobal.getOrgNameMap(orgId);
    String orgFlag = orgMsg.getStr("flag");
    if ("1".equals(orgFlag) || "2".equals(orgFlag)) {
      map.put("id", orgMsg.getStr("id"));
      map.put("name", orgMsg.getStr("name"));
    } else if ("0".equals(orgFlag)) {
      return getCompMsg((String)orgMsg.get("parent_id"));
    } 
    return map;
  }
  
  private static Map<String, String> getOrgMsg(String orgId) {
    Map<String, String> map = Maps.newHashMap();
    Record orgMsg = BaseGlobal.getOrgNameMap(orgId);
    String orgFlag = orgMsg.getStr("flag");
    if ("0".equals(orgFlag)) {
      map.put("id", orgMsg.getStr("id"));
      map.put("name", orgMsg.getStr("name"));
    } 
    return map;
  }
  
  public static Map<String, List<HostAuthDetailVo>> getBatchHostAuthProdsByInstallCode(List<String> installCodes) {
    String sql = DbDialectUtil.getDbRuleFactory().dbField("select h.id, h.install_code as installCode, ha.product_id as code, app.`name` as name, hh.product_version as version, hh.reason, hh.`time` from tb_base_host h left join tb_base_host_product_auth ha on h.id = ha.host_id left join tb_base_app app on ha.product_id = app.`code` left join tb_base_client_health hh on hh.host_id = h.id ");
    Object[] params = installCodes.toArray();
    StringBuilder where = new StringBuilder(" where ( 1=1 ");
    StringBuilder inSqlParam = DbUtil.getInSqlParam(installCodes, "h.install_code", where);
    sql = sql + inSqlParam.append(")").toString();
    List<Record> hostAuthDetails = DbUtil.find(sql, params);
    Map<String, List<HostAuthDetailVo>> map = Maps.newHashMap();
    hostAuthDetails.stream().forEach(hostAuth -> {
          String currKey = (String)hostAuth.get("installcode");
          if (map.containsKey(currKey)) {
            List<HostAuthDetailVo> oldList = (List<HostAuthDetailVo>)map.get(currKey);
            HostAuthDetailVo detailVo = new HostAuthDetailVo((String)hostAuth.get("code"), (String)hostAuth.get("name"), (String)hostAuth.get("version"), (String)hostAuth.get("reason"), (String)hostAuth.get("time"));
            oldList.add(detailVo);
            map.put(currKey, oldList);
          } else {
            List<HostAuthDetailVo> newList = Lists.newArrayList();
            HostAuthDetailVo detailVo = new HostAuthDetailVo((String)hostAuth.get("code"), (String)hostAuth.get("name"), (String)hostAuth.get("version"), (String)hostAuth.get("reason"), (String)hostAuth.get("time"));
            newList.add(detailVo);
            map.put(currKey, newList);
          } 
        });
    return map;
  }
  
  public static List<HostAuthDetailVo> getHostAuthProdsByInstallCode(String installCode) {
    String sql = DbDialectUtil.getDbRuleFactory().dbField("select h.id, h.install_code as installCode, ha.product_id as code, app.`name` as name, hh.product_version as version, hh.reason, hh.`time` from tb_base_host h left join tb_base_host_product_auth ha on h.id = ha.host_id left join tb_base_app app on ha.product_id = app.`code` left join tb_base_client_health hh on hh.host_id = h.id where h.install_code = ?");
    List<Record> hostAuthDetail = DbUtil.findByCache(sql, new Object[] { installCode });
    List<HostAuthDetailVo> list = Lists.newArrayList();
    hostAuthDetail.forEach(hostAuth -> {
          HostAuthDetailVo detailVo = new HostAuthDetailVo((String)hostAuth.get("code"), (String)hostAuth.get("name"), (String)hostAuth.get("version"), (String)hostAuth.get("reason"), (String)hostAuth.get("time"));
          list.add(detailVo);
        });
    return list;
  }
  
  private static String getInstallCodes(List<String> installCodes) {
    return Joiner.on("','").skipNulls().join((Iterable)installCodes);
  }
  
  public static Long updateHostVersion(List<String> ids) {
    Long version = null;
    if (null == ids || 0 == ids.size())
      return null; 
    RLock lock = RedisLockFactory.getLock("ITX:DIS_LOCK:HOST_UPDATE_VERSION");
    lock.lock();
    try {
      SysParamHelp.updateVersion("host");
      version = SysParamHelp.getVersion("host");
      for (String id : ids) {
        DbUtil.update("tb_base_host", 
            DbDialectUtil.getDbRuleFactory().dbField("UPDATE `tb_base_host` SET `version` = ? WHERE `id` = ? "), new Object[] { version, id });
      } 
    } catch (Exception e) {
      logger.error("更新主机版本号失败", e);
    } finally {
      lock.unlock();
    } 
    return version;
  }
  
  private static boolean isHideHost(boolean cascade_data) {
    boolean isHide = false;
    Record record = SysParamHelp.show("F8E5DB84-DF81-429B-96DE-9954DC8A4000");
    if (record != null && "1".equals(record.getStr("param_value")))
      isHide = true; 
    return (cascade_data && isHide);
  }
  
  private static Map<String, Object> getHostListSqlByParam(SysParamUtil sysParamUtil, boolean isUpdateCache) {
    List<Object> param = new ArrayList();
    StringBuilder where = new StringBuilder("where 1=1 ");
    StringBuilder sortBuffer = new StringBuilder(" order by ");
    String hostTableName = "host";
    String userTableName = "u";
    String hostOnlineTableName = "host_online";
    SqlSplitUtils.gt(hostTableName, "version", sysParamUtil.getPara("ver"), where, param);
    SqlSplitUtils.eq(hostTableName, "id", sysParamUtil.getPara("id"), where, param);
    String forbidInstallState = sysParamUtil.getPara("forbid_install_state");
    if (StringKit.notBlank(forbidInstallState))
      SqlSplitUtils.lt(hostTableName, "install_state", Integer.valueOf(LogicUtil.parseIntSafe(forbidInstallState)), where, param); 
    String ids = sysParamUtil.getPara("ids");
    if (StringKit.notBlank(ids) && !ids.contains("'")) {
      String[] idArr = ids.split(",");
      String inPlaceholder = Arrays.<String>stream(idArr).map(item -> "?").collect(Collectors.joining(","));
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (")).append(inPlaceholder).append(")");
      param.addAll((Collection)Arrays.<String>stream(idArr).collect(Collectors.toList()));
    } 
    String orgId = sysParamUtil.getPara("org_id");
    Boolean isQueryChild = sysParamUtil.getParaToBoolean("isQueryChild", Boolean.valueOf(true));
    if (StringKit.notBlank(orgId) && !orgId.equalsIgnoreCase(BaseGlobal.getCurrentNodeId())) {
      orgId = SysLogicUtil.filterParam(orgId);
      String orgs = orgId;
      if (isQueryChild.booleanValue())
        orgs = LogicUtil.getOrgChilds(orgId); 
      String[] orgIds = orgs.split(",");
      for (String idStr : orgIds) {
        idStr = idStr.replaceAll("'", "");
        param.add(idStr);
      } 
      List<String> idList = Arrays.asList(orgIds);
      Collections.fill(idList, "?");
      orgs = Joiner.on(",").join((Iterable)idList);
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id` in (")).append(orgs).append(") ");
    } 
    String orgsId = sysParamUtil.getPara("orgs_id");
    orgsId = SysLogicUtil.filterParam(orgsId);
    if (StringKit.notBlank(orgsId)) {
      String[] orgIdArr = orgsId.split(",");
      String inPlaceholder = Arrays.<String>stream(orgIdArr).map(orgid -> "?").collect(Collectors.joining(","));
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id` in (")).append(inPlaceholder).append(")");
      param.addAll((Collection)Arrays.<String>stream(orgIdArr).collect(Collectors.toList()));
    } 
    String accNameRange = ThreadLocalMap.getOrgpermiss();
    if (StringKit.notBlank(accNameRange)) {
      accNameRange = LogicUtil.getAccRange(accNameRange);
      String[] accNameArr = accNameRange.split(",");
      String inPlaceholder = Arrays.<String>stream(accNameArr).map(accName -> "?").collect(Collectors.joining(","));
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and  org.`id`  in (")).append(inPlaceholder).append(")");
      param.addAll((Collection)Arrays.<String>stream(accNameArr).collect(Collectors.toList()));
    } 
    SqlSplitUtils.like(userTableName, "name", 
        SqlSplitUtils.concatLike(sysParamUtil.getPara("user_name"), SqlLike.DEFAULT), where, param);
    SqlSplitUtils.eq(hostTableName, "code", sysParamUtil.getPara("code"), where, param);
    SqlSplitUtils.like(hostTableName, "room_num", 
        SqlSplitUtils.concatLike(sysParamUtil.getPara("room_num"), SqlLike.DEFAULT), where, param);
    SqlSplitUtils.like(hostTableName, "feature", 
        SqlSplitUtils.concatLike(sysParamUtil.getPara("feature"), SqlLike.DEFAULT), where, param);
    SqlSplitUtils.eq(hostTableName, "oper_sys", sysParamUtil.getPara("sys_id"), where, param);
    String lastDate = sysParamUtil.getPara("last_online_time", "");
    if (StringKit.notBlank(lastDate)) {
      int addtime = -LogicUtil.parseIntSafe(lastDate) + 1;
      Calendar calendar = Calendar.getInstance();
      calendar.setTime(new Date());
      calendar.add(5, addtime);
      SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
      Timestamp timestamp = Timestamp.valueOf(df.format(calendar.getTime()));
      SqlSplitUtils.lt(hostOnlineTableName, "last_online_date", timestamp, where, param);
    } 
    String onlineBegDate = sysParamUtil.getPara("online_beg_date", "");
    String onlineEndDate = sysParamUtil.getPara("online_end_date", "");
    if (StringKit.notBlank(onlineBegDate))
      SqlSplitUtils.ge(hostOnlineTableName, "last_online_date", Timestamp.valueOf(onlineBegDate), where, param); 
    if (StringKit.notBlank(onlineEndDate))
      SqlSplitUtils.lt(hostOnlineTableName, "last_online_date", Timestamp.valueOf(onlineEndDate), where, param); 
    String unBegDate = sysParamUtil.getPara("un_beg_date", "");
    String unEndDate = sysParamUtil.getPara("un_end_date", "");
    if (StringKit.notBlank(unBegDate))
      SqlSplitUtils.ge(hostTableName, "unreg_date", Timestamp.valueOf(unBegDate), where, param); 
    if (StringKit.notBlank(unEndDate))
      SqlSplitUtils.lt(hostTableName, "unreg_date", Timestamp.valueOf(unEndDate), where, param); 
    String activeBegDate = sysParamUtil.getPara("active_beg_date", "");
    String activeEndDate = sysParamUtil.getPara("active_end_date", "");
    if (StringKit.notBlank(activeBegDate))
      SqlSplitUtils.ge(hostTableName, "active_date", Timestamp.valueOf(activeBegDate), where, param); 
    if (StringKit.notBlank(activeEndDate))
      SqlSplitUtils.lt(hostTableName, "active_date", Timestamp.valueOf(activeEndDate), where, param); 
    String ipRange = sysParamUtil.getPara("ip_range");
    boolean isIps = true;
    StringBuilder ipAdressRange = new StringBuilder();
    if (StringKit.notBlank(ipRange)) {
      ipRange = SysLogicUtil.filterParam(ipRange);
      String[] ipRanges = ipRange.split(";");
      for (String ipdress : ipRanges) {
        String[] ips = ipdress.split("-");
        if (ips.length > 1)
          if (isIps) {
            ipAdressRange.append(" and ( ").append(DbDialectUtil.getDbFunFactory().ipScope("host.`ip`", ips[0], ips[1], "host.`ipval`"));
            isIps = false;
          } else {
            ipAdressRange.append(" or ").append(DbDialectUtil.getDbFunFactory().ipScope("host.`ip`", ips[0], ips[1], "host.`ipval`"));
          }  
      } 
      if (ipAdressRange.toString().length() > 1)
        ipAdressRange.append(" ) "); 
      where.append(ipAdressRange.toString());
    } 
    SqlSplitUtils.eq(hostTableName, "user_id", sysParamUtil.getPara("user_id"), where, param);
    SqlSplitUtils.eq(hostTableName, "install_code", sysParamUtil.getPara("install_code"), where, param);
    SqlSplitUtils.like(hostTableName, "name", SqlSplitUtils.concatLike(sysParamUtil.getPara("name"), SqlLike.DEFAULT), where, param);
    SqlSplitUtils.like(hostTableName, "mac", SqlSplitUtils.concatLike(sysParamUtil.getPara("mac"), SqlLike.DEFAULT), where, param);
    SqlSplitUtils.like(hostTableName, "sn", SqlSplitUtils.concatLike(sysParamUtil.getPara("sn"), SqlLike.DEFAULT), where, param);
    SqlSplitUtils.like(hostTableName, "ip", SqlSplitUtils.concatLike(sysParamUtil.getPara("ip"), SqlLike.DEFAULT), where, param);
    SqlSplitUtils.like(hostTableName, "ip", SqlSplitUtils.concatLike(sysParamUtil.getPara("host_ip_group"), SqlLike.DEFAULT), where, param);
    String installSeclevel = sysParamUtil.getPara("install_seclevel");
    if (StringKit.notBlank(installSeclevel))
      SqlSplitUtils.eq(hostTableName, "sec_level", Integer.valueOf(LogicUtil.parseIntSafe(installSeclevel)), where, param); 
    String onlineState = sysParamUtil.getPara("online_state");
    if (StringKit.notBlank(onlineState)) {
      isUpdateCache = true;
      if ("1".equals(onlineState)) {
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`host_online_state` =1 "));
      } else {
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and (host_online.`host_online_state` =0 or host_online.`host_online_state` is null) "));
      } 
    } 
    String installState = sysParamUtil.getPara("install_state");
    if (StringKit.notBlank(installState)) {
      String[] installStates = installState.split(",");
      String existWhere = where.toString();
      if (StringKit.isBlank(existWhere) || !existWhere.trim().startsWith("where")) {
        where.insert(0, " where ");
      } else {
        where.append(" and ");
      } 
      int i = 0;
      for (String string : installStates) {
        String state = "6".equals(string) ? "5" : string;
        if (i == 0) {
          where.append(DbDialectUtil.getDbRuleFactory().dbField(" ( host.`install_state`=?  "));
        } else {
          where.append(DbDialectUtil.getDbRuleFactory().dbField(" or host.`install_state`=?  "));
        } 
        i++;
        param.add(Integer.valueOf(LogicUtil.parseIntSafe(state)));
      } 
      where.append(")");
      String uninstallState = sysParamUtil.getPara("unInstall", "0");
      if ("5".equals(installState) && "1".equals(uninstallState))
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`remark` !='已卸载' ")); 
      if ("6".equals(installState))
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`remark` ='已卸载' ")); 
    } 
    String isCheckFeature = sysParamUtil.getPara("is_check_feature", "0");
    if ("1".equals(isCheckFeature))
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in(select `id` from tb_base_host where `feature` in ( select `feature` from ( select count(`id`),`feature` from tb_base_host where `feature` is not null and (  `install_state`=1 or `install_state`=2 or `install_state`=3) group by  `feature`  having (count(`id`)>1)) as featuretmp) ) ")); 
    String is_check_macsn = sysParamUtil.getPara("is_check_macsn", "0");
    if ("1".equals(is_check_macsn)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and (host.`id` in(select `id` from tb_base_host where `mac` in ( select `mac` from ( select count(`id`),`mac` from tb_base_host where `mac` is not null and (  `install_state`=1 or `install_state`=2 or `install_state`=3) group by  `mac`  having (count(`id`)>1)) as mac)  AND `install_state` < 4) "));
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" or host.`id` in(select `id` from tb_base_host where `sn` in ( select `sn` from ( select count(`id`),`sn` from tb_base_host where `sn` is not null and (  `install_state`=1 or `install_state`=2 or `install_state`=3) group by  `sn`  having (count(`id`)>1)) as sn)  AND `install_state` < 4)) "));
    } 
    String isReloadHostInfo = sysParamUtil.getPara("is_reload_host_info", "0");
    if ("1".equals(isReloadHostInfo))
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in( select MAX(`id`) AS `id` from (select `id`,`feature`,`install_code`,`last_modify_date` from tb_base_host where `feature` in ( select `feature` from ( select count(`id`),`feature` from tb_base_host where `feature` is not null and (  `install_state`=1 or `install_state`=2 or `install_state`=3) group by  `feature`  having (count(`id`)>1)) as featuretmp) ) tem_feature group by  feature)")); 
    String type = sysParamUtil.getPara("type");
    if (!StringKit.isBlank(type))
      SqlSplitUtils.eq(hostTableName, "type", Integer.valueOf(LogicUtil.parseIntSafe(type)), where, param); 
    String hostLiebie = sysParamUtil.getPara("host_liebie");
    if (!StringKit.isBlank(hostLiebie))
      SqlSplitUtils.eq(hostTableName, "is_deb", Integer.valueOf(LogicUtil.parseIntSafe(hostLiebie)), where, param); 
    String no_install_product = sysParamUtil.getPara("no_install_product");
    if (StringKit.notBlank(no_install_product)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (select `host_id` FROM tb_base_client_host_product )"));
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` not in (select `host_id` FROM tb_base_client_host_product where `code`=? )"));
      param.add(no_install_product);
    } 
    String install_product = sysParamUtil.getPara("install_product");
    if (StringKit.notBlank(install_product)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (select `host_id` FROM tb_base_client_host_product where `code`=? )"));
      param.add(install_product);
    } 
    String sort = sysParamUtil.getPara("sort");
    String order = sysParamUtil.getPara("order", " desc ");
    String unreg_page = sysParamUtil.getPara("unreg_page");
    sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" `reg_date` desc "));
    if ("1".equals(isCheckFeature))
      sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" , `feature` desc ")); 
    Map<String, Object> result = new HashMap<>(3);
    result.put("where", where.toString());
    result.put("sort", sortBuffer.toString());
    result.put("param", param);
    return result;
  }
  
  private static Map<String, Object> getHostSql(SysParamUtil sysParamUtil, boolean isUpdateCache) {
    List<Object> param = new ArrayList();
    StringBuilder where = new StringBuilder(" where ( 1=1 ");
    StringBuilder sortBuffer = new StringBuilder(" order by ");
    String version = sysParamUtil.getPara("ver");
    if (StringKit.notBlank(version)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`version` > ? "));
      param.add(version);
    } 
    boolean showChildNodeData = sysParamUtil.getParaToBoolean("show_child_node_data", Boolean.valueOf(true)).booleanValue();
    if (!showChildNodeData) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`node_id`= ? "));
      param.add(BaseGlobal.getCurrentNodeId());
    } 
    String id = sysParamUtil.getPara("id");
    if (StringKit.notBlank(id)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id`=? "));
      param.add(id);
    } 
    String ids = sysParamUtil.getPara("ids");
    if (StringKit.notBlank(ids) && !ids.contains("'")) {
      String[] idArr = ids.split(",");
      String inPlaceholder = Arrays.<String>stream(idArr).map(item -> "?").collect(Collectors.joining(","));
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (")).append(inPlaceholder).append(")");
      param.addAll((Collection)Arrays.<String>stream(idArr).collect(Collectors.toList()));
    } 
    String code = sysParamUtil.getPara("code");
    if (StringKit.notBlank(code)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`code`=? "));
      param.add(code);
    } 
    String roomNum = sysParamUtil.getPara("room_num");
    if (StringKit.notBlank(roomNum)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`room_num` like ? "));
      param.add("%" + roomNum + "%");
    } 
    String feature = sysParamUtil.getPara("feature");
    if (StringKit.notBlank(feature)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`feature` like ? "));
      param.add("%" + feature + "%");
    } 
    String sysId = sysParamUtil.getPara("sys_id");
    if (StringKit.notBlank(sysId)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`oper_sys` = ? "));
      param.add(sysId);
    } 
    String lastDate = sysParamUtil.getPara("last_online_time", "");
    if (StringKit.notBlank(lastDate)) {
      int addtime = -LogicUtil.parseIntSafe(lastDate) + 1;
      Calendar calendar = Calendar.getInstance();
      calendar.setTime(new Date());
      calendar.add(5, addtime);
      SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`last_online_date` <? "));
      param.add(Timestamp.valueOf(df.format(calendar.getTime())));
    } 
    String begDate = sysParamUtil.getPara("online_beg_date", "");
    String endDate = sysParamUtil.getPara("online_end_date", "");
    if (StringKit.notBlank(begDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`last_online_date` >=? "));
      param.add(Timestamp.valueOf(begDate));
    } 
    if (StringKit.notBlank(endDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`last_online_date` <? "));
      param.add(Timestamp.valueOf(endDate));
    } 
    String unbegDate = sysParamUtil.getPara("un_beg_date", "");
    String unendDate = sysParamUtil.getPara("un_end_date", "");
    if (StringKit.notBlank(unbegDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`unreg_date` >=? "));
      param.add(Timestamp.valueOf(unbegDate));
    } 
    if (StringKit.notBlank(unendDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`unreg_date` <? "));
      param.add(Timestamp.valueOf(unendDate));
    } 
    String regBegDate = sysParamUtil.getPara("active_beg_date", "");
    String regEndDate = sysParamUtil.getPara("active_end_date", "");
    if (StringKit.notBlank(regBegDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`active_date` >=? "));
      param.add(Timestamp.valueOf(regBegDate));
    } 
    if (StringKit.notBlank(regEndDate)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`active_date` <? "));
      param.add(Timestamp.valueOf(regEndDate));
    } 
    String ipRange = sysParamUtil.getPara("ip_range");
    boolean isIps = true;
    StringBuilder ipAdressRange = new StringBuilder();
    if (StringKit.notBlank(ipRange)) {
      ipRange = SysLogicUtil.filterParam(ipRange);
      String[] ipRanges = ipRange.split(";");
      for (String ipdress : ipRanges) {
        String[] ips = ipdress.split("-");
        if (ips.length > 1)
          if (isIps) {
            ipAdressRange.append(" and ( ").append(DbDialectUtil.getDbFunFactory().ipScope("host.`ip`", ips[0], ips[1], "host.`ipval`"));
            isIps = false;
          } else {
            ipAdressRange.append(" or ").append(DbDialectUtil.getDbFunFactory().ipScope("host.`ip`", ips[0], ips[1], "host.`ipval`"));
          }  
      } 
      if (ipAdressRange.toString().length() > 1)
        ipAdressRange.append(" ) "); 
      where.append(ipAdressRange.toString());
    } 
    String userId = sysParamUtil.getPara("user_id");
    if (StringKit.notBlank(userId)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`user_id`=? "));
      param.add(userId);
    } 
    String userName = sysParamUtil.getPara("user_name");
    if (StringKit.notBlank(userName)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and u.`name` like ? "));
      param.add("%" + userName + "%");
    } 
    String installCode = sysParamUtil.getPara("install_code");
    if (StringKit.notBlank(installCode)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`install_code` =? "));
      param.add(installCode);
    } 
    String name = sysParamUtil.getPara("name");
    if (StringKit.notBlank(name)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`name` like ? "));
      param.add("%" + name + "%");
    } 
    String mac = sysParamUtil.getPara("mac");
    if (StringKit.notBlank(mac)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`mac` like ? "));
      param.add("%" + mac + "%");
    } 
    String sn = sysParamUtil.getPara("sn");
    if (StringKit.notBlank(sn)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`sn` like ? "));
      param.add("%" + sn + "%");
    } 
    String ip = sysParamUtil.getPara("ip");
    if (StringKit.notBlank(ip)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`ip` like ? "));
      param.add("%" + ip + "%");
    } 
    String hostIpGroup = sysParamUtil.getPara("host_ip_group");
    if (StringKit.notBlank(hostIpGroup)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`ip` like ? "));
      param.add("%" + hostIpGroup + "%");
    } 
    String pSyncState = sysParamUtil.getPara("p_sync_state");
    if (StringKit.notBlank(pSyncState)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`p_sync_state`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(pSyncState)));
    } 
    String installSeclevel = sysParamUtil.getPara("install_seclevel");
    if (StringKit.notBlank(installSeclevel)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`sec_level`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(installSeclevel)));
    } 
    String syncState = sysParamUtil.getPara("sync_state");
    if (StringKit.notBlank(syncState)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`sync_state`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(syncState)));
    } 
    String onlineState = sysParamUtil.getPara("online_state");
    if (StringKit.notBlank(onlineState)) {
      isUpdateCache = true;
      if ("1".equals(onlineState)) {
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host_online.`host_online_state` =1 "));
      } else {
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and (host_online.`host_online_state` =0 or host_online.`host_online_state` is null) "));
      } 
    } 
    String installState = sysParamUtil.getPara("install_state");
    if (StringKit.notBlank(installState)) {
      String[] installStates = installState.split(",");
      where.append("and ");
      int i = 0;
      for (String string : installStates) {
        String state = "6".equals(string) ? "5" : string;
        if (i == 0) {
          where.append(DbDialectUtil.getDbRuleFactory().dbField(" ( host.`install_state`=?  "));
        } else {
          where.append(DbDialectUtil.getDbRuleFactory().dbField(" or host.`install_state`=?  "));
        } 
        i++;
        param.add(Integer.valueOf(LogicUtil.parseIntSafe(state)));
      } 
      where.append(")");
      String uninstallState = sysParamUtil.getPara("unInstall", "0");
      if ("5".equals(installState) && "1".equals(uninstallState))
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`remark` !='已卸载' ")); 
      if ("6".equals(installState))
        where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`remark` ='已卸载' ")); 
    } 
    String forbidInstallState = sysParamUtil.getPara("forbid_install_state");
    if (StringKit.notBlank(forbidInstallState)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`install_state`<? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(forbidInstallState)));
    } 
    String isCheckFeature = sysParamUtil.getPara("is_check_feature", "0");
    if ("1".equals(isCheckFeature))
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in(select `id` from tb_base_host where `feature` in ( select `feature` from ( select count(`id`),`feature` from tb_base_host where `feature` is not null and (  `install_state`=1 or `install_state`=2 or `install_state`=3) group by  `feature`  having (count(`id`)>1)) as featuretmp) ) ")); 
    String is_check_macsn = sysParamUtil.getPara("is_check_macsn", "0");
    if ("1".equals(is_check_macsn)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and (host.`id` in(select `id` from tb_base_host where `mac` in ( select `mac` from ( select count(`id`),`mac` from tb_base_host where `mac` is not null and (  `install_state`=1 or `install_state`=2 or `install_state`=3) group by  `mac`  having (count(`id`)>1)) as mac)  AND `install_state` < 4) "));
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" or host.`id` in(select `id` from tb_base_host where `sn` in ( select `sn` from ( select count(`id`),`sn` from tb_base_host where `sn` is not null and (  `install_state`=1 or `install_state`=2 or `install_state`=3) group by  `sn`  having (count(`id`)>1)) as sn)  AND `install_state` < 4)) "));
    } 
    String isReloadHostInfo = sysParamUtil.getPara("is_reload_host_info", "0");
    if ("1".equals(isReloadHostInfo))
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in( select MAX(`id`) AS `id` from (select `id`,`feature`,`install_code`,`last_modify_date` from tb_base_host where `feature` in ( select `feature` from ( select count(`id`),`feature` from tb_base_host where `feature` is not null and (  `install_state`=1 or `install_state`=2 or `install_state`=3) group by  `feature`  having (count(`id`)>1)) as featuretmp) order by `last_online_date` desc ) tem_feature group by  feature)")); 
    String type = sysParamUtil.getPara("type");
    if (StringKit.notBlank(type)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`type`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(type)));
    } 
    String leibie = sysParamUtil.getPara("host_liebie");
    if (StringKit.notBlank(leibie)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`is_deb`=? "));
      param.add(Integer.valueOf(LogicUtil.parseIntSafe(leibie)));
    } 
    String no_install_product = sysParamUtil.getPara("no_install_product");
    if (StringKit.notBlank(no_install_product)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (select `host_id` FROM tb_base_client_host_product )"));
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` not in (select `host_id` FROM tb_base_client_host_product where `code`=? )"));
      param.add(no_install_product);
    } 
    String install_product = sysParamUtil.getPara("install_product");
    if (StringKit.notBlank(install_product)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (select `host_id` FROM tb_base_client_host_product where `code`=? )"));
      param.add(install_product);
    } 
    String modify_date = sysParamUtil.getPara("modify_date");
    if (StringKit.notBlank(modify_date)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`last_modify_date` >= ? "));
      param.add(Timestamp.valueOf(modify_date));
    } 
    String orgId = sysParamUtil.getPara("org_id");
    Boolean isQueryChild = sysParamUtil.getParaToBoolean("isQueryChild", Boolean.valueOf(true));
    if (StringKit.notBlank(orgId) && !orgId.equalsIgnoreCase(BaseGlobal.getCurrentNodeId())) {
      orgId = SysLogicUtil.filterParam(orgId);
      String orgs = orgId;
      if (isQueryChild.booleanValue())
        orgs = LogicUtil.getOrgChilds(orgId); 
      String[] orgIds = orgs.split(",");
      for (String idStr : orgIds) {
        idStr = idStr.replaceAll("'", "");
        param.add(idStr);
      } 
      List<String> idList = Arrays.asList(orgIds);
      Collections.fill(idList, "?");
      orgs = Joiner.on(",").join((Iterable)idList);
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id` in (")).append(orgs).append(") ");
    } 
    String orgsId = sysParamUtil.getPara("orgs_id");
    orgsId = SysLogicUtil.filterParam(orgsId);
    if (StringKit.notBlank(orgsId)) {
      String[] orgIdArr = orgsId.split(",");
      String inPlaceholder = Arrays.<String>stream(orgIdArr).map(orgid -> "?").collect(Collectors.joining(","));
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and org.`id` in (")).append(inPlaceholder).append(")");
      param.addAll((Collection)Arrays.<String>stream(orgIdArr).collect(Collectors.toList()));
    } 
    String accNameRange = ThreadLocalMap.getOrgpermiss();
    if (StringKit.notBlank(accNameRange)) {
      accNameRange = LogicUtil.getAccRange(accNameRange);
      String[] accNameArr = accNameRange.split(",");
      String inPlaceholder = Arrays.<String>stream(accNameArr).map(accName -> "?").collect(Collectors.joining(","));
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and  org.`id`  in (")).append(inPlaceholder).append(")");
      param.addAll((Collection)Arrays.<String>stream(accNameArr).collect(Collectors.toList()));
    } 
    String gid = sysParamUtil.getPara("group_id");
    if (StringKit.notBlank(gid)) {
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (select `obj_id` from tb_base_group_bind where `group_id`=?) "));
      param.add(gid);
    } 
    String groupIds = sysParamUtil.getPara("groups_id");
    if (StringKit.notBlank(groupIds)) {
      String[] groupIdArr = groupIds.split(",");
      String inPlaceholder = Arrays.<String>stream(groupIdArr).map(groupId -> "?").collect(Collectors.joining(","));
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` in (select `obj_id` from tb_base_group_bind where `group_id` in(")).append(inPlaceholder).append("))  ");
      param.addAll((Collection)Arrays.<String>stream(groupIdArr).collect(Collectors.toList()));
    } 
    String removeHost = sysParamUtil.getPara("remove_host");
    if (StringKit.notBlank(removeHost)) {
      String[] removeHostArr = removeHost.split(",");
      String inPlaceholder = Arrays.<String>stream(removeHostArr).map(hostId -> "?").collect(Collectors.joining(","));
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" and host.`id` NOT IN (SELECT `id` FROM tb_base_host WHERE `id` in(") + inPlaceholder + ")) ");
      param.addAll((Collection)Arrays.<String>stream(removeHostArr).collect(Collectors.toList()));
    } 
    String sort = sysParamUtil.getPara("sort");
    String order = sysParamUtil.getPara("order", " desc ");
    String unreg_page = sysParamUtil.getPara("unreg_page");
    if (StringKit.notBlank(sort)) {
      sortBuffer.append(sort).append(" ").append(order).append(DbDialectUtil.getDbRuleFactory().dbField(" ,`feature` desc "));
    } else if ("1".equals(isCheckFeature)) {
      sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" `feature` desc "));
    } else {
      if (unreg_page != null) {
        if ("1".equals(unreg_page))
          sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" `unreg_date` ")); 
      } else {
        sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" `reg_date` "));
      } 
      sortBuffer.append(order);
      sortBuffer.append(DbDialectUtil.getDbRuleFactory().dbField(" ,`feature` desc "));
    } 
    where.append(" )");
    String additHost = sysParamUtil.getPara("addit_host");
    if (StringKit.notBlank(additHost)) {
      String[] additHostArr = additHost.split(",");
      String inPlaceholder = Arrays.<String>stream(additHostArr).map(addid -> "?").collect(Collectors.joining(","));
      where.append(DbDialectUtil.getDbRuleFactory().dbField(" OR host.`id`  IN (SELECT `id` FROM tb_base_host WHERE `id` in(")).append(inPlaceholder).append(")) ");
      param.addAll((Collection)Arrays.<String>stream(additHostArr).collect(Collectors.toList()));
    } 
    Map<String, Object> result = new HashMap<>(3);
    result.put("where", where.toString());
    result.put("sort", sortBuffer.toString());
    result.put("param", param);
    return result;
  }
  
  public static Record getHostInfoForRpc(String hostId) {
    return DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select host.`id`, host.`name`, host.`user_id`, u.`name` as `user_name`, host.`install_code`, host.`install_state`, host.`sec_level`, host.`reg_date`, org.`name` as `orga_name`, org.`id` as `org_id`, host.`code`, host.`last_modify_date`, host.`remark`, host.`type`,host.`room_num`, org.`region` as `region`, host.`fixed_no`, host.`eq_use` from tb_base_host host left join tb_base_user u on host.`user_id`=u.`id` left join tb_base_org org on org.`id`=u.`org_id` where  host.`id`= ? limit 1"), new Object[] { hostId });
  }
  
  public static Record getHostVersionForRpc(String hostId, int installState) {
    Record hostInfoVersion = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host_version where `host_id`=? and `type`=1 limit 1"), new Object[] { hostId });
    if (hostInfoVersion == null && installState != 5)
      hostInfoVersion = createHostVersion(hostId, "1", 2); 
    return hostInfoVersion;
  }
  
  public static List<String> getAllNormalHostIpList() {
    return DbUtil.queryByCache(DbDialectUtil.getDbRuleFactory().dbField("select ip from tb_base_host where install_state  < ?"), new Object[] { Integer.valueOf(4) });
  }
  
  public static Record getHostInfoByFeatureAndIpAndSn(String feature, String ip, String sn) {
    return DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select * from tb_base_host where `install_state`=2 and `feature`=?  and `ip`=?  and  `sn` =? limit 1 "), new Object[] { feature, ip, sn });
  }
  
  public static String getZJGDeviceId() {
    String url = YqPropertiesUtil.me().getProperty("zjg_deviceId_url");
    ZFHttpClient client = new ZFHttpClient(100, 100, 120000, 120000);
    String deviceId = "";
    try {
      String responseData = client.get(url);
      if (StrUtil.isNotEmpty(responseData)) {
        JSONObject obj = JsonUtils.toJSONObject(responseData);
        deviceId = obj.getString("data");
      } 
    } catch (Exception e) {
      e.printStackTrace();
      logger.error("未拉取到ZJG设备ID，请检查相关配置！", e);
    } 
    return deviceId;
  }
  
  public static List<String> getExitInstallCode(String installCodeStr) {
    List<String> installCodes = Arrays.asList(installCodeStr.split(","));
    List<String> installCodeLists = Lists.newArrayList();
    installCodes.forEach(installCode -> installCodeLists.add(installCode.trim()));
    List<String> exitinstallCodes = Lists.newArrayList();
    int batchSize = BaseGlobal.BATCH_SIZE.intValue();
    int interval = installCodeLists.isEmpty() ? 0 : ((installCodeLists.size() % batchSize == 0) ? (installCodeLists.size() / batchSize) : (installCodeLists.size() / batchSize + 1));
    for (int i = 0; i < interval; i++) {
      List<String> idList = (List<String>)installCodeLists.stream().skip((i * batchSize)).limit(batchSize).collect(Collectors.toList());
      String inPlaceholder = idList.stream().map(installCode -> "?").collect(Collectors.joining(","));
      List<String> exitinstallCodesTem = DbUtil.query(DbDialectUtil.getDbRuleFactory().dbField("select `install_code` from tb_base_host   where `install_code` in (" + inPlaceholder + ")"), idList.toArray());
      exitinstallCodes.addAll(exitinstallCodesTem);
    } 
    return exitinstallCodes;
  }
  
  public static List<HostAuthVo> getHostAuthInfo(Map<String, Object> bodyToMap) {
    String searchType = JSONUtil.toJsonStr(bodyToMap.get("search_type"));
    List<String> valueList = JsonUtils.toList(bodyToMap.get("value_list"), String.class);
    String sql = DbDialectUtil.getDbRuleFactory().dbField("SELECT `id`, `name`, `ip`, `mac`, `sn`, `user_id` from tb_base_host ");
    sql = DbUtil.getSingleStatmentInSqlParam(valueList, searchType, new StringBuilder(sql)).toString();
    List<Record> result = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField(sql + " and `install_state` < 4 "), valueList.toArray());
    if (ObjectUtil.isEmpty(result))
      return Collections.emptyList(); 
    Map<String, HostAuthVo> map = new HashMap<>();
    List<String> ids = new ArrayList<>();
    result.forEach(item -> {
          HostAuthVo hostAuthVo = new HostAuthVo();
          String id = item.getStr("id");
          ids.add(id);
          hostAuthVo.setId(id);
          hostAuthVo.setName(item.getStr("name"));
          hostAuthVo.setIp(item.getStr("ip"));
          hostAuthVo.setMac(item.getStr("mac"));
          hostAuthVo.setSn(item.getStr("sn"));
          hostAuthVo.setUser_id(item.getStr("user_id"));
          map.put(id, hostAuthVo);
        });
    String proSql = DbDialectUtil.getDbRuleFactory().dbField("SELECT `host_id`, `product_id` from tb_base_host_product_auth ");
    proSql = DbUtil.getSingleStatmentInSqlParam(ids, "host_id", new StringBuilder(proSql)).toString();
    List<Record> proResult = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField(proSql), ids.toArray());
    if (ObjectUtil.isEmpty(proResult))
      return new ArrayList<>(map.values()); 
    proResult.forEach(item -> {
          String id = item.getStr("host_id");
          HostAuthVo hostAuthVo = (HostAuthVo)map.get(id);
          List<String> productList = hostAuthVo.getProduct_list();
          productList.add(item.getStr("product_id"));
          hostAuthVo.setProduct_list(productList);
        });
    return new ArrayList<>(map.values());
  }
  
  public static void reloadActivateHostIdCatch(boolean showChildNodeData) {
    BusinessThreadPoolFactory.getThreadPool("host.hostIdCatch").submit(() -> {
          try {
            logger.info("-------------加载已激活主机id并保存到redis 开始-------------");
            RedisClient.getJedis().del("ITX:CACHE:ACTIVATE_HOST_ID_SET");
            RedisClient.getJedis().del("ITX:CACHE:ACTIVE_HST_PKG_CODE");
            List<Object> param = new ArrayList();
            String querySql = "select `id`,`install_code` from tb_base_host where `install_state` in (?,?,?) ";
            param.add(Integer.valueOf(2));
            param.add(Integer.valueOf(3));
            param.add(Integer.valueOf(5));
            if (!showChildNodeData) {
              querySql = querySql + "and `node_id` = ?";
              param.add(BaseGlobal.getCurrentNodeId());
            } 
            List<Record> recordList = DbUtil.find(DbDialectUtil.getDbRuleFactory().dbField(querySql), param.toArray());
            if (CollUtil.isNotEmpty(recordList)) {
              String[] activateHostIds = (String[])recordList.stream().map(()).toArray(());
              Map<String, String> hostIdInstallCodeMap = (Map<String, String>)recordList.stream().collect(Collectors.toMap((), ()));
              RedisClient.getJedis().sadd("ITX:CACHE:ACTIVATE_HOST_ID_SET", activateHostIds);
              RedisClient.getJedis().hmset("ITX:CACHE:ACTIVE_HST_PKG_CODE", hostIdInstallCodeMap);
            } 
            logger.info("-------------加载已激活主机id数量" + recordList.size() + " 保存到redis 完成-------------");
          } catch (Exception e) {
            logger.error("【已激活主机id缓存】加载已激活主机id并保存到redis缓存：", e);
          } 
        });
  }
  
  public static void addHostIdCatch(String hostId) {
    BusinessThreadPoolFactory.getThreadPool("host.hostIdCatch").submit(() -> {
          try {
            Record host = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select `install_state`,`install_code` from tb_base_host where `id` =? "), new Object[] { hostId });
            int installState = host.getInt("install_state").intValue();
            String installCode = host.getStr("install_code");
            if (installState == 2 || installState == 3) {
              RedisClient.getJedis().sadd("ITX:CACHE:ACTIVATE_HOST_ID_SET", new String[] { hostId });
              RedisClient.getJedis().hset("ITX:CACHE:ACTIVE_HST_PKG_CODE", hostId, installCode);
              logger.info("【已激活主机id缓存】主机id：{} 添加到已激活主机id缓存完成", new String[] { hostId });
            } 
          } catch (Exception e) {
            logger.error("【已激活主机id缓存】主机id添加到已激活主机id缓存异常：", e);
          } 
        });
  }
  
  public static void removeHostIdCatch(String hostId) {
    BusinessThreadPoolFactory.getThreadPool("host.hostIdCatch").submit(() -> {
          try {
            Record host = DbUtil.findFirst(DbDialectUtil.getDbRuleFactory().dbField("select `install_state` from tb_base_host where `id` =? "), new Object[] { hostId });
            int installState = host.getInt("install_state").intValue();
            if (installState == 4 || installState == 5) {
              RedisClient.getJedis().srem("ITX:CACHE:ACTIVATE_HOST_ID_SET", new String[] { hostId });
              RedisClient.getJedis().delKeyToMap("ITX:CACHE:ACTIVE_HST_PKG_CODE", hostId);
              logger.info("【已激活主机id缓存】主机id：{} 从到已激活主机id缓存移除完成", new String[] { hostId });
            } 
          } catch (Exception e) {
            logger.error("【已激活主机id缓存】主机id从到已激活主机id缓存移除异常：", e);
          } 
        });
  }
}
